/***************************************************************************
                          KConfig.h  -  description
                             -------------------
    begin                : Tue Mar 14 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KCONFIG_H
#define KCONFIG_H

#include <Foundation/NSObject.h>

#include <qtobjc/QFile.h>
#include <kdeobjc/KConfigBase.h>

/**
  *@author Richard Dale
  */

/**
* KDE Configuration entries
*
* This class implements KDE's default-based configuration system.
*
* Derived from the C++ header 'kconfig.h'
* by Kalle Dalheimer (kalle@kde.org)
* @see -[KApplication getConfig] KConfigBase KSimpleConfig
* @short KDE Configuration Management  class
*/
@interface KConfig : KConfigBase

  /** Open all appropriate configuration files and pass them on to
	* -parseOneConfigFile
	*/
- parseConfigFiles;

  /** Write back the configuration data.
	*/
- (BOOL) writeConfigFile: (QFile *) rFile global: (BOOL) bGlobal;

  /**
	* Initialize a KConfig object.
	*
	* @param pGlobalAppFile A file to parse in addition to the
	*  normally parsed files.
	* @param pLocalAppFile Another file to parse in addition to the
	* normally parsed files (has priority over pGlobalAppFile
	*/
- initFromGlobalFile: (NSString *) pGlobalAppFile localFile: (NSString *) pLocalAppFile;

  /**
	*
	* Writes back any dirty configuration entries.
	*/
- (void) dealloc;

  /**
	* Write back the config cache.
	*/
- sync;

@end

#endif
