/***************************************************************************
                          QApplication.h  -  description
                             -------------------
    begin                : Fri Mar 3 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QAPPLICATION_H
#define QAPPLICATION_H

#include <Foundation/NSObject.h>
#include <Foundation/NSArray.h>


#include <qtobjc/qwindowdefs.h>
#include <qtobjc/QObject.h>
#include <qtobjc/QLabel.h>
#include <qtobjc/QClipboard.h>

/**
  *@author Richard Dale
  */

@interface QApplication :  QObject

/**
  * Instantiate a QApplication with the command line args
  */
- initWithArgc: (int) argc argv: (char **) argv;

#if defined(_WS_X11_)
- initWithDisplay: (Display *) dpy;
#endif

/**
  * A handle to the sole instance of QApplication
  */
+ qApp;

- (int) argc;
- (char **) argv;

+ (GUIStyle) style;
+ setStyle: (GUIStyle) style;

+ (int) colorSpec;
+ setColorSpec: (int) spec;

+ (QCursor *) overrideCursor;
+ setOverrideCursor: (QCursor *) cursor replace: (BOOL) yn;
+ restoreOverrideCursor;

+ (BOOL) hasGlobalMouseTracking;
+ setGlobalMouseTracking: (BOOL) enable;

+ (QPalette *) palette;
+ setPalette: (QPalette *) palette updateAllWidgets: (BOOL) yn;

+ font;
+ setFont: (QFont *) font;
+ setFont: (QFont *) font updateAllWidgets: (BOOL) yn;
+ (QFontMetrics *) fontMetrics;

- (QWidget *) mainWidget;
- setMainWidget: (QWidget *) widget;

+ (NSArray *) allWidgets;
+ (NSArray *) topLevelWidgets;
+ (QWidget *) desktop;
+ (QWidget *) activePopupWidget;
+ (QWidget *) activeModalWidget;
+ (QClipboard *) clipboard;

- (QWidget *) focusWidget;

+ (QWidget *) widgetAt: (int) x : (int) y child: (BOOL) yn;
+ (QWidget *) widgetAt: (QPoint *) point child: (BOOL) yn;

- exec;
- processEvents;
- processEvents: (int) maxtime;
- processOneEvent;
- (int) enterLoop;
- exitLoop;
+ exit: (int) retcode;

+ (BOOL)	sendEvent: (QObject *) receiver event: (QEvent *) event;
+ postEvent: (QObject *) receiver event: (QEvent *) event;
+ sendPostedEvents: (QObject *) receiver eventType: (int) eventType;

- (BOOL) notify: (QObject *) receiver event: (QEvent *) event;

+ (BOOL)	startingUp;
+ (BOOL)	closingDown;

+ flushX;
+ syncX;

+ beep;

+ setWinStyleHighlightColor: (QColor *) color;
+ (QColor *) winStyleHighlightColor;

+ setDoubleClickInterval: (int) interval;
+ (int) doubleClickInterval;

- quit;


@end

#endif