/***************************************************************************
                          QAsyncIO.h  -  description
                             -------------------
    begin                : Sun Mar 12 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QASYNCIO_H
#define QASYNCIO_H

#include <Foundation/NSObject.h>

#include <qtobjc/QObject.h>

/**
  *@author Richard Dale
  */

@class QIODevice;

@interface QAsyncIO : NSObject <QtSupport>
{
@private
	void *	_qt;
}

- connect: (QObject *) sender slot: (NSString *) member;
- ready;
@end

@interface  QDataSink : QAsyncIO
- (int) readyToReceive;
- receive: (void *) data count: (int) count;
- eof;
- maybeReady;
@end

@interface  QDataSource : QAsyncIO
- readyToSend;
- sendTo: (QDataSink *) receiver count: (int) count;
- maybeReady;
- (BOOL) rewindable;
- enableRewind: (BOOL) on;
- rewind;
@end

@interface  QIODeviceSource : QDataSource
- init: (QIODevice *) device bufferSize: (int) bufsize;

- (int) readyToSend;
- sendTo: (QDataSink *) sink count: (int) n;
- (BOOL) rewindable;
- enableRewind: (BOOL) on;
- rewind;
@end

@interface  QDataPump : QObject
- initFromDataSource: (QDataSource *) dataSource sink: (QDataSink *) sink;
@end

#endif
