/***************************************************************************
                          QButton.m  -  description
                             -------------------
    begin                : Mon Mar 20 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QButton.h>
#include <qtc/qtc.h>

@implementation QButton

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QButton([parent qt], (char *) [name cString])];
	return self;
}


- (void) dealloc
{
	(void) qt_del_QButton([self qt]);
	[super dealloc];
	return;
}



- (NSString *) text
{
	return (NSString *) [NSString initWithCString: qt_QButton_text([self qt])];
}


- setText: (NSString *) text
{
	qt_QButton_setText([self qt], (char *) [text cString]);
	return self;
}


- (QPixmap *) pixmap
{
	return (QPixmap *) [QObject objectForQtKey: (void *) qt_QButton_pixmap([self qt])];
}


- setPixmap: (QPixmap *) pixmap
{
	qt_QButton_setPixmap([self qt], [pixmap qt]);
	return self;
}


- (int) accel
{
	return (int) qt_QButton_accel([self qt]);
}


- setAccel: (int) accel
{
	qt_QButton_setAccel([self qt], accel);
	return self;
}


- (BOOL) isToggleButton
{
	return (BOOL) qt_QButton_isToggleButton([self qt]);
}


- setDown: (BOOL) yn
{
//	qt_QButton_setDown([self qt], yn);
	return self;
}


- (BOOL) isDown
{
	return (BOOL) qt_QButton_isDown([self qt]);
}


- (BOOL) isOn
{
	return (BOOL) qt_QButton_isOn([self qt]);
}


- (BOOL) autoResize
{
	return (BOOL) qt_QButton_autoResize([self qt]);
}


- setAutoResize: (BOOL) yn
{
	qt_QButton_setAutoResize([self qt], yn);
	return self;
}


- (BOOL) autoRepeat
{
	return (BOOL) qt_QButton_autoRepeat([self qt]);
}


- setAutoRepeat: (BOOL) yn
{
	qt_QButton_setAutoRepeat([self qt], yn);
	return self;
}


- animateClick
{
	qt_QButton_animateClick([self qt]);
	return self;
}


- toggle
{
//	qt_QButton_toggle([self qt]);
	return self;
}


- pressed: sender
{
//	qt_QButton_pressed([self qt]);
	return self;
}


- released: sender
{
//	qt_QButton_released([self qt]);
	return self;
}


- clicked: sender
{
//	qt_QButton_clicked([self qt]);
	return self;
}


- toggled: sender
{
//	qt_QButton_toggled([self qt]);
	return self;
}

@end

