/***************************************************************************
                          QButtonGroup.m  -  description
                             -------------------
    begin                : Fri Apr 14 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QButtonGroup.h>
#include <qtobjc/QButton.h>
#include <qtc/qtc.h>

@implementation QButtonGroup
- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QButtonGroup([parent qt], (char *) [name cString])];	
	return self;
}


- initWithTitle: (NSString *) title parent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QButtonGroup1((char *) [title cString], [parent qt], (char *) [name cString])];	
	return self;
}


- (void) dealloc
{
	qt_del_QButtonGroup([self qt]);	
	[super dealloc];	
	return;
}


- (BOOL) isExclusive
{
	return (BOOL) qt_QButtonGroup_isExclusive([self qt]);
}


- setExclusive: (BOOL) yn
{
	qt_QButtonGroup_setExclusive([self qt], yn);
	return self;
}


- (int) insert: (QButton *) button identifier: (int) identifier
{
	return (int) qt_QButtonGroup_insert([self qt], [button qt], identifier);
}


- remove: (QButton *) button
{
	qt_QButtonGroup_remove([self qt], [button qt]);
	return self;
}


- (QButton *) find: (int) identifier
{
	return (QButton *) [QObject objectForQtKey: qt_QButtonGroup_find([self qt], identifier)];
}

@end

