/***************************************************************************
                          QColor.h  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QCOLOR_H
#define QCOLOR_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QObject.h>

/**
  *@author Richard Dale
  */

@class QColor;
@class QWidget;

@interface QColor : NSObject <QtSupport>
{
@private
	void *	_qt;
}

- init;
- init: (int) r : (int) g : (int) b;
- init: (int) x : (int) y : (int) z spec: (int) spec;
- init: (int) rgb pixel: (uint) pixel;
- initWithName: (NSString *) name;

- (BOOL) isValid;
- (BOOL) isDirty;
- setNamedColor: (NSString *) name;
- rgb: (int *) r : (int *) g : (int *) b;
- (int) rgb;
- setRgb: (int) r : (int) g : (int) b;
- setRgb: (int) rgb;
- (int) red;
- (int) green;
- (int) blue;
- hsv: (int *) h : (int *) s : (int *) v;
- setHsv: (int) h : (int) s : (int) v;
- light: (int) f;
- dark: (int) f;

+ (BOOL) lazyAlloc;
+  setLazyAlloc: (BOOL) yn;

- (uint) alloc;
- (uint) pixel;
+ (int)  maxColors;
+ (int)  numBitPlanes;
+ (int)  enterAllocContext;
+  leaveAllocContext;
+ (int)  currentAllocContext;
+  destroyAllocContext: (int) context;
+  (void) initialize;
+  cleanup;


+ (QColor *) color0;
+ (QColor *) color1;
+ (QColor *) black;
+ (QColor *) white;
+ (QColor *) darkGray;
+ (QColor *) gray;
+ (QColor *) lightGray;
+ (QColor *) red;
+ (QColor *) green;
+ (QColor *) blue;
+ (QColor *) cyan;
+ (QColor *) magenta;
+ (QColor *) yellow;
+ (QColor *) darkRed;
+ (QColor *) darkGreen;
+ (QColor *) darkBlue;
+ (QColor *) darkCyan;
+ (QColor *) darkMagenta;
+ (QColor *) darkYellow;

@end

#endif
