/***************************************************************************
                          QColor.m  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QColor.h>

#include <qtc/qtc.h>

@implementation QColor

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- init
{
	[super init];
	return self;
}


- init: (int) r : (int) g : (int) b
{
	[self setQt: qt_new_QColor1(r, g, b)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- init: (int) x : (int) y : (int) z spec: (int) spec
{
	[self setQt: qt_new_QColor2(x, y, z, spec)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- init: (int) rgb pixel: (uint) pixel
{
	[self setQt: qt_new_QColor3(rgb, pixel)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- initWithName: (NSString *) name
{
	[self setQt: qt_new_QColor4((char *) [name cString])];
	[QObject setObject: self forQtKey: [self qt]];
	return self;	
}


- copyWithZone: (NSZone *) zone
{
	id	aCopy;
	
	aCopy = [[[self class] alloc] init];
	[aCopy setQt: qt_new_QColor5([self qt])];
	[QObject setObject: aCopy forQtKey: [aCopy qt]];
	return aCopy;	
}

- (void) dealloc
{
	[QObject removeQtKey: [self qt]];
	qt_del_QColor([self qt]);
	[super dealloc];
	return;
}

- (BOOL) isValid
{
	return (BOOL) qt_QColor_isValid([self qt]);
}


- (BOOL) isDirty
{
	return (BOOL) qt_QColor_isDirty([self qt]);
}


- setNamedColor: (NSString *) name
{
	qt_QColor_setNamedColor([self qt], (char *) [name cString]);
	return self;
}


- rgb: (int *) r : (int *) g : (int *) b
{
	qt_QColor_rgb([self qt], (int) r, (int) g, (int) b);
	return self;
}


- (int) rgb
{
	return (int) qt_QColor_rgb1([self qt]);
}


- setRgb: (int) r : (int) g : (int) b
{
	qt_QColor_setRgb([self qt], r, g, b);
	return self;
}


- setRgb: (int) rgb
{
	qt_QColor_setRgb1([self qt], rgb);
	return self;
}


- (int) red
{
	return (int) qt_QColor_red([self qt]);
}


- (int) green
{
	return (int) qt_QColor_green([self qt]);
}


- (int) blue
{
	return (int) qt_QColor_blue([self qt]);
}


- hsv: (int *) h : (int *) s : (int *) v
{
	qt_QColor_hsv([self qt], (int) h, (int) s, (int) v);
	return self;
}


- setHsv: (int) h : (int) s : (int) v
{
	qt_QColor_setHsv([self qt], h, s, v);
	return self;
}


- light: (int) f
{
	qt_QColor_light([self qt], f);
	return self;
}


- dark: (int) f
{
	qt_QColor_dark([self qt], f);
	return self;
}



+ (BOOL) lazyAlloc
{
	return (BOOL) qt_QColor_lazyAlloc();
}


+ setLazyAlloc: (BOOL) yn
{
	qt_QColor_setLazyAlloc(yn);
	return self;
}



- (uint) alloc
{
	return (uint) qt_QColor_alloc([self qt]);
}


- (uint) pixel
{
	return (uint) qt_QColor_pixel([self qt]);
}


+ (int)  maxColors
{
	return (int) qt_QColor_maxColors();
}


+ (int)  numBitPlanes
{
	return (int) qt_QColor_numBitPlanes();
}


+ (int)  enterAllocContext
{
	return (int) qt_QColor_enterAllocContext();
}


+ leaveAllocContext
{
	qt_QColor_leaveAllocContext();
	return self;
}


+ (int)  currentAllocContext
{
	return (int) qt_QColor_currentAllocContext();
}


+ destroyAllocContext: (int) context
{
	qt_QColor_destroyAllocContext(context);
	return self;
}


+ (void) initialize
{
	qt_QColor_initialize();
	return;
}


+ cleanup
{
	qt_QColor_cleanup();
	return self;
}

+ (QColor *) color0
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_color0()];
	}
	
	return color;
}

+ (QColor *) color1
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_color1()];
	}
	
	return color;
}

+ (QColor *) black
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_black()];
	}
	
	return color;
}

+ (QColor *) white
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_white()];
	}
	
	return color;
}

+ (QColor *) darkGray
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_darkGray()];
	}
	
	return color;
}

+ (QColor *) gray
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_gray()];
	}
	
	return color;
}

+ (QColor *) lightGray
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_lightGray()];
	}
	
	return color;
}

+ (QColor *) red
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_red()];
	}
	
	return color;
}

+ (QColor *) green
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_green()];
	}
	
	return color;
}

+ (QColor *) blue
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_blue()];
	}
	
	return color;
}

+ (QColor *) cyan
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_cyan()];
	}
	
	return color;
}

+ (QColor *) magenta
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_magenta()];
	}
	
	return color;
}

+ (QColor *) yellow
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_yellow()];
	}
	
	return color;
}

+ (QColor *) darkRed
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_darkRed()];
	}
	
	return color;
}

+ (QColor *) darkGreen
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_darkGreen()];
	}
	
	return color;
}

+ (QColor *) darkBlue
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_darkBlue()];
	}
	
	return color;
}

+ (QColor *) darkCyan
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_darkCyan()];
	}
	
	return color;
}

+ (QColor *) darkMagenta
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_darkMagenta()];
	}
	
	return color;
}

+ (QColor *) darkYellow
{
static QColor *	color = nil;
	
	if (color == nil) {
		color = [[QColor alloc] init];
		[color setQt: qt_QColor_constant_darkYellow()];
	}
	
	return color;
}

@end

