/***************************************************************************
                          QComboBox.h  -  description
                             -------------------
    begin                : Sat Apr 1 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QCOMBOBOX_H
#define QCOMBOBOX_H

#include <Foundation/NSObject.h>
#include <qtobjc/QWidget.h>

/**
  *@author Richard Dale
  */

@interface QComboBox : QWidget
- initWithParent: (QWidget *) parent name: (NSString *) name;
- initWithWindowType: (BOOL) rw parent: (QWidget *) parent name: (NSString *) name;
- (void) dealloc;
- (int) count;
- insertTextItem: (NSString *) text;
- insertTextItem: (NSString *) text index: (int) index;
- insertPixmapItem: (QPixmap *) pixmap;
- insertPixmapItem: (QPixmap *) pixmap index: (int) index;
- removeItem: (int) index;
- clear;
- (NSString *) currentText;
- (NSString *) text: (int) index;
- (QPixmap *) pixmap: (int) index;
- changeTextItem: (NSString *) text index: (int) index;
- changePixmapItem: (QPixmap *) pixmap index: (int) index;
- (int) currentItem;
- setCurrentItem: (int) index;
- (BOOL) autoResize;
- setAutoResize: (BOOL) yn;
- (QSize *) sizeHint;
- setBackgroundColor: (QColor *) color;
- setPalette: (QPalette *) palette;
- setFont: (QFont *) font;
- setEnabled: (BOOL) yn;
- setSizeLimit: (int) limit;
- (int) sizeLimit;
- setMaxCount: (int) count;
- (int) maxCount;
@end

#endif
