/***************************************************************************
                          QComboBox.m  -  description
                             -------------------
    begin                : Sat Apr 1 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QComboBox.h>
#include <qtobjc/QPixmap.h>

#include <qtc/qtc.h>

@implementation QComboBox
- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QComboBox([parent qt], (char *) [name cString])];	
	return self;
}


- initWithWindowType: (BOOL) rw parent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QComboBox1(rw, [parent qt], (char *) [name cString])];	
	return self;
}


- (void) dealloc
{
	qt_del_QComboBox([self qt]);	
	[super dealloc];	
	return;
}


- (int) count
{
	return (int) qt_QComboBox_count([self qt]);
}

- insertTextItem: (NSString *) text
{
	return [self insertTextItem: text index: -1];
}


- insertTextItem: (NSString *) text index: (int) index
{
	qt_QComboBox_insertItem([self qt], (char *) [text cString], index);
	return self;
}


- insertPixmapItem: (QPixmap *) pixmap
{
	return [self insertPixmapItem: pixmap index: -1];
}


- insertPixmapItem: (QPixmap *) pixmap index: (int) index
{
	qt_QComboBox_insertItem1([self qt], [pixmap qt], index);
	return self;
}


- removeItem: (int) index
{
	qt_QComboBox_removeItem([self qt], index);
	return self;
}


- clear
{
	qt_QComboBox_clear([self qt]);
	return self;
}


- (NSString *) currentText
{
	return (NSString *) [NSString stringWithCString: qt_QComboBox_currentText([self qt])];
}


- (NSString *) text: (int) index
{
	return (NSString *) [NSString stringWithCString: qt_QComboBox_text([self qt], index)];
}


- (QPixmap *) pixmap: (int) index
{
	return (QPixmap *) [QObject objectForQtKey: qt_QComboBox_pixmap([self qt], index) withClass: [QPixmap class]];
}


- changeTextItem: (NSString *) text
{
	return [self changeTextItem: text index: -1];
}

- changeTextItem: (NSString *) text index: (int) index
{
	qt_QComboBox_changeItem([self qt], (char *) [text cString], index);
	return self;
}


- changePixmapItem: (QPixmap *) pixmap
{
	return [self changePixmapItem: pixmap index: -1];
}


- changePixmapItem: (QPixmap *) pixmap index: (int) index
{
	qt_QComboBox_changeItem1([self qt], [pixmap qt], index);
	return self;
}


- (int) currentItem
{
	return (int) qt_QComboBox_currentItem([self qt]);
}


- setCurrentItem: (int) index
{
	qt_QComboBox_setCurrentItem([self qt], index);
	return self;
}


- (BOOL) autoResize
{
	return (BOOL) qt_QComboBox_autoResize([self qt]);
}


- setAutoResize: (BOOL) yn
{
	qt_QComboBox_setAutoResize([self qt], yn);
	return self;
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: qt_QComboBox_sizeHint([self qt]) withClass: [QSize class]];
}


- setBackgroundColor: (QColor *) color
{
	qt_QComboBox_setBackgroundColor([self qt], [color qt]);
	return self;
}


- setPalette: (QPalette *) palette
{
	qt_QComboBox_setPalette([self qt], [palette qt]);
	return self;
}


- setFont: (QFont *) font
{
	qt_QComboBox_setFont([self qt], [font qt]);
	return self;
}


- setEnabled: (BOOL) yn
{
	qt_QComboBox_setEnabled([self qt], yn);
	return self;
}


- setSizeLimit: (int) limit
{
	qt_QComboBox_setSizeLimit([self qt], limit);
	return self;
}


- (int) sizeLimit
{
	return (int) qt_QComboBox_sizeLimit([self qt]);
}


- setMaxCount: (int) count
{
	qt_QComboBox_setMaxCount([self qt], count);
	return self;
}


- (int) maxCount
{
	return (int) qt_QComboBox_maxCount([self qt]);
}

@end

