/***************************************************************************
                          QCursor.m  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QCursor.h>
#include <qtc/qtc.h>

@implementation QCursor

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- init
{
	[self setQt: qt_new_QCursor()];	
	return self;
}

					
- init: (int) shape
{
	[self setQt: qt_new_QCursor1(shape)];	
	return self;
}


- initFromBitmap: (QBitmap *) bitmap mask: (QBitmap *) mask hotX: (int) hotX hotY: (int) hotY
{
	[self setQt: qt_new_QCursor2([(<QtSupport>) bitmap qt], [(<QtSupport>)mask qt], hotX, hotY)];	
	return self;
}


- (void) dealloc
{
	qt_del_QCursor([self qt]);	
	[super dealloc];	
	return;
}


- (int) shape
{
	return (int) qt_QCursor_shape([self qt]);
}


- setShape: (int) shape
{
	qt_QCursor_setShape([self qt], shape);
	return self;
}


- (QBitmap *) bitmap
{
	return (QBitmap *) [QObject objectForQtKey: qt_QCursor_bitmap([self qt])];
}


- (QBitmap *) mask
{
	return (QBitmap *) [QObject objectForQtKey: qt_QCursor_mask([self qt])];
}


- (QPoint *) hotSpot
{
	return (QPoint *) [QObject objectForQtKey: qt_QCursor_hotSpot([self qt]) withClass: [QPoint class]];
}


- (HANDLE) handle
{
	return (HANDLE) qt_QCursor_handle([self qt]);
}



+ (QPoint *) pos
{
	return (QPoint *) [QObject objectForQtKey: qt_QCursor_pos() withClass: [QPoint class]];
}


+ setPos: (int) x : (int) y
{
	qt_QCursor_setPos(x, y);
	return self;
}


+ setPos: (QPoint *) point
{
	qt_QCursor_setPos1([point qt]);
	return self;
}


+ initialize
{
//	[self setQt: qt_new_QCursor()];	
	return self;
}


+ cleanup
{
	qt_QCursor_cleanup([self qt]);
	return self;
}

@end

