/***************************************************************************
                          QDialog.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QDialog.h>
#include <qtc/qtc.h>

@implementation QDialog
- initWithParent: (QWidget *) parent name: (NSString *)name modal: (BOOL) modal flags: (WFlags) f
{
	[self setQt: qt_new_QDialog([parent qt], (char *) [name cString], modal, f)];	
	return self;
}


- (void) dealloc
{
	qt_del_QDialog([self qt]);	
	[super dealloc];	
	return;
}



- (int) exec
{
	return (int) qt_QDialog_exec([self qt]);
}


- show
{
	qt_QDialog_show([self qt]);
	return self;
}

- (int) result
{
	return qt_QDialog_result([self qt]);
}


- move: (int) x : (int) y
{
	qt_QDialog_move([self qt], x, y);
	return self;
}


- move: (QPoint *) p
{
	qt_QDialog_move1([self qt], [p qt]);
	return self;
}


- resize: (int) w : (int) h
{
	qt_QDialog_resize([self qt], w, h);
	return self;
}


- resize: (QSize *) size
{
	qt_QDialog_resize1([self qt], [size qt]);
	return self;
}


- setGeometry: (int) x : (int) y : (int) w : (int) h
{
	qt_QDialog_setGeometry([self qt], x, y, w, h);
	return self;
}


- setGeometry: (QRect *) rect
{
	qt_QDialog_setGeometry1([self qt], [rect qt]);
	return self;
}

@end

