/***************************************************************************
                          QEvent.m  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QEvent.h>
#include <qtobjc/QObject.h>
#include <qtc/qtc.h>

@implementation QEvent

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- initFromType: (int) type
{
	[self setQt: qt_new_QEvent(type)];	
	return self;
}


- (void) dealloc
{
//	qt_del_QEvent([self qt]);	
	[super dealloc];	
	return;
}


- (int) type
{
	return (int) qt_QEvent_type([self qt]);
}

@end

@implementation QTimerEvent

- initFromTimerId: (int) timerId
{
	[self setQt: qt_new_QTimerEvent(timerId)];	
	return self;
}


- (void) dealloc
{
//	qt_del_QTimerEvent([self qt]);	
	[super dealloc];	
	return;
}


- (int) timerId
{
	return (int) qt_QTimerEvent_timerId([self qt]);
}


@end

@implementation QMouseEvent

- initFromType: (int) type position: (QPoint *) pos button: (int) button state: (int) state
{
	[self setQt: qt_new_QMouseEvent(type, [pos qt], button, state)];	
	return self;
}


- initFromType: (int) type position: (QPoint *) pos globalPosition: globalPos button: (int) button state: (int) state
{
//	[self setQt: qt_new_QMouseEvent1(type, [pos qt], globalPos, button, state)];	
	return self;
}



- (QPoint *) pos
{
	return (QPoint *) [QObject objectForQtKey: qt_QMouseEvent_pos([self qt]) withClass: [QPoint class]];
}


- (QPoint *) globalPos
{
//	return (QPoint *) [QObject objectForQtKey: qt_QMouseEvent_globalPos([self qt])];
	return nil;
}


- (int) x
{
	return (int) qt_QMouseEvent_x([self qt]);
}


- (int) y
{
	return (int) qt_QMouseEvent_y([self qt]);
}


- (int) globalX
{
//	return (int) qt_QMouseEvent_globalX([self qt]);
	return 0;
}


- (int) globalY
{
//	return (int) qt_QMouseEvent_globalY([self qt]);
	return 0;
}


- (int) button
{
	return (int) qt_QMouseEvent_button([self qt]);
}


- (int) state
{
	return (int) qt_QMouseEvent_state([self qt]);
}


@end


@implementation QKeyEvent
- initFromType: (int) type key: (int) key ascii: (int) ascii state: (int) state
{
	[self setQt: qt_new_QKeyEvent(type, key, ascii, state)];	
	return self;
}


- dealloc
{
//	qt_QKeyEvent_dealloc([self qt]);
	[super dealloc];
	return self;
}



- (int) key
{
	return (int) qt_QKeyEvent_key([self qt]);
}


- (int) ascii
{
	return (int) qt_QKeyEvent_ascii([self qt]);
}


- (int) state
{
	return (int) qt_QKeyEvent_state([self qt]);
}


- (BOOL) isAccepted
{
	return (BOOL) qt_QKeyEvent_isAccepted([self qt]);
}


- accept
{
	qt_QKeyEvent_accept([self qt]);
	return self;
}


- ignore
{
	qt_QKeyEvent_ignore([self qt]);
	return self;
}

@end

@implementation QFocusEvent

- initFromFocusType: (int) focusType
{
	[self setQt: qt_new_QFocusEvent(focusType)];	
	return self;
}


- (BOOL) gotFocus
{
	return (BOOL) qt_QFocusEvent_gotFocus([self qt]);
}


- (BOOL) lostFocus
{
	return (BOOL) qt_QFocusEvent_lostFocus([self qt]);
}


@end

@implementation QPaintEvent

- initFromRect: (QRect *) rect
{
	[self setQt: qt_new_QPaintEvent([rect qt])];	
	return self;
}


- (QRect *) rect
{
	return (QRect *) [QObject objectForQtKey: qt_QPaintEvent_rect([self qt]) withClass: [QRect class]];
}


@end

@implementation QMoveEvent

- initFromPosition: (QPoint *) position oldPosition: (QPoint *) oldPosition
{
	[self setQt: qt_new_QMoveEvent([position qt], [oldPosition qt])];	
	return self;
}


- (QPoint *) position
{
	return (QPoint *) [QObject objectForQtKey: qt_QMoveEvent_pos([self qt]) withClass: [QPoint class]];
}


- (QPoint *) oldPosition
{
	return (QPoint *) [QObject objectForQtKey: qt_QMoveEvent_oldPos([self qt]) withClass: [QPoint class]];
}


@end

@implementation QResizeEvent

- initFromSize: (QSize *) size oldSize: (QSize *) oldSize
{
	[self setQt: qt_new_QResizeEvent([size qt], [oldSize qt])];	
	return self;
}


- (QSize *) size
{
	return (QSize *) [QObject objectForQtKey: qt_QResizeEvent_size([self qt]) withClass: [QSize class]];
}


- (QSize *) oldSize
{
	return (QSize *) [QObject objectForQtKey: qt_QResizeEvent_oldSize([self qt]) withClass: [QSize class]];
}

@end

@implementation QCloseEvent

- init
{
	[self setQt: qt_new_QCloseEvent()];	
	return self;
}


- (BOOL) isAccepted
{
	return (BOOL) qt_QCloseEvent_isAccepted([self qt]);
}


- accept
{
	qt_QCloseEvent_accept([self qt]);
	return self;
}


- ignore
{
	qt_QCloseEvent_ignore([self qt]);
	return self;
}

@end

