/***************************************************************************
                          QFile.h  -  description
                             -------------------
    begin                : Thu Mar 16 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QFILE_H
#define QFILE_H

#include <stdio.h>

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QIODevice.h>

/**
  *@author Richard Dale
  */

@interface QFile : QIODevice
- init;
- initWithName: (NSString *) name;
- (void) dealloc;

- (NSString *) name;
- setName: (NSString *) name;
- (BOOL) exists;
+ (BOOL) exists: (NSString *) fileName;
- (BOOL) remove;
+ (BOOL) remove: (NSString *) fileName;
- (BOOL) open: (int) mode;
- (BOOL) open: (int) mode handle: (FILE *) file;
- (BOOL) open: (int) mode descriptor: (int) descriptor;
- close;
- flush;
- (uint) size;
- (int) at;
- (BOOL) at: (int) offset;
- (BOOL) atEnd;
- (int) readBlock: (char *) data length: (uint) len;
- (int) writeBlock: (const char *) data length: (uint) len;
- (int) readLine: (char *) data maxLength: (uint) maxlen;
- (int) getch;
- (int) putch: (int) ch;
- (int) ungetch: (int) ch;
- (int) handle;
@end

#endif
