/***************************************************************************
                          QFile.m  -  description
                             -------------------
    begin                : Thu Mar 16 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QFile.h>

#include <qtc/qtc.h>

@implementation QFile

- init
{
	[self setQt: qt_new_QFile()];
	return self;
}


- initWithName: (NSString *) name
{
	[self setQt: qt_new_QFile([name cString])];
	return self;
}


- (void) dealloc
{
	(void) qt_del_QFile([self qt]);
	[super dealloc];
	return;
}



- (NSString *) name
{
	return (NSString *) [NSString initWithCString: qt_QFile_name([self qt])];
}


- setName: (NSString *) name
{
	qt_QFile_setName([self qt], (char *) [name cString]);
	return self;
}


- (BOOL) exists
{
	return (BOOL) qt_QFile_exists([self qt]);
}


+ (BOOL) exists: (NSString *) fileName
{
	return (BOOL) qt_QFile_exists1((char *) [fileName cString]);
}


- (BOOL) remove
{
//	return (BOOL) qt_QFile_remove([self qt]);
	return NO;
}


+ (BOOL) remove: (NSString *) fileName
{
//	return (BOOL) qt_QFile_remove((char *) [fileName cString]);
	return NO;
}


- (BOOL) open: (int) mode
{
	return (BOOL) qt_QFile_open([self qt], mode);
}


- (BOOL) open: (int) mode handle: (FILE *) file
{
	return (BOOL) qt_QFile_open1([self qt], mode, file);
}


- (BOOL) open: (int) mode descriptor: (int) descriptor
{
	return (BOOL) qt_QFile_open2([self qt], mode, descriptor);
}


- close
{
	qt_QFile_close([self qt]);
	return self;
}


- flush
{
	qt_QFile_flush([self qt]);
	return self;
}


- (uint) size
{
	return (uint) qt_QFile_size([self qt]);
}


- (int) at
{
	return (int) qt_QFile_at([self qt]);
}


- (BOOL) at: (int) offset
{
	return (BOOL) qt_QFile_at1([self qt], offset);
}


- (BOOL) atEnd
{
	return (BOOL) qt_QFile_atEnd([self qt]);
}


- (int) readBlock: (char *) data length: (uint) len
{
	return (int) qt_QFile_readBlock([self qt], data, len);
}


- (int) writeBlock: (const char *) data length: (uint) len
{
	return (int) qt_QFile_writeBlock([self qt], (char *) data, len);
}


- (int) readLine: (char *) data maxLength: (uint) maxlen
{
	return (int) qt_QFile_readLine([self qt], data, maxlen);
}


- (int) getch
{
	return (int) qt_QFile_getch([self qt]);
}


- (int) putch: (int) ch
{
	return (int) qt_QFile_putch([self qt], ch);
}


- (int) ungetch: (int) ch
{
	return (int) qt_QFile_ungetch([self qt], ch);
}


- (int) handle
{
	return (int) qt_QFile_handle([self qt]);
}

@end

