/***************************************************************************
                          QFileDialog.h  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QFILEDIALOG_H
#define QFILEDIALOG_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <Foundation/NSArray.h>

#include <qtobjc/QDialog.h>


#define Mode				int
#define AnyFile			0
#define ExistingFile		1
#define Directory			2
#define ExistingFiles		3

/**
  *@author Richard Dale
  */

@interface QFileIconProvider : QObject
@end

@interface QFileDialog : QDialog
- initWithDirectory: (NSString *) dirName filter: (NSString *) filter parent: (QWidget *) parent name: (NSString *)name modal: (BOOL) modal;
- initWithParent: (QWidget *) parent name: (NSString *) name modal: (BOOL) modal;
- (void) dealloc;

+ (NSString *) getOpenFileName: (NSString *) initially filter: (NSString *) filter parent: (QWidget *) parent;
+ (NSString *) getOpenFileName: (NSString *) initially filter: (NSString *) filter parent: (QWidget *) parent name: (NSString *) name;
+ (NSString *) getSaveFileName: (NSString *) initially filter: (NSString *) filter parent: (QWidget *) parent;
+ (NSString *) getSaveFileName: (NSString *) initially filter: (NSString *) filter parent: (QWidget *) parent name: (NSString *) name;
+ (NSString *) getExistingDirectory: (NSString *) dir parent: (QWidget *) parent name: (NSString *) name;
+ (NSArray *) getOpenFileNames: (NSString *) filter directory: (NSString *) dir parent: (QWidget *) parent name: (NSString *) name;
+  setIconProvider: (QFileIconProvider *) QFileIconProvider;
+ (QFileIconProvider *) iconProvider;
- (NSString *) selectedFile;
- setSelection: (NSString *) selection;
- (NSString *) dirPath;
- setDir: (NSString *) dir;
- (NSString *) dir;
- rereadDir;
- setMode: (Mode) mode;
- (Mode) mode;
- (BOOL) eventFilter: (QObject *) receiver event: (QEvent *) event;
@end

#endif
