/***************************************************************************
                          QFont.h  -  description
                             -------------------
    begin                : Sat Mar 11 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QFONT_H
#define QFONT_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/qwindowdefs.h>
#include <qtobjc/QObject.h>

//	StyleHint
#define Helvetica					0
#define Times					1
#define Courier					2
#define OldEnglish				3
#define System					4
#define AnyStyle					5
#define SansSerif					Helvetica
#define Serif					Times
#define TypeWriter				Courier
#define Decorative				OldEnglish

//	Weight
#define Light					25
#define Normal					50
#define DemiBold					63
#define Bold						75
#define Black					87

//	CharSet
#define Latin1					0
#define ISO_8859_1				Latin1
#define AnyCharSet				1
#define Latin2					2
#define ISO_8859_2				Latin2
#define Latin3					3
#define ISO_8859_3				Latin3
#define Latin4					4
#define ISO_8859_4				Latin4
#define Latin5					5
#define ISO_8859_5				Latin5
#define Latin6					6
#define ISO_8859_6				Latin6
#define Latin7					7
#define ISO_8859_7				Latin7
#define Latin8					8
#define ISO_8859_8				Latin8
#define Latin9					9
#define ISO_8859_9				Latin9
#define KOI8R 					10

/**
  *@author Richard Dale
  */

@interface QFont : NSObject <QtSupport>
{
@private
	void *	_qt;
}

+ (void) initialize;

- init;					
- initWithFamily: (NSString *) family pointSize: (int) pointSize;
- initWithFamily: (NSString *) family pointSize: (int) pointSize weight: (int) weight italic: (BOOL) yn;
- initWithFamily: (NSString *) family pointSize: (int) pointSize weight: (int) weight italic: (BOOL) yn charset: (int) charSet;
- (void) dealloc;

- (NSString *) family;
- setFamily: (NSString *) family;
- (int) pointSize;
- setPointSize: (int) size;
- (int) weight;
- setWeight: (int) weight;
- (BOOL) bold;
- setBold: (BOOL) yn;
- (BOOL) italic;
- setItalic: (BOOL) yn;
- (BOOL) underline;
- setUnderline: (BOOL) yn;
- (BOOL) strikeOut;
- setStrikeOut: (BOOL) yn;
- (BOOL) fixedPitch;
- setFixedPitch: (BOOL) yn;
- (int) styleHint;
- setStyleHint: (int) hint;
- (int) charSet;
- setCharSet: (int) charSet;
- (BOOL) rawMode;
- setRawMode: (BOOL) yn;
- (BOOL) exactMatch;
- (HANDLE) handle: (HANDLE) handle;
- (NSString *) key;

+ (QFont *) defaultFont;
+  setDefaultFont: (QFont *) font;
+ (NSString *) substitute: (NSString *) familyName;
+  insertSubstitution: (NSString *) familyName replacementName: (NSString *) replacementName;
+  removeSubstitution: (NSString *) familyName;
+  listSubstitutions: (NSArray *) list;
+  cleanup;
+  cacheStatistics;

@end

#endif
