/***************************************************************************
                          QFont.m  -  description
                             -------------------
    begin                : Sat Mar 11 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QFont.h>
#include <qtc/qtc.h>

@implementation QFont

+ (void) initialize
{
	qt_QFont_initialize();
	return;
}

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- init
{
	[self setQt: qt_new_QFont()];	
	return self;
}

					
- initWithFamily: (NSString *) family pointSize: (int) pointSize
{
	[self initWithFamily: family pointSize: pointSize weight: Normal italic: NO];	
	return self;
}


- initWithFamily: (NSString *) family pointSize: (int) pointSize weight: (int) weight italic: (BOOL) yn
{
	[self setQt: qt_new_QFont1((char *) [family cString], pointSize, weight, yn)];	
	return self;
}


- initWithFamily: (NSString *) family pointSize: (int) pointSize weight: (int) weight italic: (BOOL) yn charset: (int) charSet
{
	[self setQt: qt_new_QFont2((char *) [family cString], pointSize, weight, yn, charSet)];	
	return self;
}

- copyWithZone: (NSZone *) zone
{
	id	aCopy;
	
	aCopy = [[[self class] alloc] init];
	[aCopy setQt: qt_new_QFont3([self qt])];
	[QObject setObject: aCopy forQtKey: [aCopy qt]];
	return aCopy;	
}


- (void) dealloc
{
	qt_del_QFont([self qt]);	
	[super dealloc];	
	return;
}



- (NSString *) family
{
	return (NSString *) [NSString stringWithCString: qt_QFont_family([self qt])];
}


- setFamily: (NSString *) family
{
	qt_QFont_setFamily([self qt], (char *) [family cString]);
	return self;
}


- (int) pointSize
{
	return (int) qt_QFont_pointSize([self qt]);
}


- setPointSize: (int) size
{
	qt_QFont_setPointSize([self qt], size);
	return self;
}


- (int) weight
{
	return (int) qt_QFont_weight([self qt]);
}


- setWeight: (int) weight
{
	qt_QFont_setWeight([self qt], weight);
	return self;
}


- (BOOL) bold
{
	return (BOOL) qt_QFont_bold([self qt]);
}


- setBold: (BOOL) yn
{
	qt_QFont_setBold([self qt], yn);
	return self;
}


- (BOOL) italic
{
	return (BOOL) qt_QFont_italic([self qt]);
}


- setItalic: (BOOL) yn
{
	qt_QFont_setItalic([self qt], yn);
	return self;
}


- (BOOL) underline
{
	return (BOOL) qt_QFont_underline([self qt]);
}


- setUnderline: (BOOL) yn
{
	qt_QFont_setUnderline([self qt], yn);
	return self;
}


- (BOOL) strikeOut
{
	return (BOOL) qt_QFont_strikeOut([self qt]);
}


- setStrikeOut: (BOOL) yn
{
	qt_QFont_setStrikeOut([self qt], yn);
	return self;
}


- (BOOL) fixedPitch
{
	return (BOOL) qt_QFont_fixedPitch([self qt]);
}


- setFixedPitch: (BOOL) yn
{
	qt_QFont_setFixedPitch([self qt], yn);
	return self;
}


- (int) styleHint
{
	return (int) qt_QFont_styleHint([self qt]);
}


- setStyleHint: (int) hint
{
	qt_QFont_setStyleHint([self qt], hint);
	return self;
}


- (int) charSet
{
	return (int) qt_QFont_charSet([self qt]);
}


- setCharSet: (int) charSet
{
	qt_QFont_setCharSet([self qt], charSet);
	return self;
}


- (BOOL) rawMode
{
	return (BOOL) qt_QFont_rawMode([self qt]);
}


- setRawMode: (BOOL) yn
{
	qt_QFont_setRawMode([self qt], yn);
	return self;
}


- (BOOL) exactMatch
{
	return (BOOL) qt_QFont_exactMatch([self qt]);
}



- (HANDLE) handle: (HANDLE) handle
{
	return (HANDLE) qt_QFont_handle([self qt], (unsigned int) handle);
}


- (NSString *) key
{
	return (NSString *) [NSString stringWithCString: qt_QString_data(qt_QFont_key([self qt]))];
}



+ (QFont *) defaultFont
{
	return (QFont *) [QObject objectForQtKey: qt_QFont_defaultFont([self qt]) withClass: [QFont class]];
}


+ setDefaultFont: (QFont *) font
{
	qt_QFont_setDefaultFont([font qt]);
	return self;
}


+ (NSString *) substitute: (NSString *) familyName
{
	return (NSString *) [NSString stringWithCString: qt_QFont_substitute((char *) [familyName cString])];
}


+ insertSubstitution: (NSString *) familyName replacementName: (NSString *) replacementName
{
	qt_QFont_insertSubstitution((char *) [familyName cString], (char *) [replacementName cString]);
	return self;
}


+ removeSubstitution: (NSString *) familyName
{
	qt_QFont_removeSubstitution((char *) [familyName cString]);
	return self;
}


+ listSubstitutions: (NSArray *) list
{
//	qt_QFont_listSubstitutions();
	return self;
}

+ cleanup
{
	qt_QFont_cleanup();
	return self;
}


+ cacheStatistics
{
	qt_QFont_cacheStatistics();
	return self;
}

@end

