/***************************************************************************
                          QFontMetrics.h  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QFONTMETRICS_H
#define QFONTMETRICS_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>
#include <Foundation/NSArray.h>

#include <qtobjc/QFont.h>
#include <qtobjc/QRect.h>

/**
  *@author Richard Dale
  */

@class QFontMetrics;

@interface QFontMetrics : NSObject <QtSupport>
- init: (QFont *) font;
- initWithFontMetrics: (QFontMetrics *) fontMetrics;
- (void) dealloc;

- (int) ascent;
- (int) descent;
- (int) height;
- (int) leading;
- (int) lineSpacing;
- (int) minLeftBearing;
- (int) minRightBearing;
- (int) maxWidth;
- (BOOL) inFont: (char) ch;
- (int) leftBearing: (char) ch;
- (int) rightBearing: (char) ch;
- (int) width: (NSString *) name length: (int) length;
- (int) width: (char) ch;

- (QRect *) boundingRect: (NSString *) name length: (int) len;
- (QRect *) boundingRect: (char) ch;
- (QRect *) boundingRect: (int) x : (int) y : (int) w : (int) h
	flags: (int) flags text: (NSString *) str length: (int) len
	tabstops: (int) tabstops tabArray: (NSArray *) tabArray;

- (int) underlinePos;
- (int) strikeOutPos;
- (int) lineWidth;
@end

#endif
