/***************************************************************************
                          QFrame.m  -  description
                             -------------------
    begin                : Fri Mar 3 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <Foundation/NSString.h>

#include <qtobjc/QFrame.h>
#include <qtc/qtc.h>

@implementation QFrame

- initWithParent: (QWidget *) parent name: (NSString *) name flag: (WFlags) f allowLines: (BOOL) allowLines
{
	[self setQt: qt_new_QFrame([parent qt], (char *) [name cString], f, allowLines)];
	[super init];
	return self;
}


- (int) frameStyle
{
	return (int) qt_QFrame_frameStyle([self qt]);
}


- (int) frameShape
{
	return (int) qt_QFrame_frameShape([self qt]);
}


- (int) frameShadow
{
	return (int) qt_QFrame_frameShadow([self qt]);
}


- setFrameStyle: (int) style
{
	qt_QFrame_setFrameStyle([self qt], style);
	return self;
}


- (BOOL) lineShapesOk
{
	return (BOOL) qt_QFrame_lineShapesOk([self qt]);
}


- (int) lineWidth
{
	return (int) qt_QFrame_lineWidth([self qt]);
}


- setLineWidth: (int) width
{
	qt_QFrame_setLineWidth([self qt], width);
	return self;
}


- (int) margin
{
//	return (int) qt_QFrame_margin([self qt]);
	return 0;
}


- setMargin: (int) margin
{
//	qt_QFrame_setMargin([self qt], margin);
	return self;
}


- (int) midLineWidth
{
	return (int) qt_QFrame_midLineWidth([self qt]);
}


- setMidLineWidth: (int) width
{
	qt_QFrame_setMidLineWidth([self qt], width);
	return self;
}


- (int) frameWidth
{
	return (int) qt_QFrame_frameWidth([self qt]);
}


- (QRect *) frameRect
{
	return (QRect *) [QObject objectForQtKey: (void *) qt_QFrame_frameRect([self qt]) withClass: [QRect class]];
}


- (QRect *) contentsRect
{
	return (QRect *) [QObject objectForQtKey: (void *) qt_QFrame_contentsRect([self qt]) withClass: [QRect class]];
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: (void *) qt_QFrame_sizeHint([self qt]) withClass: [QSize class]];
}

@end
