/***************************************************************************
                          QIODevice.h  -  description
                             -------------------
    begin                : Sun Mar 12 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QIODEVICE_H
#define QIODEVICE_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QObject.h>
/**
  *@author Richard Dale
  */

@interface QIODevice : NSObject <QtSupport>
- init;
- (void) dealloc;


- (int) flags;
- (int) mode;
- (int) state;

- (BOOL) isDirectAccess;
- (BOOL) isSequentialAccess;
- (BOOL) isCombinedAccess;
- (BOOL) isBuffered;
- (BOOL) isRaw;
- (BOOL) isSynchronous;
- (BOOL) isAsynchronous;
- (BOOL) isTranslated;
- (BOOL) isReadable;
- (BOOL) isWritable;
- (BOOL) isReadWrite;
- (BOOL) isInactive;
- (BOOL) isOpen;


- (int) status;
- (void) resetStatus;

- (BOOL) open: (int) mode;
- (void) close;
- (void) flush;

- (uint) size;
- (int) at;
- (BOOL) at: (int) position;
- (BOOL) atEnd;

- (int) readBlock: (NSString *) data length: (uint) len;
- (int) writeBlock: (NSString *) data length: (uint) len;
- (int) readLine: (NSString *) data maxlen: (uint) maxlen;

- (int) getch;
- (int) putch: (int) ch;
- (int) ungetch: (int) ch;

- setFlags: (int) flags;
- setType: (int) type;
- setMode: (int) mode;
- setState: (int) state;
- setStatus: (int) status;

@end

#endif
