/***************************************************************************
                          QIconSet.h  -  description
                             -------------------
    begin                : Tue Apr 4 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QICONSET_H
#define QICONSET_H

#include <Foundation/NSObject.h>

#include <qtobjc/QPixmap.h>

#define Size			int
#define Automatic		0
#define Small		1
#define Large		2

#undef Normal

#define Mode 		int
#define Normal		0
#define Disabled		1
#define Active		2

/**
  *@author Richard Dale
  */

@interface QIconSet : NSObject <QtSupport>
{
@private
	void *	_qt;
}

- initWithPixmap: (QPixmap *) defaultPixmap defaultSize: (Size) size;
- (void) dealloc;
- reset: (QPixmap *) pixmap size: (Size) size;
- setPixmap: (QPixmap *) pixmap size: (Size) size mode: (Mode) mode;
- setPixmapWithFilename: (NSString *) filename size: (Size) size mode: (Mode) mode;
- (QPixmap *) pixmap: pixmap size: (Size) size mode: (Mode) mode;
- (QPixmap *) pixmap;
- (BOOL) isGenerated: (Size) size mode: (Mode) mode;
- detach;
@end

#endif
