/***************************************************************************
                          QIconSet.m  -  description
                             -------------------
    begin                : Tue Apr 4 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QIconSet.h>

#undef Normal

#include <qtc/qtc.h>

@implementation QIconSet

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- initWithPixmap: (QPixmap *) defaultPixmap defaultSize: (Size) size
{
	[self setQt: qt_new_QIconSet([defaultPixmap qt], size)];
	[super init];	
	return self;
}

- copyWithZone: (NSZone *) zone
{
	id	aCopy;
	
	aCopy = [[[self class] alloc] init];
	[aCopy setQt: qt_new_QIconSet1([self qt])];
	[QObject setObject: aCopy forQtKey: [aCopy qt]];
	return aCopy;	
}


- (void) dealloc
{
	qt_del_QIconSet([self qt]);	
	[super dealloc];	
	return;
}


- reset: (QPixmap *) pixmap size: (Size) size
{
	qt_QIconSet_reset([self qt], [pixmap qt], size);
	return self;
}


- setPixmap: (QPixmap *) pixmap size: (Size) size mode: (Mode) mode
{
	qt_QIconSet_setPixmap([self qt], [pixmap qt], size, mode);
	return self;
}


- setPixmapWithFilename: (NSString *) filename size: (Size) size mode: (Mode) mode
{
	qt_QIconSet_setPixmap1([self qt], (char *) [filename cString], size, mode);
	return self;
}


- (QPixmap *) pixmap: pixmap size: (Size) size mode: (Mode) mode
{
	return (QPixmap *) [QObject objectForQtKey: qt_QIconSet_pixmap([self qt], size, mode) withClass: [QPixmap class]];
}


- (QPixmap *) pixmap
{
	return (QPixmap *) [QObject objectForQtKey: qt_QIconSet_pixmap1([self qt]) withClass: [QPixmap class]];
}


- (BOOL) isGenerated: (Size) size mode: (Mode) mode
{
	return (BOOL) qt_QIconSet_isGenerated([self qt], size, mode);
}


- detach
{
	qt_QIconSet_detach([self qt]);
	return self;
}

@end

