/***************************************************************************
                          QLCDNumber.h  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QLCDNUMBER_H
#define QLCDNUMBER_H

#include <Foundation/NSObject.h>

#include <qtobjc/QFrame.h>
#include <qtobjc/QWidget.h>
#include <qtobjc/QSize.h>
#include <qtobjc/QRect.h>

#define Mode 		int
#define HEX			0
#define DEC			1
#define OCT			2
#define BIN			3

#define SegmentStyle 		int
#define Outline			0
#define Filled			1
#define Flat				2

/**
  *@author Richard Dale
  */

@interface QLCDNumber : QFrame
- initWithParent: (QWidget *) parent name: (NSString *) name;
- initWithDigits: (uint) numDigits parent: (QWidget *) parent;
- initWithDigits: (uint) numDigits parent: (QWidget *) parent name: (NSString *) name;
- (void) dealloc;
- (BOOL) smallDecimalPoint;
- (int) numDigits;
- setNumDigits: (int) nDigits;
- (BOOL) checkDoubleOverflow: (double) num;
- (BOOL) checkIntOverflow: (int) num;
- (Mode) mode;
- setMode: (Mode) mode;
- (SegmentStyle) segmentStyle;
- setSegmentStyle: (SegmentStyle) style;
- (double) value;
- (int) intValue;
- (QSize *) sizeHint;
- displayInt: (int) num;
- displayDouble: (double) num;
- displayString: (NSString *) str;
- setHexMode;
- setDecMode;
- setOctMode;
- setBinMode;
- setSmallDecimalPoint: (BOOL) yn;
@end

#endif
