/***************************************************************************
                          QLCDNumber.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QLCDNumber.h>
#include <qtc/qtc.h>

@implementation QLCDNumber

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QLCDNumber([parent qt], (char *) [name cString])];	
	return self;
}


- initWithDigits: (uint) numDigits parent: (QWidget *) parent
{
	return [self initWithDigits: numDigits parent: parent name: @""];
}


- initWithDigits: (uint) numDigits parent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QLCDNumber1(numDigits, [parent qt], (char *) [name cString])];	
	return self;
}


- (void) dealloc
{
	qt_del_QLCDNumber([self qt]);	
	[super dealloc];	
	return;
}


- (BOOL) smallDecimalPoint
{
	return (BOOL) qt_QLCDNumber_smallDecimalPoint([self qt]);
}


- (int) numDigits
{
	return (int) qt_QLCDNumber_numDigits([self qt]);
}


- setNumDigits: (int) nDigits
{
	qt_QLCDNumber_setNumDigits([self qt], nDigits);
	return self;
}


- (BOOL) checkDoubleOverflow: (double) num
{
	return (BOOL) qt_QLCDNumber_checkOverflow([self qt], num);
}


- (BOOL) checkIntOverflow: (int) num
{
	return (BOOL) qt_QLCDNumber_checkOverflow1([self qt], num);
}


- (Mode) mode
{
	return (Mode) qt_QLCDNumber_mode([self qt]);
}


- setMode: (Mode) mode
{
	qt_QLCDNumber_setMode([self qt], mode);
	return self;
}


- (SegmentStyle) segmentStyle
{
	return (SegmentStyle) qt_QLCDNumber_segmentStyle([self qt]);
}


- setSegmentStyle: (SegmentStyle) style
{
	qt_QLCDNumber_setSegmentStyle([self qt], style);
	return self;
}


- (double) value
{
	return (double) qt_QLCDNumber_value([self qt]);
}


- (int) intValue
{
	return (int) qt_QLCDNumber_intValue([self qt]);
}


- (QSize *) sizeHint
{
//	return (QSize *) [QObject objectForQtKey: qt_QLCDNumber_sizeHint([self qt])];
	return nil;
}


- displayInt: (int) num
{
	qt_QLCDNumber_display([self qt], num);
	return self;
}


- displayDouble: (double) num
{
	qt_QLCDNumber_display1([self qt], num);
	return self;
}


- displayString: (NSString *) str
{
	qt_QLCDNumber_display2([self qt], (char *) [str cString]);
	return self;
}


- setHexMode
{
	qt_QLCDNumber_setHexMode([self qt]);
	return self;
}


- setDecMode
{
	qt_QLCDNumber_setDecMode([self qt]);
	return self;
}


- setOctMode
{
	qt_QLCDNumber_setOctMode([self qt]);
	return self;
}


- setBinMode
{
	qt_QLCDNumber_setBinMode([self qt]);
	return self;
}


- setSmallDecimalPoint: (BOOL) yn
{
	qt_QLCDNumber_setSmallDecimalPoint([self qt], yn);
	return self;
}

@end

