/***************************************************************************
                          QLabel.h  -  description
                             -------------------
    begin                : Fri Mar 3 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QLABEL_H
#define QLABEL_H

#include <Foundation/NSString.h>

#include <qtobjc/qwindowdefs.h>
#include <qtobjc/QFrame.h>
#include <qtobjc/QMovie.h>
#include <qtobjc/QWidget.h>
#include <qtobjc/QPixmap.h>
#include <qtobjc/QPainter.h>
#include <qtobjc/QSize.h>

/**
  *@author Richard Dale
  */

@interface QLabel :  QFrame

- initWithText: (NSString *) name;
- initWithText: (NSString *) name parent: (QWidget *) parent;
- initWithText: (NSString *) aString parent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f;

- initWithParent: (QWidget *) parent name: (NSString *) name;
- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f;
- initWithBuddy: (QWidget *) buddy text: (NSString *) text parent: (QWidget *) parent name: (NSString*) name flags: (WFlags) f;

- (void) dealloc;

- (NSString *) text;
- (QPixmap *) pixmap;
- (QMovie *) movie;

- (int) alignment;
- setAlignment: (int) alignment;
- (int) margin;
- setMargin: (int) margin;


- (BOOL) autoResize;
- setAutoResize: (BOOL) yn;
- (QSize *) sizeHint;

- setBuddy: (QWidget *) buddy;
- (QWidget *) buddy;

/*
 * Slots
 */
- setText: (NSString *) text;
- setPixmap: (QPixmap *) pixmap;
- setMovie: (QMovie *) movie;
- setIntValue: (int) num;
- setDoubleValue: (double) num;
- clear;

- drawContents: (QPainter *) painter;

@end

#endif
