/***************************************************************************
                          QLabel.m  -  description
                             -------------------
    begin                : Fri Mar 3 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <Foundation/NSString.h>

#include <qtobjc/QLabel.h>
#include <qtc/qtc.h>

@implementation QLabel

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[super init];
	[self setQt: (void *) qt_new_QLabel([parent qt], (char *) [name cString], 0)];
	return self;
}

- initWithText: (NSString *) name
{
	[super init];
	[self setQt: (void *) qt_new_QLabel1((char *) [name cString], (void *) NULL, (char *) NULL, 0)];
	return self;
}

- initWithText: (NSString *) aString parent: (QWidget *) parent
{
	[super init];
	[self setQt: (void *) qt_new_QLabel1((char *) [aString cString], [parent qt], (char *) NULL, 0)];
	return self;
}

- initWithText: (NSString *) aString parent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f
{
	[super init];
	[self setQt: (void *) qt_new_QLabel1((char *) [aString cString], [parent qt], (char *) [name cString], f)];
	return self;
}

- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f
{
	[super init];
	[self setQt: (void *) qt_new_QLabel([parent qt], (char *) [name cString], f)];
	return self;
}

- initWithBuddy: (QWidget *) buddy text: (NSString *) text parent: (QWidget *) parent name: (NSString*) name flags: (WFlags) f
{
	[super init];
	[self setQt: (void *) qt_new_QLabel2([buddy qt], (char *) [text cString], [parent qt], (char *) [name cString], f)];
	return self;
}

- (void) dealloc
{
	qt_del_QLabel([self qt]);
	[super dealloc];
	return;
}



- (NSString *) text
{
	return (NSString *) [NSString stringWithCString: qt_QLabel_text([self qt])];
}


- (QPixmap *) pixmap
{
	return (QPixmap *) [QObject objectForQtKey: (void *) qt_QLabel_pixmap([self qt])];
}


- (QMovie *) movie
{
	return (QMovie *) [QObject objectForQtKey: (void *) qt_QLabel_movie([self qt])];
}



- (int) alignment
{
	return (int) qt_QLabel_alignment([self qt]);
}


- setAlignment: (int) alignment
{
	qt_QLabel_setAlignment([self qt], alignment);
	return self;
}


- (int) margin
{
	return (int) qt_QLabel_margin([self qt]);
}


- setMargin: (int) margin
{
	qt_QLabel_setMargin([self qt], margin);
	return self;
}




- (BOOL) autoResize
{
	return (BOOL) qt_QLabel_autoResize([self qt]);
}


- setAutoResize: (BOOL) yn
{
	qt_QLabel_setAutoResize([self qt], yn);
	return self;
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: (void *) qt_QLabel_sizeHint([self qt])];
}



- setBuddy: (QWidget *) buddy
{
	qt_QLabel_setBuddy([self qt], [buddy qt]);
	return self;
}


- (QWidget *) buddy
{
	return (QWidget *) [QObject objectForQtKey: (void *) qt_QLabel_buddy([self qt])];
}



/*
 * Slots
 */
- setText: (NSString *) text
{
	qt_QLabel_setText([self qt], (char *) [text cString]);
	return self;
}


- setPixmap: (QPixmap *) pixmap
{
	qt_QLabel_setPixmap([self qt], [pixmap qt]);
	return self;
}


- setMovie: (QMovie *) movie
{
	qt_QLabel_setMovie([self qt], [movie qt]);
	return self;
}


- setIntValue: (int) num
{
	qt_QLabel_setNum([self qt], num);
	return self;
}


- setDoubleValue: (double) num
{
	qt_QLabel_setNum1([self qt], num);
	return self;
}


- clear
{
//	qt_QLabel_clear([self qt]);
	return self;
}



- drawContents: (QPainter *) painter
{
//	qt_QLabel_drawContents([self qt], [qpainter qt]);
	return self;
}

@end
