/***************************************************************************
                          QLineEdit.h  -  description
                             -------------------
    begin                : Fri Apr 14 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QLINEEDIT_H
#define QLINEEDIT_H

#include <Foundation/NSObject.h>
#include "QWidget.h"

#undef Normal

#define EchoMode			int
#define Normal			0
#define NoEcho			1
#define Password			2

@class QValidator;

/**
  *@author Richard Dale
  */

@interface QLineEdit : QWidget
- initWithParent: (QWidget *) parent name: (NSString *) name;
- (void) dealloc;
- (NSString *) text;
- (int) maxLength;
- setMaxLength: (int) length;
- setFrame: (BOOL) yn;
- (BOOL) frame;
- setEchoMode: (EchoMode) mode;
- (EchoMode) echoMode;
- setValidator: (QValidator *) validator;
- (QValidator *) validator;
- (QSize *) sizeHint;
- setEnabled: (BOOL) yn;
- setFont: (QFont *) font;
- setPalette: (QPalette *) palette;
- setSelectionFrom: (int) from to: (int) to;
- setCursorPosition: (int) position;
- (int) cursorPosition;
- (BOOL) validateAndSet: (NSString *) text newPosition: (int) newPos newMarkAnchor: (int) anchor newMarkDrag: (int) newDrag;
- cut;
- copy;
- paste;
- setText: (NSString *) text;
- selectAll;
- deselect;
- clearValidator;
@end

#endif
