/***************************************************************************
                          QLineEdit.m  -  description
                             -------------------
    begin                : Fri Apr 14 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QLineEdit.h>
#include <qtobjc/QValidator.h>

#undef Normal
#include <qtc/qtc.h>

@implementation QLineEdit

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QLineEdit([parent qt], (char *) name)];	
	return self;
}


- (void) dealloc
{
	qt_del_QLineEdit([self qt]);	
	[super dealloc];	
	return;
}


- (NSString *) text
{
	return (NSString *) [NSString stringWithCString: qt_QLineEdit_text([self qt])];
}


- (int) maxLength
{
	return (int) qt_QLineEdit_maxLength([self qt]);
}


- setMaxLength: (int) length
{
	qt_QLineEdit_setMaxLength([self qt], length);
	return self;
}


- setFrame: (BOOL) yn
{
	qt_QLineEdit_setFrame([self qt], yn);
	return self;
}


- (BOOL) frame
{
	return (BOOL) qt_QLineEdit_frame([self qt]);
}


- setEchoMode: (EchoMode) mode
{
	qt_QLineEdit_setEchoMode([self qt], mode);
	return self;
}


- (EchoMode) echoMode
{
	return (EchoMode) qt_QLineEdit_echoMode([self qt]);
}


- setValidator: (QValidator *) validator
{
	qt_QLineEdit_setValidator([self qt], [validator qt]);
	return self;
}


- (QValidator *) validator
{
	return (QValidator *) [QObject objectForQtKey: qt_QLineEdit_validator([self qt])];
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: qt_QLineEdit_sizeHint([self qt]) withClass: [QSize class]];
}


- setEnabled: (BOOL) yn
{
//	qt_QLineEdit_setEnabled([self qt], yn);
	return self;
}


- setFont: (QFont *) font
{
//	qt_QLineEdit_setFont([self qt], [font qt]);
	return self;
}


- setPalette: (QPalette *) palette
{
//	qt_QLineEdit_setPalette([self qt], [palette qt]);
	return self;
}


- setSelectionFrom: (int) from to: (int) to
{
//	qt_QLineEdit_setSelection([self qt], from, to);
	return self;
}


- setCursorPosition: (int) position
{
	qt_QLineEdit_setCursorPosition([self qt], position);
	return self;
}


- (int) cursorPosition
{
//	return (int) qt_QLineEdit_cursorPosition([self qt]);
	return 0;
}


- (BOOL) validateAndSet: (NSString *) text newPosition: (int) newPos newMarkAnchor: (int) anchor newMarkDrag: (int) newDrag
{
//	return (BOOL) qt_QLineEdit_validateAndSet([self qt], (char *) [text cString], newPos, anchor, newDrag);
	return NO;
}


- cut
{
	qt_QLineEdit_cut([self qt]);
	return self;
}


- copy
{
	qt_QLineEdit_copy([self qt]);
	return self;
}


- paste
{
	qt_QLineEdit_paste([self qt]);
	return self;
}


- setText: (NSString *) text
{
	qt_QLineEdit_setText([self qt], (char *) [text cString]);
	return self;
}


- selectAll
{
	qt_QLineEdit_selectAll([self qt]);
	return self;
}


- deselect
{
	qt_QLineEdit_deselect([self qt]);
	return self;
}


- clearValidator
{
	qt_QLineEdit_clearValidator([self qt]);
	return self;
}

@end

