/***************************************************************************
                          QListBox.h  -  description
                             -------------------
    begin                : Sat Apr 1 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QLISTBOX_H
#define QLISTBOX_H

#include <Foundation/NSObject.h>
#include <qtobjc/QTableView.h>

@class QListBox;

/**
  *@author Richard Dale
  */

@interface QListBoxItem : NSObject <QtSupport>
{
@private
	void *	_qt;
}
- (NSString *) text;
- (QPixmap *) pixmap;
- (int) height: (QListBox *) listBox;
- (int) width: (QListBox *) listBox;
@end

@interface QListBoxText : QListBoxItem
- initWithText: (NSString *) text;
- (void) dealloc;
- paint: (QPainter *) painter;
- (int) height: (QListBox *) listBox;
- (int) width: (QListBox *) listBox;
@end

@interface QListBoxPixmap : QListBoxItem
- initWithPixmap: (QPixmap *) pixmap;
- (QPixmap *) pixmap;
@end

@interface QListBox : QTableView
- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f;
- (void) dealloc;
- setFont: (QFont *) font;
- (uint) count;
- insertListBoxItem: (QListBoxItem *) item;
- insertListBoxItem: (QListBoxItem *) item index: (int) index;
- insertTextItem: (NSString *) text;
- insertTextItem: (NSString *) text index: (int) index;
- insertPixmapItem: (QPixmap *) pixmap;
- insertPixmapItem: (QPixmap *) pixmap index: (int) index;
- inListBoxSort: (QListBoxItem *) item;
- inTextSort: (NSString *) text;
- removeItem: (int) index;
- clear;
- (NSString *) text: (int) index;
- (QPixmap *) pixmap: (int) index;
- changeListBoxItem: (QListBoxItem *) item index: (int) index;
- changeStringItem: (NSString *) text index: (int) index;
- changePixmapItem: (QPixmap *) pixmap index: (int) index;
- (BOOL) autoUpdate;
- setAutoUpdate: (BOOL) yn;
- (int) numItemsVisible;
- setFixedVisibleLines: (int) lines;
- (int) currentItem;
- setCurrentItem: (int) index;
- centerCurrentItem;
- (int) topItem;
- setTopItem: (int) index;
- setBottomItem: (int) index;
- (BOOL) dragSelect;
- setDragSelect: (BOOL) yn;
- (BOOL) autoScroll;
- setAutoScroll: (BOOL) yn;
- (BOOL) autoScrollBar;
- setAutoScrollBar: (BOOL) yn;
- (BOOL) scrollBar;
- setScrollBar: (BOOL) yn;
- (BOOL) autoBottomScrollBar;
- setAutoBottomScrollBar: (BOOL) yn;
- (BOOL) bottomScrollBar;
- setBottomScrollBar: (BOOL) yn;
- (BOOL) smoothScrolling;
- setSmoothScrolling: (BOOL) yn;
- (int) itemHeight;
- (int) itemHeight: (int) index;
- (long) maxItemWidth;
- (BOOL) isMultiSelection;
- setMultiSelection: (BOOL) yn;
- setSelected: (int) index selected: (BOOL) yn;
- (BOOL) isSelected: (int) index;
- (QSize *) sizeHint;

@end

#endif
