/***************************************************************************
                          QListView.m  -  description
                             -------------------
    begin                : Sat Apr 1 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <Foundation/NSArray.h>

#include <qtobjc/QListView.h>
#include <qtobjc/QPainter.h>
#include <qtobjc/QPixmap.h>

#undef Manual
#include <qtc/qtc.h>

@implementation QListViewItem

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- initWithParent: (QListView *) parent
{
	[self setQt: qt_new_QListViewItem([parent qt])];
	[super init];	
	return self;
}


- initWithParentItem: (QListViewItem *) parentItem
{
	[self setQt: qt_new_QListViewItem1([parentItem qt])];	
	[super init];	
	return self;
}


- initWithParent: (QListView *) parent after: (QListViewItem *) after
{
	[self setQt: qt_new_QListViewItem2([parent qt], [after qt])];	
	[super init];	
	return self;
}


- initWithParentItem: (QListViewItem *) parentItem after: (QListViewItem *) after
{
	[self setQt: qt_new_QListViewItem3([parentItem qt], [after qt])];	
	[super init];	
	return self;
}


- initWithParent: (QListView *) parent labels: (NSString *) label1, ...
{
	NSMutableArray *	labels;
	NSString *		label;
	va_list			args;
	int				count;
	
	labels = [[NSMutableArray alloc] init];
	[labels addObject: label1];
	
	va_start(args, label1);
	
	label = va_arg(args, NSString *);
	while (label != nil) {
		[labels addObject: label];
		label = va_arg(args, NSString *);
	}
	
	va_end(args);
	count = [labels count];
	
	[	self setQt: qt_new_QListViewItem4(	[parent qt],
										(char *) [[labels objectAtIndex: 0] cString],
										count > 1 ? (char *) [[labels objectAtIndex: 1] cString] : 0,
										count > 2 ? (char *) [[labels objectAtIndex: 2] cString] : 0,
										count > 3 ? (char *) [[labels objectAtIndex: 3] cString] : 0,
										count > 4 ? (char *) [[labels objectAtIndex: 4] cString] : 0,
										count > 5 ? (char *) [[labels objectAtIndex: 5] cString] : 0,
										count > 6 ? (char *) [[labels objectAtIndex: 6] cString] : 0,
										count > 7 ? (char *) [[labels objectAtIndex: 7] cString] : 0 ) ];
	[labels release];
	[super init];	
	return self;
}


- initWithParentItem: (QListViewItem *) parentItem labels: (NSString *) label1, ...
{
	NSMutableArray *	labels;
	NSString *		label;
	va_list			args;
	int				count;
	
	labels = [[NSMutableArray alloc] init];
	[labels addObject: label1];
	
	va_start(args, label1);
	
	label = va_arg(args, NSString *);
	while (label != nil) {
		[labels addObject: label];
		label = va_arg(args, NSString *);
	}
	
	va_end(args);
	count = [labels count];
	
	[	self setQt: qt_new_QListViewItem5(	[parentItem qt],
										(char *) [[labels objectAtIndex: 0] cString],
										count > 1 ? (char *) [[labels objectAtIndex: 1] cString] : 0,
										count > 2 ? (char *) [[labels objectAtIndex: 2] cString] : 0,
										count > 3 ? (char *) [[labels objectAtIndex: 3] cString] : 0,
										count > 4 ? (char *) [[labels objectAtIndex: 4] cString] : 0,
										count > 5 ? (char *) [[labels objectAtIndex: 5] cString] : 0,
										count > 6 ? (char *) [[labels objectAtIndex: 6] cString] : 0,
										count > 7 ? (char *) [[labels objectAtIndex: 7] cString] : 0 ) ];
	[labels release];
	[super init];	
	return self;
}


- initWithParent: (QListView *) parent  after: (QListViewItem *) after labels: (NSString *) label1,  ...
{
	NSMutableArray *	labels;
	NSString *		label;
	va_list			args;
	int				count;
	
	labels = [[NSMutableArray alloc] init];
	[labels addObject: label1];
	
	va_start(args, label1);
	
	label = va_arg(args, NSString *);
	while (label != nil) {
		[labels addObject: label];
		label = va_arg(args, NSString *);
	}
	
	va_end(args);
	count = [labels count];
	
	[	self setQt: qt_new_QListViewItem6(	[parent qt],
										[after qt],
										(char *) [[labels objectAtIndex: 0] cString],
										count > 1 ? (char *) [[labels objectAtIndex: 1] cString] : 0,
										count > 2 ? (char *) [[labels objectAtIndex: 2] cString] : 0,
										count > 3 ? (char *) [[labels objectAtIndex: 3] cString] : 0,
										count > 4 ? (char *) [[labels objectAtIndex: 4] cString] : 0,
										count > 5 ? (char *) [[labels objectAtIndex: 5] cString] : 0,
										count > 6 ? (char *) [[labels objectAtIndex: 6] cString] : 0,
										count > 7 ? (char *) [[labels objectAtIndex: 7] cString] : 0 ) ];
	[labels release];
	[super init];	
	return self;
}


- initWithParentItem: (QListViewItem *) parentItem  after: (QListViewItem *) after labels: (NSString *) label1, ...
{
	NSMutableArray *	labels;
	NSString *		label;
	va_list			args;
	int				count;
	
	labels = [[NSMutableArray alloc] init];
	[labels addObject: label1];
	
	va_start(args, label1);
	
	label = va_arg(args, NSString *);
	while (label != nil) {
		[labels addObject: label];
		label = va_arg(args, NSString *);
	}
	
	va_end(args);
	count = [labels count];
	
	[	self setQt: qt_new_QListViewItem7(	[parentItem qt],
										[after qt],
										(char *) [[labels objectAtIndex: 0] cString],
										count > 1 ? (char *) [[labels objectAtIndex: 1] cString] : 0,
										count > 2 ? (char *) [[labels objectAtIndex: 2] cString] : 0,
										count > 3 ? (char *) [[labels objectAtIndex: 3] cString] : 0,
										count > 4 ? (char *) [[labels objectAtIndex: 4] cString] : 0,
										count > 5 ? (char *) [[labels objectAtIndex: 5] cString] : 0,
										count > 6 ? (char *) [[labels objectAtIndex: 6] cString] : 0,
										count > 7 ? (char *) [[labels objectAtIndex: 7] cString] : 0 ) ];
	[labels release];
	[super init];	
	return self;
}


- (void) dealloc
{
	qt_del_QListView([self qt]);	
	[super dealloc];	
	return;
}


- insertItem: (QListViewItem *) item
{
	qt_QListViewItem_insertItem([self qt], [item qt]);
	return self;
}


- removeItem: (QListViewItem *) item
{
	qt_QListViewItem_removeItem([self qt], [item qt]);
	return self;
}


- invalidateHeight
{
	qt_QListViewItem_invalidateHeight([self qt]);
	return self;
}


- (int) totalHeight
{
	return (int) qt_QListViewItem_totalHeight([self qt]);
}


- (int) width: (QFontMetrics *) fontMetric listView: (QListView *) listView column: (int) column
{
	return (int) qt_QListViewItem_width([self qt], [fontMetric qt], [listView qt], column);
}


- widthChanged: (int) column
{
	qt_QListViewItem_widthChanged([self qt], column);
	return self;
}


- (int) depth
{
	return (int) qt_QListViewItem_depth([self qt]);
}


- setTextInColumn: (int) column text: (NSString *) text
{
	qt_QListViewItem_setText([self qt], column, (char *) text);
	return self;
}


- (NSString *) textInColumn: (int) column
{
	return (NSString *) [NSString stringWithCString: qt_QListViewItem_text([self qt], column)];
}


- setPixmap: (int) identifier pixmap: (QPixmap *) pixmap
{
	qt_QListViewItem_setPixmap([self qt], identifier, [pixmap qt]);
	return self;
}


- (QPixmap *) pixmap: (int) identifier
{
	return (QPixmap *) [QObject objectForQtKey: qt_QListViewItem_pixmap([self qt], identifier) withClass: [QPixmap class]];
}


- (NSString *) key: (int) column ascending: (BOOL) yn
{
	return (NSString *) [NSString stringWithCString: qt_QListViewItem_key([self qt], column, yn)];
}


- sortChildItems: (int)  ascending: (BOOL) yn
{
	qt_QListViewItem_sortChildItems([self qt], ascending, yn);
	return self;
}


- setOpen: (BOOL) yn
{
	qt_QListViewItem_setOpen([self qt], yn);
	return self;
}


- setup
{
	qt_QListViewItem_setup([self qt]);
	return self;
}


- setSelected: (BOOL) yn
{
	qt_QListViewItem_setSelected([self qt], yn);
	return self;
}


- paintCell: (QPainter *) painter colorGroup: (QColorGroup *) cg column: (int) column width: (int) width alignment: (int) alignment
{
	qt_QListViewItem_paintCell([self qt], [painter qt], [cg qt], column, width, alignment);
	return self;
}


- paintBranches: (QPainter *) p colorGroup: (QColorGroup *) cg width: (int) width top: (int) y height: (int) h style: (GUIStyle) s
{
	qt_QListViewItem_paintBranches([self qt], [p qt], [cg qt], width, y, h, s);
	return self;
}


- paintFocus: (QPainter *) painter colorGroup: (QColorGroup *) cg rect: (QRect *) r
{
	qt_QListViewItem_paintFocus([self qt], [painter qt], [cg qt], [r qt]);
	return self;
}


- (QListViewItem *) firstChild
{
	return (QListViewItem *) [QObject objectForQtKey: qt_QListViewItem_firstChild([self qt])];
}


- (QListViewItem *) parent
{
	return (QListViewItem *) [QObject objectForQtKey: qt_QListViewItem_parent([self qt])];
}


- (QListViewItem *) itemAbove
{
	return (QListViewItem *) [QObject objectForQtKey: qt_QListViewItem_itemAbove([self qt])];
}


- (QListViewItem *) itemBelow
{
	return (QListViewItem *) [QObject objectForQtKey: qt_QListViewItem_itemBelow([self qt])];
}


- (int) itemPos
{
	return (int) qt_QListViewItem_itemPos([self qt]);
}


- (QListView *) listView
{
	return (QListView *) [QObject objectForQtKey: qt_QListViewItem_listView([self qt])];
}


- setSelectable: (BOOL) enable
{
	qt_QListViewItem_setSelectable([self qt], enable);
	return self;
}


- setExpandable: (BOOL) yn
{
	qt_QListViewItem_setExpandable([self qt], yn);
	return self;
}


- repaint
{
	qt_QListViewItem_repaint([self qt]);
	return self;
}


@end

@implementation QListView

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QListView([parent qt], (char *) [name cString])];
	[super init];	
	return self;
}


- (void) dealloc
{
	qt_del_QListView([self qt]);	
	[super dealloc];	
	return;
}


- (int) treeStepSize
{
	return (int) qt_QListView_treeStepSize([self qt]);
}


- setTreeStepSize: (int) size
{
	qt_QListView_setTreeStepSize([self qt], size);
	return self;
}


- insertItem: (QListViewItem *) item
{
	qt_QListView_insertItem([self qt], [item qt]);
	return self;
}


- clear
{
	qt_QListView_clear([self qt]);
	return self;
}


- (QHeader *) header
{
	return (QHeader *) [QObject objectForQtKey: qt_QListView_header([self qt])];
}


- (int) addColumn: (NSString *) label
{
	return [self addColumn: label size: -1];
}

- (int) addColumn: (NSString *) label size: (int) size
{
	return (int) qt_QListView_addColumn([self qt], (char *) [label cString], size);
}


- setColumnText: (int) column label: (NSString *) label
{
	qt_QListView_setColumnText([self qt], column, (char *) [label cString]);
	return self;
}


- (NSString *) columnText: (int) column
{
	return (NSString *) [NSString stringWithCString: qt_QListView_columnText([self qt], column)];
}


- setColumn: (int) column width: (int) width
{
	qt_QListView_setColumnWidth([self qt], column, width);
	return self;
}


- (int) columnWidth: (int) column
{
	return (int) qt_QListView_columnWidth([self qt], column);
}


- setColumnWidthMode: (int) column widthMode: (WidthMode) mode
{
	qt_QListView_setColumnWidthMode([self qt], column, mode);
	return self;
}


- (WidthMode) columnWidthMode: (int) column
{
	return (WidthMode) qt_QListView_columnWidthMode([self qt], column);
}


- setColumnAlignment: (int) column alignment: (int) alignment
{
	qt_QListView_setColumnAlignment([self qt], column, alignment);
	return self;
}


- (int) columnAlignment: (int) alignment
{
	return (int) qt_QListView_columnAlignment([self qt], alignment);
}


- show
{
	qt_QListView_show([self qt]);
	return self;
}


- (QListViewItem *) itemAt: (QPoint *) screenPos
{
	return (QListViewItem *) [QObject objectForQtKey: qt_QListView_itemAt([self qt], [screenPos qt])];
}


- (QRect *) itemRect: (QListViewItem *) item
{
	return (QRect *) [QObject objectForQtKey: qt_QListView_itemRect([self qt], [item qt])];
}


- (int) itemPos: (QListViewItem *) item
{
	return (int) qt_QListView_itemPos([self qt], [item qt]);
}


- ensureItemVisible: (QListViewItem *) item
{
	qt_QListView_ensureItemVisible([self qt], [item qt]);
	return self;
}


- repaintItem: (QListViewItem *) item
{
	qt_QListView_repaintItem([self qt], [item qt]);
	return self;
}


- setMultiSelection: (BOOL) enable
{
	qt_QListView_setMultiSelection([self qt], enable);
	return self;
}


- (BOOL) isMultiSelection
{
	return (BOOL) qt_QListView_isMultiSelection([self qt]);
}


- setSelected: (QListViewItem *) item selected: (BOOL) yn
{
	qt_QListView_setSelected([self qt], [item qt], yn);
	return self;
}


- (BOOL) isSelected: (QListViewItem *) item
{
	return (BOOL) qt_QListView_isSelected([self qt], [item qt]);
}


- setOpen: (QListViewItem *) item open: (BOOL) yn
{
	qt_QListView_setOpen([self qt], [item qt], yn);
	return self;
}


- (BOOL) isOpen: (QListViewItem *) item
{
	return (BOOL) qt_QListView_isOpen([self qt], [item qt]);
}


- setCurrentItem: (QListViewItem *) item
{
	qt_QListView_setCurrentItem([self qt], [item qt]);
	return self;
}


- (QListViewItem *) currentItem
{
	return (QListViewItem *) [QObject objectForQtKey: qt_QListView_currentItem([self qt])];
}


- (QListViewItem *) firstChild
{
	return (QListViewItem *) [QObject objectForQtKey: qt_QListView_firstChild([self qt])];
}


- (int) childCount
{
	return (int) qt_QListView_childCount([self qt]);
}


- setAllColumnsShowFocus: (BOOL) yn
{
	qt_QListView_setAllColumnsShowFocus([self qt], yn);
	return self;
}


- (BOOL) allColumnsShowFocus
{
	return (BOOL) qt_QListView_allColumnsShowFocus([self qt]);
}


- setItemMargin: (int) margin
{
	qt_QListView_setItemMargin([self qt], margin);
	return self;
}


- (int) itemMargin
{
	return (int) qt_QListView_itemMargin([self qt]);
}


- setRootIsDecorated: (BOOL) yn
{
	qt_QListView_setRootIsDecorated([self qt], yn);
	return self;
}


- (BOOL) rootIsDecorated
{
	return (BOOL) qt_QListView_rootIsDecorated([self qt]);
}


- setSorting: (int) column increasing: (BOOL) increasing
{
	qt_QListView_setSorting([self qt], column, increasing);
	return self;
}


- setStyle: (GUIStyle) style
{
	qt_QListView_setStyle([self qt], style);
	return self;
}


- setFont: (QFont *) font
{
	qt_QListView_setFont([self qt], [font qt]);
	return self;
}


- setPalette: (QPalette *) palette
{
	qt_QListView_setPalette([self qt], [palette qt]);
	return self;
}


- (BOOL) eventFilter: (QObject *) o event: (QEvent *) event
{
	return (BOOL) qt_QListView_eventFilter([self qt], [o qt], [event qt]);
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: qt_QListView_sizeHint([self qt])];
}


- triggerUpdate
{
	qt_QListView_triggerUpdate([self qt]);
	return self;
}

@end

@implementation QCheckListItem

- initWithParentItem: (QCheckListItem *) parent text: (NSString *) text type: (Type) type
{
	[self setQt: qt_new_QCheckListItem([parent qt], (char *) [text cString], type)];	
	return self;
}


- initWithParent: (QListView *) parent text: (NSString *) text type: (Type) type
{
	[self setQt: qt_new_QCheckListItem1([parent qt], (char *) [text cString], type) ];	
	return self;
}


- initWithParentItem: (QListViewItem *) parent text: (NSString *) text pixmap: (QPixmap *) pixmap
{
	[self setQt: qt_new_QCheckListItem2([parent qt], (char *) [text cString], [pixmap qt])];	
	return self;
}


- initWithParent: (QListView *) parent text: (NSString *) text pixmap: (QPixmap *) pixmap
{
	[self setQt: qt_new_QCheckListItem3([parent qt], (char *) [text cString], [pixmap qt])];	
	return self;
}


- paintCell: (QPainter *) painter colorGroup: (QColorGroup *) cg column: (int) column width: (int) width alignment: (int) alignment
{
	qt_QCheckListItem_paintCell([self qt], [painter qt], [cg qt], column, width, alignment);
	return self;
}


- (int) width: (QFontMetrics *) fontMetrics listView: (QListView *) listView column: (int) column
{
	return (int) qt_QCheckListItem_width([self qt], [fontMetrics qt], [listView qt], column);
}


- setup
{
	qt_QCheckListItem_setup([self qt]);
	return self;
}


- setOn: (BOOL) yn
{
	qt_QCheckListItem_setOn([self qt], yn);
	return self;
}
@end

