/***************************************************************************
                          QMainWindow.h  -  description
                             -------------------
    begin                : Fri Mar 24 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QMAINWINDOW_H
#define QMAINWINDOW_H

#include <Foundation/NSObject.h>

#include <qtobjc/QWidget.h>
#include <qtobjc/QToolTip.h>

#define ToolBarDock		int
#define Unmanaged			0
#define TornOff			1
#define Top				2
#define Bottom			3
#define Right			4
#define Left  			5

@class QMenuBar;
@class QToolBar;
@class QStatusBar;

/**
  *@author Richard Dale
  */

@interface QMainWindow : QWidget
- init;
- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f;
- (void) dealloc;

- (QMenuBar *) menuBar;
- (QStatusBar *) statusBar;
- (QToolTipGroup *) toolTipGroup;
- setCentralWidget: (QWidget *) widget;
- (QWidget *) centralWidget;
- setDockEnabled: (ToolBarDock) dock enable: (BOOL) enable;
- (BOOL) isDockEnabled: (ToolBarDock) dock;
- addToolBar: (QToolBar *) toolbar label: (NSString *) label toolbarType: (ToolBarDock) toolbarType newline: (BOOL) newLine;
- removeToolBar: (QToolBar *) toolbar;
- show;
- (BOOL) rightJustification;
- (BOOL) usesBigPixmaps;
- setRightJustification: (BOOL) yn;
- setUsesBigPixmaps: (BOOL) yn;
@end

#endif
