/***************************************************************************
                          QMainWindow.m  -  description
                             -------------------
    begin                : Fri Mar 24 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QMainWindow.h>
#include <qtobjc/QToolBar.h>
#include <qtc/qtc.h>

@implementation QMainWindow

+ (void) initialize
{
	id temp;
	
	// Force these classes to load now
	temp = [QMenuBar class];
	temp = [QStatusBar class];
	return;
}

- init
{
	return [self initWithParent: nil name: @"" flags: 0];
}

- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f
{
	[self setQt: qt_new_QMainWindow([parent qt], (char *) [name cString], f)];	
	return self;
}


- (void) dealloc
{
	qt_del_QMainWindow([self qt]);	
	[super dealloc];	
	return;
}



- (QMenuBar *) menuBar
{
	return (QMenuBar *) [QObject objectForQtKey: qt_QMainWindow_menuBar([self qt])];
}


- (QStatusBar *) statusBar
{
	return (QStatusBar *) [QObject objectForQtKey: qt_QMainWindow_statusBar([self qt])];
}


- (QToolTipGroup *) toolTipGroup
{
	return (QToolTipGroup *) [QObject objectForQtKey: qt_QMainWindow_toolTipGroup([self qt])];
}


- setCentralWidget: (QWidget *) widget
{
	qt_QMainWindow_setCentralWidget([self qt], [widget qt]);
	return self;
}


- (QWidget *) centralWidget
{
	return (QWidget *) [QObject objectForQtKey: qt_QMainWindow_centralWidget([self qt])];
}


- setDockEnabled: (ToolBarDock) dock enable: (BOOL) enable
{
	qt_QMainWindow_setDockEnabled([self qt], dock, enable);
	return self;
}


- (BOOL) isDockEnabled: (ToolBarDock) dock
{
	return (BOOL) qt_QMainWindow_isDockEnabled([self qt], dock);
}


- addToolBar: (QToolBar *) toolbar label: (NSString *) label toolbarType: (ToolBarDock) toolbarType newline: (BOOL) newline
{
	qt_QMainWindow_addToolBar([self qt], [toolbar qt], (char *) [label cString], toolbarType, newline);
	return self;
}


- removeToolBar: (QToolBar *) toolbar
{
	qt_QMainWindow_removeToolBar([self qt], [toolbar qt]);
	return self;
}


- show
{
	qt_QMainWindow_show([self qt]);
	return self;
}


- (BOOL) rightJustification
{
	return (BOOL) qt_QMainWindow_rightJustification([self qt]);
}


- (BOOL) usesBigPixmaps
{
	return (BOOL) qt_QMainWindow_usesBigPixmaps([self qt]);
}


- setRightJustification: (BOOL) yn
{
	qt_QMainWindow_setRightJustification([self qt], yn);
	return self;
}


- setUsesBigPixmaps: (BOOL) yn
{
	qt_QMainWindow_setUsesBigPixmaps([self qt], yn);
	return self;
}

@end

