/***************************************************************************
                          QMenuBar.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/****************************************************#include <qtobjc/QWidget.h>
***********************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QMenuBar.h>
#include <qtc/qtc.h>

@implementation QMenuBar

- initWithParent: (QWidget *) parent
{
	[self setQt: qt_new_QMenuBar([parent qt], NULL)];
	[super init];	
	return self;
}

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QMenuBar([parent qt], (char *) [name cString])];	
	[super init];	
	return self;
}


- (void) dealloc
{
	qt_del_QMenuBar([self qt]);	
	[super dealloc];	
	return;
}



- updateItem: (int) identifier
{
	qt_QMenuBar_updateItem([self qt], identifier);
	return self;
}


- show
{
	qt_QMenuBar_show([self qt]);
	return self;
}

				
- hide
{
	qt_QMenuBar_hide([self qt]);
	return self;
}

				
- (BOOL) eventFilter: (<QObjectInterface,QtSupport>) receiver event: (QEvent *) event
{
	return (BOOL) qt_QMenuBar_eventFilter([self qt], [receiver qt], [(<QtSupport>) event qt]);
}


- (int) heightForWidth: (int) width
{
	return (int) qt_QMenuBar_heightForWidth([self qt], width);
}


- (Separator) separator
{
	return (Separator) qt_QMenuBar_separator([self qt]);
}


- setSeparator: (Separator) when
{
	qt_QMenuBar_setSeparator([self qt], when);
	return self;
}


@end

@implementation QMenuBar (QMenuDataImplementation)

- (uint) count
{
	return (uint) qt_QMenuData_count(qt_QMenuBar_QMenuData([self qt]));
}


- (int) insertItem: (NSString *) text receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member
{
	return [self insertItem: text receiver: receiver slot: member accel: 0];
}

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member accel: (int) accel
{
	return [self insertItem: text receiver: receiver slot: member accel: accel identifier: -1 index: -1];	
}

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel identifier: (int) identifier
{
	return [self insertItem: text receiver: receiver slot: member accel: accel identifier: identifier index: -1];	
}

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel identifier: (int) identifier index: (int) index
{
	identifier = [self insertItem: text identifier: identifier index: index];
	[self connectItem: identifier receiver: receiver slot: member];
	[self setAccel: accel identifier: identifier];
	return identifier;
}

- (int) insertPixmapItem: (QPixmap *) pixmap receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member accel: (int) accel
{
	return (int) qt_QMenuBar_insertItem1([self qt], [pixmap qt], [receiver qt], (char *) [member cString], accel);
}


- (int) insertPixmapItem: (QPixmap *) pixmap text: (NSString *) text receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member accel: (int) accel
{
	return (int) qt_QMenuBar_insertItem2([self qt], [pixmap qt], (char *) [text cString], [receiver qt], (char *) [member cString], accel);
}

- (int) insertItem: (NSString *) text identifier: (int) identifier
{
	return [self insertItem: text identifier: identifier index: -1];
}

- (int) insertItem: (NSString *) text identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuBar_insertItem3([self qt], (char *) [text cString], identifier, index);
}

- (int) insertPopupItem: (NSString *) text popup: (QPopupMenu *) popup
{
	return [self insertPopupItem: text popup: popup identifier: -1 index: -1];
}

- (int) insertPopupItem: (NSString *) text popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuBar_insertItem4([self qt], (char *) [text cString], [popup qt], identifier, index);
}

- (int) insertPixmapItem: (QPixmap *) pixmap identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuBar_insertItem5([self qt], [pixmap qt], identifier, index);
}


- (int) insertPixmapItem: (QPixmap *) pixmap popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuBar_insertItem6([self qt], [pixmap qt], [popup qt], identifier, index);
}

- (int) insertPixmapItem:  (QPixmap *) pixmap text: (NSString *) text identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuBar_insertItem7([self qt], [pixmap qt], (char *) [text cString], identifier, index);
}

- (int) insertPopupItem: (QPixmap *) pixmap text: (NSString *)text popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuBar_insertItem8([self qt], [pixmap qt], (char *) [text cString], [popup qt], identifier, index);
}


- insertSeparator
{
	qt_QMenuBar_insertSeparator([self qt], -1);
	return self;
}

- insertSeparator: (int) index
{
	qt_QMenuBar_insertSeparator([self qt], index);
	return self;
}


- removeItem: (int) identifier
{
	qt_QMenuData_removeItem(qt_QMenuBar_QMenuData([self qt]), identifier);
	return self;
}

		
- removeItemAt: (int) index
{
	qt_QMenuData_removeItemAt(qt_QMenuBar_QMenuData([self qt]), index);
	return self;
}


- clear
{
	qt_QMenuData_clear(qt_QMenuBar_QMenuData([self qt]));
	return self;
}


- (int) accel: (int) identifier
{
	return (int) qt_QMenuData_accel(qt_QMenuBar_QMenuData([self qt]), identifier);
}


- setAccel: (int) key identifier: (int) identifier
{
	qt_QMenuBar_setAccel([self qt], key, identifier);
	return self;
}


- (NSString *) text: (int) identifier
{
	return (NSString *) [NSString stringWithCString: qt_QMenuData_text(qt_QMenuBar_QMenuData([self qt]), identifier)];
}


- (QPixmap *) pixmap: (int) identifier
{
	return (QPixmap *) [QObject objectForQtKey: qt_QMenuData_pixmap(qt_QMenuBar_QMenuData([self qt]), identifier)];
}


- changeItem: (NSString *) text identifier: (int) identifier
{
	qt_QMenuData_changeItem(qt_QMenuBar_QMenuData([self qt]), (char *) [text cString], identifier);
	return self;
}


- changePixmapItem: (QPixmap *) pixmap identifier: (int) identifier
{
	qt_QMenuData_changeItem1(qt_QMenuBar_QMenuData([self qt]), [pixmap qt], identifier);
	return self;
}


- changePixmapItem: (QPixmap *) pixmap text: (NSString *) text identifier: (int) identifier
{
	qt_QMenuData_changeItem2(qt_QMenuBar_QMenuData([self qt]), [pixmap qt], (char *) [text cString], identifier);
	return self;
}


- (BOOL) isItemEnabled: (int) identifier
{
	return (BOOL) qt_QMenuData_isItemEnabled(qt_QMenuBar_QMenuData([self qt]), identifier);
}


- setItemEnabled: (int) identifier enable: (BOOL) yn
{
	qt_QMenuData_setItemEnabled(qt_QMenuBar_QMenuData([self qt]), identifier, yn);
	return self;
}


- (BOOL) isItemChecked: (int) identifier
{
	return (BOOL) qt_QMenuData_isItemChecked(qt_QMenuBar_QMenuData([self qt]), identifier);
}


- setItemChecked: (int) identifier check: (BOOL) yn
{
	qt_QMenuData_setItemChecked(qt_QMenuBar_QMenuData([self qt]), identifier, yn);
	return self;
}


- updateItem: (int) identifier
{
	qt_QMenuData_updateItem(qt_QMenuBar_QMenuData([self qt]), identifier);
	return self;
}


- (int) indexOf: (int) identifier
{
	return (int) qt_QMenuData_indexOf(qt_QMenuBar_QMenuData([self qt]), identifier);
}


- (int) idAt: (int) index
{
	return (int) qt_QMenuData_idAt(qt_QMenuBar_QMenuData([self qt]), index);
}


- setId: (int) index identifier: (int) identifier
{
	qt_QMenuData_setId(qt_QMenuBar_QMenuData([self qt]), index, identifier);
	return self;
}


- (BOOL) connectItem: (int) identifier receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member
{
	return (BOOL) qt_QMenuData_connectItem(qt_QMenuBar_QMenuData([self qt]), identifier, [receiver qt], (char *) [member cString]);
}


- (BOOL) disconnectItem: (int) identifier receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member
{
	return (BOOL) qt_QMenuData_disconnectItem(qt_QMenuBar_QMenuData([self qt]), identifier, [receiver qt], (char *) [member cString]);
}


@end
