/***************************************************************************
                          QMenuData.h  -  description
                             -------------------
    begin                : Thu Mar 16 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QMENUDATA_H
#define QMENUDATA_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QObject.h>
#include <qtobjc/QPixmap.h>

/**
  *@author Richard Dale
  */

@class QPopupMenu;

@protocol QMenuDataInterface
- (uint) count;

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member;
- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel;
- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel identifier: (int) identifier;
- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel identifier: (int) identifier index: (int) index;
- (int) insertPixmapItem: (QPixmap *) pixmap receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel;
- (int) insertPixmapItem: (QPixmap *) pixmap text: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel;
- (int) insertItem: (NSString *) text identifier: (int) identifier;
- (int) insertItem: (NSString *) text identifier: (int) identifier index: (int) index;
- (int) insertPopupItem: (NSString *) text popup: (QPopupMenu *) popup;
- (int) insertPopupItem: (NSString *) text popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index;
- (int) insertPixmapItem: (QPixmap *) pixmap identifier: (int) identifier index: (int) index;
- (int) insertPixmapItem: (QPixmap *) pixmap popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index;
- (int) insertPixmapItem:  (QPixmap *) pixmap text: (NSString *) text identifier: (int) identifier index: (int) index;
- (int) insertPopupItem: (QPixmap *) pixmap text: (NSString *)text popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index;


- insertSeparator;
- insertSeparator: (int) index;
- removeItem: (int) identifier;		
- removeItemAt: (int) index;
- clear;
- (int) accel: (int) identifier;
- setAccel: (int) key identifier: (int) identifier;
- (NSString *) text: (int) identifier;
- (QPixmap *) pixmap: (int) identifier;
- changeItem: (NSString *) text identifier: (int) identifier;
- changePixmapItem: (QPixmap *) pixmap identifier: (int) identifier;
- changePixmapItem: (QPixmap *) pixmap text: (NSString *) text identifier: (int) identifier;
- (BOOL) isItemEnabled: (int) identifier;
- setItemEnabled: (int) identifier enable: (BOOL) yn;
- (BOOL) isItemChecked: (int) identifier;
- setItemChecked: (int) identifier check: (BOOL) yn;
- updateItem: (int) identifier;
- (int) indexOf: (int) identifier;
- (int) idAt: (int) index;
- setId: (int) index identifier: (int) identifier;
- (BOOL) connectItem: (int) identifier receiver: (<QObjectInterface>) receiver slot: (NSString *) member;
- (BOOL) disconnectItem: (int) identifier receiver: (<QObjectInterface>) receiver slot: (NSString *) member;
@end

@interface QMenuData : NSObject <QMenuDataInterface, QtSupport>
{
@private
	void *	_qt;
}

- init;
- (void) dealloc;
@end

#endif
