/***************************************************************************
                          QMenuData.m  -  description
                             -------------------
    begin                : Thu Mar 16 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <Foundation/NSInvocation.h>
#include <Foundation/NSMethodSignature.h>

#include <qtobjc/QMenuData.h>
#include <qtobjc/QPopupMenu.h>
#include <qtobjc/QObject.h>

#include <qtc/qtc.h>

@implementation QMenuData

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- init
{
	[self setQt: qt_new_QMenuData([self qt])];
	return self;
}



- (void) dealloc
{
	(void) qt_del_QMenuData([self qt]);
	[super dealloc];
	return;
}

- (uint) count
{
	return (uint) qt_QMenuData_count([self qt]);
}

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member
{
	return [self insertItem: text receiver: receiver slot: member accel: 0];
}

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member accel: (int) accel
{
	return [self insertItem: text receiver: receiver slot: member accel: accel identifier: -1 index: -1];	
}

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel identifier: (int) identifier
{
	return [self insertItem: text receiver: receiver slot: member accel: accel identifier: identifier index: -1];	
}

- (int) insertItem: (NSString *) text receiver: (<QObjectInterface>) receiver slot: (NSString *) member accel: (int) accel identifier: (int) identifier index: (int) index
{
	identifier = [self insertItem: text identifier: identifier index: index];
	[self connectItem: identifier receiver: receiver slot: member];
	[self setAccel: accel identifier: identifier];
	return identifier;
}

- (int) insertPixmapItem: (QPixmap *) pixmap receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member accel: (int) accel
{
	return (int) qt_QMenuData_insertItem1([self qt], [pixmap qt], [receiver qt], (char *) [member cString], accel);
}


- (int) insertPixmapItem: (QPixmap *) pixmap text: (NSString *) text receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member accel: (int) accel
{
	return (int) qt_QMenuData_insertItem2([self qt], [pixmap qt], (char *) [text cString], [receiver qt], (char *) [member cString], accel);
}

- (int) insertItem: (NSString *) text identifier: (int) identifier
{
	return [self insertItem: text identifier: identifier index: -1];
}

- (int) insertItem: (NSString *) text identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuData_insertItem3([self qt], (char *) [text cString], identifier, index);
}

- (int) insertPopupItem: (NSString *) text popup: (QPopupMenu *) popup
{
	return [self insertPopupItem: text popup: popup identifier: -1 index: -1];
}

- (int) insertPopupItem: (NSString *) text popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuData_insertItem4([self qt], (char *) [text cString], [popup qt], identifier, index);
}

- (int) insertPixmapItem: (QPixmap *) pixmap identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuData_insertItem5([self qt], [pixmap qt], identifier, index);
}


- (int) insertPixmapItem: (QPixmap *) pixmap popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuData_insertItem6([self qt], [pixmap qt], [popup qt], identifier, index);
}

- (int) insertPixmapItem:  (QPixmap *) pixmap text: (NSString *) text identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuData_insertItem7([self qt], [pixmap qt], (char *) [text cString], identifier, index);
}

- (int) insertPopupItem: (QPixmap *) pixmap text: (NSString *)text popup: (QPopupMenu *) popup identifier: (int) identifier index: (int) index
{
	return (int) qt_QMenuData_insertItem8([self qt], [pixmap qt], (char *) [text cString], [popup qt], identifier, index);
}


- insertSeparator
{
	qt_QMenuData_insertSeparator([self qt], -1);
	return self;
}

- insertSeparator: (int) index
{
	qt_QMenuData_insertSeparator([self qt], index);
	return self;
}


- removeItem: (int) identifier
{
	qt_QMenuData_removeItem([self qt], identifier);
	return self;
}

		
- removeItemAt: (int) index
{
	qt_QMenuData_removeItemAt([self qt], index);
	return self;
}


- clear
{
	qt_QMenuData_clear([self qt]);
	return self;
}


- (int) accel: (int) identifier
{
	return (int) qt_QMenuData_accel([self qt], identifier);
}


- setAccel: (int) key identifier: (int) identifier
{
	qt_QMenuData_setAccel([self qt], key, identifier);
	return self;
}


- (NSString *) text: (int) identifier
{
	return (NSString *) [NSString stringWithCString: qt_QMenuData_text([self qt], identifier)];
}


- (QPixmap *) pixmap: (int) identifier
{
	return (QPixmap *) [QObject objectForQtKey: qt_QMenuData_pixmap([self qt], identifier)];
}


- changeItem: (NSString *) text identifier: (int) identifier
{
	qt_QMenuData_changeItem([self qt], (char *) [text cString], identifier);
	return self;
}


- changePixmapItem: (QPixmap *) pixmap identifier: (int) identifier
{
	qt_QMenuData_changeItem1([self qt], [pixmap qt], identifier);
	return self;
}


- changePixmapItem: (QPixmap *) pixmap text: (NSString *) text identifier: (int) identifier
{
	qt_QMenuData_changeItem2([self qt], [pixmap qt], (char *) [text cString], identifier);
	return self;
}


- (BOOL) isItemEnabled: (int) identifier
{
	return (BOOL) qt_QMenuData_isItemEnabled([self qt], identifier);
}


- setItemEnabled: (int) identifier enable: (BOOL) yn
{
	qt_QMenuData_setItemEnabled([self qt], identifier, yn);
	return self;
}


- (BOOL) isItemChecked: (int) identifier
{
	return (BOOL) qt_QMenuData_isItemChecked([self qt], identifier);
}


- setItemChecked: (int) identifier check: (BOOL) yn
{
	qt_QMenuData_setItemChecked([self qt], identifier, yn);
	return self;
}


- updateItem: (int) identifier
{
	qt_QMenuData_updateItem([self qt], identifier);
	return self;
}


- (int) indexOf: (int) identifier
{
	return (int) qt_QMenuData_indexOf([self qt], identifier);
}


- (int) idAt: (int) index
{
	return (int) qt_QMenuData_idAt([self qt], index);
}


- setId: (int) index identifier: (int) identifier
{
	qt_QMenuData_setId([self qt], index, identifier);
	return self;
}


- (BOOL) connectItem: (int) identifier receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member
{
	qt_Slot *			slotId;
	
	if ([member hasSuffix: @")"]) {
		return (BOOL) qt_QMenuData_connectItem(	[self qt],
												identifier,
												[receiver qt],
												(char *)[[NSString stringWithFormat: @"1%@", member] cString] );
	} else {
		slotId = (qt_Slot *) [QObject slotIdForReceiver: receiver slot: member];
		
		return (BOOL) qt_QMenuData_connectItem(	[self qt],
												identifier,
												(qt_QObject *) slotId,
												([member hasSuffix: @":"]) ?"1UserDataSlot(int)" : "1UserDataSlot()" );
	}
}


- (BOOL) disconnectItem: (int) identifier receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) member
{
	return (BOOL) qt_QMenuData_disconnectItem([self qt], identifier, [receiver qt], (char *) [member cString]);
}

@end


