/***************************************************************************
                          QMessageBox.h  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QMESSAGEBOX_H
#define QMESSAGEBOX_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QDialog.h>
#include <qtobjc/QWidget.h>
#include <qtobjc/QPixmap.h>

#define Icon				int
#define NoIcon			0
#define Information		1
#define Warning			2
#define Critical			3

#define Ok				1
#define Cancel			2
#define Yes				3
#define No				4
#define Abort			5
#define Retry			6
#define ButtonMask		0x07
#undef Default
#define Default			0x100
#define Escape			0x200
#define FlagMask			0x300

/**
  *@author Richard Dale
  */

@interface QMessageBox : QDialog
- initWithParent: (QWidget *) parent name: (NSString *)name;
- initWithCaption: (NSString *) caption text: (NSString *) text icon: (Icon) icon button0: (int) button0 button1: (int) button1 button2: (int) button2 parent: (QWidget *) parent name: (NSString *)name modal: (BOOL) modal flags: (WFlags) f;
- (void) dealloc;

+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0;
+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1;
+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1 button2: (int) button2;
+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text;
+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0Text: (NSString *) button0Text button1Text: (NSString *) button1Text button2Text: (NSString *) button2Text defaultButtonNumber: (int) defaultButtonNumber escapeButtonNumber: (int) escapeButtonNumber;
+ (int) warning: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text;
+ (int) warning: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1 button2: (int) button2;
+ (int) warning: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0Text: (NSString *) button0Text button1Text: (NSString *) button1Text button2Text: (NSString *) button2Text defaultButtonNumber: (int) defaultButtonNumber escapeButtonNumber: (int) escapeButtonNumber;
+ (int) critical: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1 button2: (int) button2;
+ (int) critical: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0Text: (NSString *) button0Text  button1Text: (NSString *) button1Text button2Text: (NSString *) button2Text defaultButtonNumber: (int) defaultButtonNumber escapeButtonNumber: (int) escapeButtonNumber;
+  about: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text;
+  aboutQt: (QWidget *) parent caption: (NSString *) caption;

- (NSString *) text;
- setText: (NSString *) text;
- (Icon) icon;
- setIcon: (Icon) icon;
- (QPixmap *) iconPixmap;
- setIconPixmap: (QPixmap *) pixmap;

- (NSString *) buttonText: (int) button;
- setButtonText: (int) button text: (NSString *) text;
- adjustSize;
- setStyle: (GUIStyle) style;
+ (QPixmap *) standardIcon: (Icon) icon style: (GUIStyle) style;
@end

#endif
