/***************************************************************************
                          QMessageBox.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QMessageBox.h>
#include <qtc/qtc.h>

@implementation QMessageBox

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QMessageBox([parent qt], (char *) [name cString])];	
	return self;
}


- initWithCaption: (NSString *) caption text: (NSString *) text icon: (Icon) icon button0: (int) button0 button1: (int) button1 button2: (int) button2 parent: (QWidget *) parent name: (NSString *)name modal: (BOOL) modal flags: (WFlags) f
{
	[self setQt: qt_new_QMessageBox1((char *) [caption cString], (char *) [text cString], icon, button0, button1, button2, [parent qt], (char *) [name cString], modal, f)];	
	return self;
}


- (void) dealloc
{
	qt_del_QMessageBox([self qt]);	
	[super dealloc];	
	return;
}

+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0
{
	return [self information: parent caption: caption text: text button0: button0 button1: 0 button2: 0];
}

+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1
{
	return [self information: parent caption: caption text: text button0: button0 button1: button1 button2: 0];
}

+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1 button2: (int) button2
{
	return (int) qt_QMessageBox_information([parent qt], (char *) [caption cString], (char *) [text cString], button0, button1, button2);
}

+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text
{
	return [self information: parent caption: caption text: text button0Text: @"OK" button1Text: nil button2Text: nil defaultButtonNumber: 0 escapeButtonNumber: -1];
}

+ (int) information: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0Text: (NSString *) button0Text button1Text: (NSString *) button1Text button2Text: (NSString *) button2Text defaultButtonNumber: (int) defaultButtonNumber escapeButtonNumber: (int) escapeButtonNumber
{
	return (int) qt_QMessageBox_information1([parent qt], (char *) [caption cString], (char *) [text cString], (char *) [button0Text cString], (char *) [button1Text cString], (char *) [button2Text cString], defaultButtonNumber, escapeButtonNumber);
}


+ (int) warning: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text
{
	return (int) qt_QMessageBox_warning([parent qt], (char *) [caption cString], (char *) [text cString], 0, 0, 0);
}

+ (int) warning: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1 button2: (int) button2
{
	return (int) qt_QMessageBox_warning([parent qt], (char *) [caption cString], (char *) [text cString], button0, button1, button2);
}


+ (int) warning: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0Text: (NSString *) button0Text button1Text: (NSString *) button1Text button2Text: (NSString *) button2Text defaultButtonNumber: (int) defaultButtonNumber escapeButtonNumber: (int) escapeButtonNumber
{
	return (int) qt_QMessageBox_warning1([parent qt], (char *) [caption cString], (char *) [text cString], (char *) [button0Text cString], (char *) [button1Text cString], (char *) [button2Text cString], defaultButtonNumber, escapeButtonNumber);
}


+ (int) critical: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0: (int) button0 button1: (int) button1 button2: (int) button2
{
	return (int) qt_QMessageBox_critical([parent qt], (char *) [caption cString], (char *) [text cString], button0, button1, button2);
}


+ (int) critical: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text button0Text: (NSString *) button0Text  button1Text: (NSString *) button1Text button2Text: (NSString *) button2Text defaultButtonNumber: (int) defaultButtonNumber escapeButtonNumber: (int) escapeButtonNumber
{
	return (int) qt_QMessageBox_critical1([parent qt], (char *) [caption cString], (char *) [text cString], (char *) [button0Text cString], (char *) [button1Text cString], (char *) [button2Text cString], defaultButtonNumber, escapeButtonNumber);
}


+ about: (QWidget *) parent caption: (NSString *) caption text: (NSString *) text
{
	qt_QMessageBox_about([parent qt], (char *) [caption cString], (char *) [text cString]);
	return self;
}


+ aboutQt: (QWidget *) parent caption: (NSString *) caption
{
	qt_QMessageBox_aboutQt([parent qt], (char *) [caption cString]);
	return self;
}



- (NSString *) text
{
	return (NSString *) [NSString stringWithCString: qt_QMessageBox_text([self qt])];
}


- setText: (NSString *) text
{
	qt_QMessageBox_setText([self qt], (char *) [text cString]);
	return self;
}


- (Icon) icon
{
	return (Icon) qt_QMessageBox_icon([self qt]);
}


- setIcon: (Icon) icon
{
	qt_QMessageBox_setIcon([self qt], icon);
	return self;
}


- (QPixmap *) iconPixmap
{
	return (QPixmap *) [QObject objectForQtKey: qt_QMessageBox_iconPixmap([self qt])];
}


- setIconPixmap: (QPixmap *) pixmap
{
	qt_QMessageBox_setIconPixmap([self qt], [pixmap qt]);
	return self;
}



- (NSString *) buttonText: (int) button
{
	return (NSString *) [NSString stringWithCString: qt_QMessageBox_buttonText([self qt], button)];
}


- setButtonText: (int) button text: (NSString *) text
{
	qt_QMessageBox_setButtonText([self qt], button, (char *) [text cString]);
	return self;
}


- adjustSize
{
	qt_QMessageBox_adjustSize([self qt]);
	return self;
}


- setStyle: (GUIStyle) style
{
	qt_QMessageBox_setStyle([self qt], style);
	return self;
}


+ (QPixmap *) standardIcon: (Icon) icon style: (GUIStyle) style
{
	return (QPixmap *) [QObject objectForQtKey: qt_QMessageBox_standardIcon(icon, style)];
}

@end

