/***************************************************************************
                          QMovie.h  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QMOVIE_H
#define QMOVIE_H

#include <Foundation/NSObject.h>

#include <qtobjc/QObject.h>
#include <qtobjc/QAsyncIO.h>
#include <qtobjc/QColor.h>
#include <qtobjc/QPixmap.h>

//	Status
#define SourceEmpty			2
#define UnrecognizedFormat	-1
#define Paused				1
#define EndOfFrame			2
#define EndOfLoop				3
#define EndOfMovie			4
#define SpeedChanged			5


/**
  *@author Richard Dale
  */

@class QMovie;

@interface QMovie : NSObject <QtSupport>
- init;
- initFromDataSource: (QDataSource *) dataSource bufferSize: (int) bufsize;
- initFromFile: (NSString *) fileName bufferSize: (int) bufsize;
- initFromArray: (void *) data bufferSize: (int) bufsize;
- initFromMovie: (QMovie *) movie;
- (void) dealloc;

- (QColor *) backgroundColor;
- setBackgroundColor: (QColor *) color;
- (QRect *) getValidRect;
- (QPixmap *) framePixmap;
- (BOOL) isNull;
- (int) frameNumber;
- (int) steps;
- (BOOL) paused;
- (BOOL) finished;
- (BOOL) running;
- unpause;
- pause;
- step;
- step: (int) step;
- restart;
- (int) speed;
- setSpeed: (int) speed;

- connectResize: (QObject *) receiver slot: (NSString *) member;
- disconnectResize: (QObject *) receiver slot: (NSString *) member;
- connectUpdate: (QObject *) receiver slot: (NSString *) member;
- disconnectUpdate: (QObject *) receiver slot: (NSString *) member;

- connectStatus: (QObject *) receiver slot: (NSString *) member;
- disconnectStatus: (QObject *) receiver slot: (NSString *) member;
@end

#endif
