/***************************************************************************
                          QMultiLineEdit.h  -  description
                             -------------------
    begin                : Sat Apr 15 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QMULTILINEEDIT_H
#define QMULTILINEEDIT_H

#include <Foundation/NSObject.h>
#include <qtobjc/QTableView.h>

/**
  *@author Richard Dale
  */

@interface QMultiLineEdit : QTableView

- initWithParent: (QWidget *) parent name: (NSString *) name;
- (void) dealloc;
- (NSString *) textLine: (int) line;
- (NSString *) text;
- (int) numLines;
- (BOOL) isReadOnly;
- (BOOL) isOverwriteMode;
- setFont: (QFont *) font;
- insertLine: (NSString *) s line: (int) line;
- insertAt: (NSString *) s line: (int) line column: (int) col;
- removeLine: (int) line;
- cursorPositionLine: (int ) line column: (int ) col;
- setCursorPositionLine: (int) line column: (int) col mark: (BOOL) mark;
- getCursorPositionLine: (int ) line column: (int ) col;
- (BOOL) atBeginning;
- (BOOL) atEnd;
- (BOOL) autoUpdate;
- setAutoUpdate: (BOOL) yn;
- setFixedVisibleLines: (int) lines;
- (int) maxLineWidth;
- clear;
- setText: (NSString *) text;
- append: (NSString *) text;
- deselect;
- selectAll;
- setReadOnly: (BOOL) yn;
- setOverwriteMode: (BOOL) yn;
- paste;
- copyText;
- cut;

@end

#endif
