/***************************************************************************
                          QMultiLineEdit.m  -  description
                             -------------------
    begin                : Sat Apr 15 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QMultiLineEdit.h>
#include <qtc/qtc.h>

@implementation QMultiLineEdit

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QMultiLineEdit([parent qt], (char *) [name cString])];	
	[super init];
	return self;
}


- (void) dealloc
{
	qt_del_QMultiLineEdit([self qt]);	
	[super dealloc];	
	return;
}


- (NSString *) textLine: (int) line
{
	return (NSString *) [NSString stringWithCString: qt_QMultiLineEdit_textLine([self qt], line)];
}


- (NSString *) text
{
	return (NSString *) [NSString stringWithCString: qt_QString_data(qt_QMultiLineEdit_text([self qt]))];
}


- (int) numLines
{
	return (int) qt_QMultiLineEdit_numLines([self qt]);
}


- (BOOL) isReadOnly
{
	return (BOOL) qt_QMultiLineEdit_isReadOnly([self qt]);
}


- (BOOL) isOverwriteMode
{
	return (BOOL) qt_QMultiLineEdit_isOverwriteMode([self qt]);
}


- setFont: (QFont *) font
{
	qt_QMultiLineEdit_setFont([self qt], [font qt]);
	return self;
}


- insertLine: (NSString *) s line: (int) line
{
	qt_QMultiLineEdit_insertLine([self qt], (char *) [s cString], line);
	return self;
}


- insertAt: (NSString *) s line: (int) line column: (int) col
{
	qt_QMultiLineEdit_insertAt([self qt], (char *) [s cString], line, col);
	return self;
}


- removeLine: (int) line
{
	qt_QMultiLineEdit_removeLine([self qt], line);
	return self;
}


- cursorPositionLine: (int ) line column: (int ) col
{
	qt_QMultiLineEdit_cursorPosition([self qt], line, col);
	return self;
}


- setCursorPositionLine: (int) line column: (int) col mark: (BOOL) mark
{
	qt_QMultiLineEdit_setCursorPosition([self qt], line, col, mark);
	return self;
}


- getCursorPositionLine: (int ) line column: (int ) col
{
	qt_QMultiLineEdit_getCursorPosition([self qt], line, col);
	return self;
}


- (BOOL) atBeginning
{
	return (BOOL) qt_QMultiLineEdit_atBeginning([self qt]);
}


- (BOOL) atEnd
{
	return (BOOL) qt_QMultiLineEdit_atEnd([self qt]);
}


- (BOOL) autoUpdate
{
	return (BOOL) qt_QMultiLineEdit_autoUpdate([self qt]);
}


- setAutoUpdate: (BOOL) yn
{
	qt_QMultiLineEdit_setAutoUpdate([self qt], yn);
	return self;
}


- setFixedVisibleLines: (int) lines
{
//	qt_QMultiLineEdit_setFixedVisibleLines([self qt], lines);
	return self;
}


- (int) maxLineWidth
{
//	return (int) qt_QMultiLineEdit_maxLineWidth([self qt]);
	return 0;
}


- clear
{
	qt_QMultiLineEdit_clear([self qt]);
	return self;
}


- setText: (NSString *) text
{
	qt_QMultiLineEdit_setText([self qt], (char *) [text cString]);
	return self;
}


- append: (NSString *) text
{
	qt_QMultiLineEdit_append([self qt], (char *) [text cString]);
	return self;
}


- deselect
{
	qt_QMultiLineEdit_deselect([self qt]);
	return self;
}


- selectAll
{
	qt_QMultiLineEdit_selectAll([self qt]);
	return self;
}


- setReadOnly: (BOOL) yn
{
	qt_QMultiLineEdit_setReadOnly([self qt], yn);
	return self;
}


- setOverwriteMode: (BOOL) yn
{
	qt_QMultiLineEdit_setOverwriteMode([self qt], yn);
	return self;
}


- paste
{
	qt_QMultiLineEdit_paste([self qt]);
	return self;
}


- copyText
{
	qt_QMultiLineEdit_copyText([self qt]);
	return self;
}


- cut
{
	qt_QMultiLineEdit_cut([self qt]);
	return self;
}

@end

