/***************************************************************************
                          QPainter.m  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QPainter.h>
#include <qtc/qtc.h>

@implementation QPainter

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- init
{
	[super init];
	[self setQt: qt_new_QPainter()];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- initPaintDevice: (QPaintDevice *) device
{
	[super init];
	[self setQt: qt_new_QPainter1([device qt])];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- (void) dealloc
{
	[QObject removeQtKey: [self qt]];
	qt_del_QPainter([self qt]);
	[super dealloc];
	return;
}


- (BOOL) begin: (QPaintDevice *) device
{
	return (BOOL) qt_QPainter_begin([self qt], [device paintDevice]);
}


- (BOOL) begin: (QPaintDevice *) device withWidget: (QWidget *) widget
{
//	return (BOOL) qt_QPainter_begin1([self qt], [device qt], [widget qt]);
	return NO;
}


- (BOOL) end
{
	return (BOOL) qt_QPainter_end([self qt]);
}


- (QPaintDevice *) device
{
	return (QPaintDevice *) [QObject objectForQtKey: qt_QPainter_device([self qt]) withClass: [QPaintDevice class]];
}


+ redirect: (QPaintDevice *) pdev to: (QPaintDevice *) replacement
{
	qt_QPainter_redirect([pdev qt], [replacement qt]);
	return self;
}


- (BOOL) isActive
{
	return (BOOL) qt_QPainter_isActive([self qt]);
}


- flush
{
	qt_QPainter_flush([self qt]);
	return self;
}


- save
{
	qt_QPainter_save([self qt]);
	return self;
}


- restore
{
	qt_QPainter_restore([self qt]);
	return self;
}


- (QFontMetrics *) fontMetrics
{
	return (QFontMetrics *) [QObject objectForQtKey: qt_QPainter_fontMetrics([self qt]) withClass: [QFontMetrics class]];
}


- (QFontInfo *) fontInfo
{
	return (QFontInfo *) [QObject objectForQtKey: qt_QPainter_fontInfo([self qt]) withClass: [QFontInfo class]];
}


- (QFont *) font
{
	return (QFont *) [QObject objectForQtKey: qt_QPainter_font([self qt]) withClass: [QFont class]];
}


- setFont: (QFont *) font
{
	qt_QPainter_setFont([self qt], [font qt]);
	return self;
}


- (QPen *) pen
{
	return (QPen *) [QObject objectForQtKey: qt_QPainter_pen([self qt]) withClass: [QPen class]];
}


- setPen: (QPen *) pen
{
	qt_QPainter_setPen([self qt], [pen qt]);
	return self;
}


- setPenStyle: (int) pen
{
	qt_QPainter_setPen1([self qt], pen);
	return self;
}


- setPenColor: (QColor *) color
{
	qt_QPainter_setPen2([self qt], [color qt]);
	return self;
}


- (QBrush *) brush
{
	return (QBrush *) [QObject objectForQtKey: qt_QPainter_brush([self qt]) withClass: [QBrush class]];
}


- setBrush: (QBrush *) brush
{
	qt_QPainter_setBrush([self qt], [brush qt]);
	return self;
}


- setBrushStyle: (int) brush
{
//	qt_QPainter_setBrushStyle([self qt], brush);
	return self;
}


- setBrushColor: (QColor *) color
{
//	qt_QPainter_setBrushColor([self qt], [color qt]);
	return self;
}


- (QColor *) backgroundColor
{
	return (QColor *) [QObject objectForQtKey: qt_QPainter_backgroundColor([self qt]) withClass: [QColor class]];
}


- setBackgroundColor: (QColor *) color
{
	qt_QPainter_setBackgroundColor([self qt], [color qt]);
	return self;
}


- (int) backgroundMode
{
	return (int) qt_QPainter_backgroundMode([self qt]);
}


- setBackgroundMode: (int) mode
{
	qt_QPainter_setBackgroundMode([self qt], mode);
	return self;
}


- (int) rasterOp
{
	return (int) qt_QPainter_rasterOp([self qt]);
}


- setRasterOp: (int) op
{
	qt_QPainter_setRasterOp([self qt], op);
	return self;
}


- (QPoint *) brushOrigin
{
	return (QPoint *) [QObject objectForQtKey: qt_QPainter_brushOrigin([self qt])];
}


- setBrushOrigin: (int) x : (int) y
{
	qt_QPainter_setBrushOrigin([self qt], x, y);
	return self;
}


- setBrushOrigin: (QPoint *) point
{
	qt_QPainter_setBrushOrigin1([self qt], [point qt]);
	return self;
}


- setViewXForm: (BOOL) yn
{
	qt_QPainter_setViewXForm([self qt], yn);
	return self;
}

		
- (BOOL) hasViewXForm
{
	return (BOOL) qt_QPainter_hasViewXForm([self qt]);
}


- (QRect *) window
{
	return (QRect *) [QObject objectForQtKey: qt_QPainter_window([self qt]) withClass: [QRect class]];
}

		
- setWindow: (QRect *) rect
{
	qt_QPainter_setWindow([self qt], [rect qt]);
	return self;
}

	
- setWindow: (int) x : (int) y : (int) w : (int) h
{
	qt_QPainter_setWindow1([self qt], x, y, w, h);
	return self;
}


- (QRect *) viewport
{
	return (QRect *) [QObject objectForQtKey: qt_QPainter_viewport([self qt]) withClass: [QRect class]];
}
		
- setViewport: (QRect *) rect
{
	qt_QPainter_setViewport([self qt], [rect qt]);
	return self;
}

	
- setViewport: (int) x : (int) y : (int) w : (int) h
{
	qt_QPainter_setViewport1([self qt], x, y, w, h);
	return self;
}


- setWorldXForm: (BOOL) yn
{
	qt_QPainter_setWorldXForm([self qt], yn);
	return self;
}

		
- (BOOL) hasWorldXForm
{
	return (BOOL) qt_QPainter_hasWorldXForm([self qt]);
}


- (QWMatrix *) worldMatrix
{
	return (QWMatrix *) [QObject objectForQtKey: qt_QPainter_worldMatrix([self qt])];
}

	
- setWorldMatrix: (QWMatrix *) matrix combine: (BOOL) yn
{
	qt_QPainter_setWorldMatrix([self qt], [(<QtSupport>) matrix qt], yn);
	return self;
}


- translate: (float) dx : (float) dy
{
	qt_QPainter_translate([self qt], dx, dy);
	return self;
}


- scale: (float) sx : (float) sy
{
	qt_QPainter_scale([self qt], sx, sy);
	return self;
}


- shear: (float) sh : (float) sv
{
	qt_QPainter_shear([self qt], sh, sv);
	return self;
}


- rotate: (float) a
{
	qt_QPainter_rotate([self qt], a);
	return self;
}



- resetXForm
{
	qt_QPainter_resetXForm([self qt]);
	return self;
}


- (QPoint *) xFormPoint: (QPoint *) point
{
//	return (QPoint *) [QObject objectForQtKey: qt_QPainter_xFormPoint([self qt], [point qt])];
	return nil;
}

	
- (QRect *) xFormRect: (QRect *) rect
{
//	return (QRect *) [QObject objectForQtKey: qt_QPainter_xFormRect([self qt], [rect qt])];
	return nil;
}


- (NSArray *) xFormArray: (NSArray *) array
{
//	return (NSArray *) qt_QPainter_xFormArray([self qt]);
	return nil;
}


- (NSArray *) xFormArray: (NSArray *) array index: (int) i npoints: (int) n
{
//	return (NSArray *) qt_QPainter_xFormArray([self qt]);
	return nil;
}



- (QPoint *) xFormDevPoint: (QPoint *) point
{
//	return (QPoint *) [QObject objectForQtKey: qt_QPainter_xFormDevPoint([self qt], [point qt])];
	return nil;
}


- (QRect *) xFormDevRect: (QRect *) rect
{
//	return (QRect *) [QObject objectForQtKey: qt_QPainter_xFormDevRect([self qt], [rect qt])];
	return nil;
}


- (NSArray *) xFormDevArray: (NSArray *) array
{
//	return (NSArray) qt_QPainter_xFormDevArray([self qt]);
	return nil;
}


- (NSArray *) xFormDevArray: (NSArray *) index: (int) i npoints: (int) n
{
//	return (NSArray) qt_QPainter_xFormDevArray([self qt]);
	return nil;
}



- setClipping: (BOOL) yn
{
	qt_QPainter_setClipping([self qt], yn);
	return self;
}

		
- (BOOL) hasClipping
{
	return (BOOL) qt_QPainter_hasClipping([self qt]);
}


- (QRegion *) clipRegion
{
	return (QRegion *) [QObject objectForQtKey: qt_QPainter_clipRegion([self qt]) withClass: [QRegion class]];
}


- setClipRect: (QRect *) rect
{
	qt_QPainter_setClipRect([self qt], [rect qt]);
	return self;
}

	
- setClipRect: (int) x : (int) y : (int) w : (int) h
{
	qt_QPainter_setClipRect1([self qt], x, y, w, h);
	return self;
}


- setClipRegion: (QRegion *) region
{
	qt_QPainter_setClipRegion([self qt], [region qt]);
	return self;
}



- drawPoint: (int) x : (int) y
{
	qt_QPainter_drawPoint([self qt], x, y);
	return self;
}


- drawPoint: (QPoint *) point
{
	qt_QPainter_drawPoint1([self qt], [point qt]);
	return self;
}


- drawPoints: (NSArray *) a index: (int) i npoints: (int) n
{
//	qt_QPainter_drawPoints([self qt]);
	return self;
}


- moveTo: (int) x : (int) y
{
	qt_QPainter_moveTo([self qt], x, y);
	return self;
}


- moveTo: (QPoint *) point
{
	qt_QPainter_moveTo1([self qt], [point qt]);
	return self;
}


- lineTo: (int) x : (int) y
{
	qt_QPainter_lineTo([self qt], x, y);
	return self;
}


- lineTo: (QPoint *) point
{
	qt_QPainter_lineTo1([self qt], [point qt]);
	return self;
}


- drawLineFrom: (int) x1 : (int) y1 to: (int) x2 : (int) y2
{
	qt_QPainter_drawLine([self qt], x1, y1, x2, y2);
	return self;
}


- drawLineFrom: (QPoint *) from to: (QPoint *) to
{
	qt_QPainter_drawLine1([self qt], [from qt], [to qt]);
	return self;
}


- drawRect: (int) x : (int) y : (int) w : (int) h
{
	qt_QPainter_drawRect([self qt], x, y, w, h);
	return self;
}


- drawRect: (QRect *) rect
{
	qt_QPainter_drawRect1([self qt], [rect qt]);
	return self;
}


- drawWinFocusRect: (int) x : (int) y : (int) w : (int) h
{
	qt_QPainter_drawWinFocusRect([self qt], x, y, w, h);
	return self;
}


- drawWinFocusRect: (int) x : (int) y : (int) w : (int) h color: (QColor *) bgColor
{
	qt_QPainter_drawWinFocusRect1([self qt], x, y, w, h, [bgColor qt]);
	return self;
}


- drawWinFocusRect: (QRect *) rect
{
	qt_QPainter_drawWinFocusRect2([self qt], [rect qt]);
	return self;
}


- drawWinFocusRect: (QRect *) color: (QColor *) bgColor
{
	qt_QPainter_drawWinFocusRect3([self qt], [color qt], [bgColor qt]);
	return self;
}


- drawRoundRect: (int) x : (int) y : (int) w : (int) h rect: (int) r length: (int) alen
{
	qt_QPainter_drawRoundRect([self qt], x, y, w, h, r, alen);
	return self;
}


- drawRoundRect: (QRect *) rect rect: (int) r length: (int) alen
{
	qt_QPainter_drawRoundRect1([self qt], [rect qt], r, alen);
	return self;
}


- drawEllipse: (int) x : (int) y : (int) w : (int) h
{
	qt_QPainter_drawEllipse([self qt], x, y, w, h);
	return self;
}


- drawEllipse: (QRect *) rect
{
	qt_QPainter_drawEllipse1([self qt], [rect qt]);
	return self;
}


- drawArc: (int) x : (int) y : (int) w : (int) h startAngle: (int) a arcLength: (int) alen
{
	qt_QPainter_drawArc([self qt], x, y, w, h, a, alen);
	return self;
}


- drawArc: (QRect *) rect startAngle: (int) a arcLength: (int) alen
{
	qt_QPainter_drawArc1([self qt], [rect qt], a, alen);
	return self;
}


- drawPie: (int) x : (int) y : (int) w : (int) h startAngle: (int) a arcLength: (int) alen
{
	qt_QPainter_drawPie([self qt], x, y, w, h, a, alen);
	return self;
}


- drawPie: (QRect *) rect startAngle: (int) a length: (int) alen
{
	qt_QPainter_drawPie1([self qt], [rect qt], a, alen);
	return self;
}


- drawChord: (int) x : (int) y : (int) w : (int) h startAngle: (int) a arcLength: (int) alen
{
	qt_QPainter_drawChord([self qt], x, y, w, h, a, alen);
	return self;
}


- drawChord: (QRect *)  rect startAngle: (int) a arcLength: (int) alen
{
	qt_QPainter_drawChord1([self qt], [rect qt], a, alen);
	return self;
}


- drawLineSegments: (NSArray *) segments index: (int) i nlines: (int) n
{
//	qt_QPainter_drawLineSegments([self qt]);
	return self;
}


- drawPolyline: (NSArray *) array index: (int) i npoints: (int) n
{
//	qt_QPainter_drawPolyline([self qt]);
	return self;
}


- drawPolygon: (NSArray *) winding: (BOOL) yn index: (int) i npoints: (int) n
{
//	qt_QPainter_drawPolygon([self qt]);
	return self;
}


- drawQuadBezier: (NSArray *) array index: (int) i
{
//	qt_QPainter_drawQuadBezier([self qt]);
	return self;
}


- drawPixmap: (int) x : (int) y map: (QPixmap *) map sx: (int) sx sy: (int) sy sw: (int) sw sh: (int) sh
{
	qt_QPainter_drawPixmap([self qt], x, y, [map qt], sx, sy, sw, sh);
	return self;
}


- drawPixmap: (QPoint *) point map: (QPixmap *) pixmap rect: (QRect *) sr
{
	qt_QPainter_drawPixmap1([self qt], [point qt], [pixmap qt], [sr qt]);
	return self;
}


- drawPixmap: (QPoint *) point map: (QPixmap *) map
{
	qt_QPainter_drawPixmap2([self qt], [point qt], [map qt]);
	return self;
}


- drawImage: (int) x : (int) y image: (QImage *) image sx: (int) sx sy: (int) sy sw: (int) sw sh: (int) sh
{
//	qt_QPainter_drawImage([self qt], x, y, [image qt], sx, sy, sw, sh);
	return self;
}


- drawImage: (QPoint *) point image: (QImage *) image rect: (QRect *) sr
{
//	qt_QPainter_drawImage1([self qt], [point qt], [image qt], [sr qt]);
	return self;
}


- drawImage: (QPoint *) point image: (QImage *) image
{
//	qt_QPainter_drawImage2([self qt], [point qt], [image qt]);
	return self;
}


- drawTiledPixmap: (int) x : (int) y : (int) w : (int) h map: (QPixmap *) map sx: (int) sx sy: (int) sy
{
//	qt_QPainter_drawTiledPixmap([self qt], x, y, w, h, [map qt], sx, sy);
	return self;
}


- drawTiledPixmap: (QRect *) rect map: (QPixmap *) map at: (QPoint *) point
{
//	qt_QPainter_drawTiledPixmap1([self qt], [rect qt], [map qt], [point qt]);
	return self;
}


- drawTiledPixmap: (QRect *) rect map: (QPixmap *) map
{
//	qt_QPainter_drawTiledPixmap2([self qt], [rect qt], [map qt]);
	return self;
}



- drawPicture: (QPicture *) picture
{
	qt_QPainter_drawPicture([self qt], [picture qt]);
	return self;
}



- fillRect: (int) x : (int) y : (int) w : (int) h brush: (QBrush *) brush
{
	qt_QPainter_fillRect([self qt], x, y, w, h, [brush qt]);
	return self;
}


- fillRect: (QRect *) rect brush: (QBrush *) brush
{
	qt_QPainter_fillRect1([self qt], [rect qt], [brush qt]);
	return self;
}


- eraseRect: (int) x : (int) y : (int) w : (int) h
{
	qt_QPainter_eraseRect([self qt], x, y, w, h);
	return self;
}


- eraseRect: (QRect *) rect
{
	qt_QPainter_eraseRect1([self qt],[rect qt]);
	return self;
}



- drawText: (int) x : (int) y text: (NSString *) str length: (int) len
{
	qt_QPainter_drawText([self qt], x, y, (char *) [str cString], len);
	return self;
}


- drawText: (QPoint *) point text: (NSString *) str length: (int) len
{
	qt_QPainter_drawText1([self qt], [point qt], (char *) [str cString], len);
	return self;
}


- drawText: (int) x : (int) y : (int) w : (int) h flags: (int) flags text: (NSString *) str length: (int) len breaks: (QRect *) br
{
	qt_QPainter_drawText2([self qt], x, y, w, h, flags, (char *) [str cString], len, [br qt], NULL);
	return self;
}


- drawText: (QRect *) rect flags: (int) flags text: (NSString *) str length: (int) len breaks: (QRect *) br
{
	qt_QPainter_drawText3([self qt], [rect qt], flags, (char *) [str cString], len, [br qt], NULL);
	return self;
}



- (QRect *) boundingRect: (int) x : (int) y : (int) w : (int) h flags: (int) flags text: (NSString *) str length: (int) length
{
	return (QRect *) [QObject objectForQtKey: qt_QPainter_boundingRect([self qt], x, y, w, h, flags, (char *) [str cString], length, NULL) withClass: [QRect class]];
}


- (QRect *) boundingRect: (QRect *) rect flags: (int) flags text: (NSString *) str length: (int) length
{
	return (QRect *) [QObject objectForQtKey: qt_QPainter_boundingRect1([self qt], [rect qt], flags, (char *) [str cString], length, NULL) withClass: [QRect class]];
}



- (int) tabStops
{
	return (int) qt_QPainter_tabStops([self qt]);
}


- setTabStops: (int) stops
{
	qt_QPainter_setTabStops([self qt], stops);
	return self;
}


- (NSArray *) tabArray
{
//	return (NSArray *) qt_QPainter_tabArray([self qt]);
	return nil;
}


- setTabArray: (NSArray *) tabArray
{
//	qt_QPainter_setTabArray([self qt]);
	return self;
}



- (HANDLE) handle
{
	return (HANDLE) qt_QPainter_handle([self qt]);
}



+ initialize
{
	qt_QPainter_initialize();
	return self;
}


+ cleanup
{
	qt_QPainter_cleanup();
	return self;
}

@end

