/***************************************************************************
                          QPalette.h  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QPALETTE_H
#define QPALETTE_H

#include <Foundation/NSObject.h>

#include <qtobjc/QColor.h>

/**
  *@author Richard Dale
  */

@interface QColorGroup : NSObject  <QtSupport>

- init;				
- init: (QColor *) foreground background: (QColor *) background light: (QColor *) light dark: (QColor *) dark mid: (QColor *) mid text: (QColor *) text base: (QColor *) base;
- (void) dealloc;
- (QColor *) foreground;
- (QColor *) background;
- (QColor *) light;
- (QColor *) midlight;
- (QColor *) dark;
- (QColor *) mid;
- (QColor *) text;
- (QColor *) base;

@end

@class QPalette;

@interface QPalette : NSObject  <QtSupport>

- init;
- initFromColor: (QColor *) background;
- initFromColorGroup: (QColorGroup *) normal disabled: (QColorGroup *) disabled active: (QColorGroup *) active;
- initFromPalette: (QPalette *) palette;
- (void) dealloc;

- copy;

- (QColorGroup *) normal;
- (QColorGroup *) disabled;
- (QColorGroup *) active;

- setNormal: (QColorGroup *) colorGroup;
- setDisabled: (QColorGroup *) colorGroup;
- setActive: (QColorGroup *) colorGroup;

- (BOOL) isCopyOf: (QPalette *) palette;
- (int) serialNumber;
@end

#endif
