/***************************************************************************
                          QPixmap.h  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QPIXMAP_H
#define QPIXMAP_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QPaintDevice.h>
#include <qtobjc/QSize.h>
#include <qtobjc/QWidget.h>
#include <qtobjc/QImage.h>

//	Optimization
#define NoOptim			0
#define NormalOptim		1
#define BestOptim			2

/**
  *@author Richard Dale
  */

@class QBitmap;

@interface QPixmap : QPaintDevice
- init;
- init: (int) w : (int) h  depth: (int) depth;
- init: (QSize *) size depth: (int) depth;
- initFromFile: (NSString *) fileName;
- initFromFile: (NSString *) fileName format: (NSString *) format mode: (int) mode;
- initFromFile: (NSString *) fileName format: (NSString *) format conversionFlags: (int) flags;
- initFromXpm: (char **) xpm;
- (void) dealloc;

- (BOOL) isNull;
+ (int)	defaultDepth;
- fill: (QColor *) fillColor;
- fill: (QWidget *) widget xofs: (int) xofs yofs: (int) yofs;
- fill: (QWidget *) widget ofs: (QPoint *) ofs;
- resize: (int) width : (int) height;
- resize: (QSize *) size;
- (QBitmap *) mask;
- setMask: (QBitmap *) mask;
- (BOOL) selfMask;
- (QBitmap *) createHeuristicMask: (BOOL) clipTight;

+ grabWindow: (int) windowId : (int) x : (int) y : (int) w : (int) h;

- (QPixmap *) xForm: (QWMatrix *) matrix;
+ (QWMatrix *) trueMatrix: (QWMatrix *) matrix : (int) w : (int) h;
- (QImage *) convertToImage;
- (BOOL) convertFromImage: (QImage *) image mode: (int) mode;
- (BOOL) convertFromImage: (QImage *) image conversionFlags: (int) flags;
+ (NSString *) imageFormat: (NSString *) fileName;
- (BOOL) load: (NSString *) fileName;
- (BOOL) load: (NSString *) fileName format: (NSString *) format mode: (int) mode;
- (BOOL) load: (NSString *) fileName format: (NSString *) format conversionFlags: (int) flags;
- (BOOL) loadFromData: (unsigned char *) buf length: (uint) len format: (NSString *) format mode: (int) mode;
- (BOOL) loadFromData: (unsigned char *) buf length: (uint) len format: (NSString *) format conversionFlags: (int) flags;
- (BOOL) loadFromData: (void *) data format: (NSString *) format conversionFlags: (int) flags;
- (BOOL) save: (NSString *) fileName format: (NSString *) format;
- (int) serialNumber;
- detach;
- (BOOL) isQBitmap;

@end

#endif
