/***************************************************************************
                          QPixmap.m  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QPixmap.h>

#include <qtc/qtc.h>

@implementation QPixmap

- init
{
	[super init];
	[self setQt: qt_new_QPixmap()];
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- init: (int) w : (int) h  depth: (int) depth
{
	[super init];
	[self setQt: qt_new_QPixmap1(w, h, depth)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- init: (QSize *) size depth: (int) depth
{
	[super init];
	[self setQt: qt_new_QPixmap2([size qt], depth)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- initFromFile: (NSString *) fileName
{
	[super init];
	[self setQt: qt_new_QPixmap3((char *) [fileName cString], 0, Auto)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}

- initFromFile: (NSString *) fileName format: (NSString *) format mode: (int) mode
{
	[super init];
	[self setQt: qt_new_QPixmap3((char *) [fileName cString], (char *) [format cString], mode)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- initFromFile: (NSString *) fileName format: (NSString *) format conversionFlags: (int) flags
{
	[super init];
	[self setQt: qt_new_QPixmap4((char *) [fileName cString], (char *) [format cString], flags)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}


- initFromXpm: (char **) xpm
{
	[super init];
	[self setQt: qt_new_QPixmap5(xpm)];	
	[QObject setObject: self forQtKey: [self qt]];
	return self;
}

- copyWithZone: (NSZone *) zone
{
	id	aCopy;

	aCopy = [[[self class] alloc] init];
	[aCopy setQt: qt_new_QPixmap6([self qt])];
	[QObject setObject: aCopy forQtKey: [aCopy qt]];
	
	return aCopy;	
}


- (void) dealloc
{
	[QObject removeQtKey: [self qt]];
	qt_del_QPixmap([self qt]);	
	[super dealloc];	
	return;
}


- (BOOL) isNull
{
	return (BOOL) qt_QPixmap_isNull([self qt]);
}


+ (int)	defaultDepth
{
	return (int) qt_QPixmap_defaultDepth();
}


- fill: (QColor *) fillColor
{
	qt_QPixmap_fill([self qt], [fillColor qt]);
	return self;
}


- fill: (QWidget *) widget xofs: (int) xofs yofs: (int) yofs
{
	qt_QPixmap_fill1([self qt], [widget qt], xofs, yofs);
	return self;
}


- fill: (QWidget *) widget ofs: (QPoint *) ofs
{
	qt_QPixmap_fill2([self qt], [widget qt], [ofs qt]);
	return self;
}


- resize: (int) width : (int) height
{
	qt_QPixmap_resize([self qt], width, height);
	return self;
}


- resize: (QSize *) size
{
	qt_QPixmap_resize1([self qt], [size qt]);
	return self;
}


- (QBitmap *) mask
{
	return (QBitmap *) [QObject objectForQtKey: qt_QPixmap_mask([self qt])];
}


- setMask: (QBitmap *) mask
{
	qt_QPixmap_setMask([self qt], [(<QtSupport>) mask qt]);
	return self;
}


- (BOOL) selfMask
{
	return (BOOL) qt_QPixmap_selfMask([self qt]);
}


- (QBitmap *) createHeuristicMask: (BOOL) clipTight
{
	return (QBitmap *) [QObject objectForQtKey: qt_QPixmap_createHeuristicMask([self qt], clipTight)];
}



+ grabWindow: (int) windowId : (int) x : (int) y : (int) w : (int) h
{
	qt_QPixmap_grabWindow(windowId, x, y, w, h);
	return self;
}



- (QPixmap *) xForm: (QWMatrix *) matrix
{
	return (QPixmap *) [QObject objectForQtKey: qt_QPixmap_xForm([self qt], [(<QtSupport>) matrix qt])];
}


+ (QWMatrix *) trueMatrix: (QWMatrix *) matrix : (int) w : (int) h
{
	return (QWMatrix *) [QObject objectForQtKey: qt_QPixmap_trueMatrix([(<QtSupport>) matrix qt], w, h)];
}


- (QImage *) convertToImage
{
	return (QImage *) [QObject objectForQtKey: qt_QPixmap_convertToImage([self qt])];
}


- (BOOL) convertFromImage: (QImage *) image mode: (int) mode
{
	return (BOOL) qt_QPixmap_convertFromImage([self qt], [image qt], mode);
}


- (BOOL) convertFromImage: (QImage *) image conversionFlags: (int) flags
{
	return (BOOL) qt_QPixmap_convertFromImage1([self qt], [image qt], flags);
}


+ (NSString *) imageFormat: (NSString *) fileName
{
	return (NSString *) [NSString stringWithCString: qt_QPixmap_imageFormat((char *) [fileName cString])];
}


- (BOOL) load: (NSString *) fileName
{
	return (BOOL) qt_QPixmap_load([self qt], (char *) [fileName cString], NULL, 0);
}

- (BOOL) load: (NSString *) fileName format: (NSString *) format mode: (int) mode
{
	return (BOOL) qt_QPixmap_load([self qt], (char *) [fileName cString], (char *) [format cString], mode);
}


- (BOOL) load: (NSString *) fileName format: (NSString *) format conversionFlags: (int) flags
{
	return (BOOL) qt_QPixmap_load1([self qt], (char *) [fileName cString], (char *) [format cString], flags);
}


- (BOOL) loadFromData: (unsigned char *) buf length: (uint) len format: (NSString *) format mode: (int) mode
{
	return (BOOL) qt_QPixmap_loadFromData([self qt], buf, len, (char *) [format cString], mode);
}


- (BOOL) loadFromData: (unsigned char *) buf length: (uint) len format: (NSString *) format conversionFlags: (int) flags
{
	return (BOOL) qt_QPixmap_loadFromData1([self qt], buf, len, (char *) [format cString], flags);
}


- (BOOL) loadFromData: (void *) data format: (NSString *) format conversionFlags: (int) flags
{
//	return (BOOL) qt_QPixmap_loadFromData2([self qt], data, (char *) [format cString], flags);
	return NO;
}


- (BOOL) save: (NSString *) fileName format: (NSString *) format
{
	return (BOOL) qt_QPixmap_save([self qt], (char *) [fileName cString], (char *) [format cString]);
}


- (int) serialNumber
{
	return (int) qt_QPixmap_serialNumber([self qt]);
}

- detach
{
	qt_QPixmap_detach([self qt]);
	return self;
}


- (BOOL) isQBitmap
{
	return (BOOL) qt_QPixmap_isQBitmap([self qt]);
}

@end

