/***************************************************************************
                          QPrinter.h  -  description
                             -------------------
    begin                : Fri Mar 24 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QPRINTER_H
#define QPRINTER_H

#include <Foundation/NSObject.h>
#include <qtobjc/QPaintDevice.h>
#include <qtobjc/QWidget.h>

#define Orientation			int
#define Portrait				0
#define Landscape				1

#define PageSize    			int
#define A4                    0
#define B5                    1
#define Letter                2
#define Legal                 3
#define Executive             4
#define A0                    5
#define A1                    6
#define A2                    7
#define A3                    8
#define A5                    9
#define A6                    10
#define A7                    11
#define A8                    12
#define A9                    13
#define B0                    14
#define B1                    15
#define B10                   16
#define B2                    17
#define B3                    18
#define B4                    19
#define B6                    20
#define B7                    21
#define B8                    22
#define B9                    23
#define C5E                   24
#define Comm10E               25
#define DLE                   26
#define Folio                 27
#define Ledger                28
#define Tabloid               29

#define PageOrder			int
#define FirstPageFirst	0
#define LastPageFirst		1

#undef GrayScale

#define ColorMode			int
#define GrayScale			0
#define Color			1

/**
  *@author Richard Dale
  */

@interface QPrinter : QPaintDevice
- init;
- (void) dealloc;

- (NSString *) printerName;
- setPrinterName: (NSString *) name;
- (BOOL) outputToFile;
- setOutputToFile: (BOOL) yn;
- (NSString *) outputFileName;
- setOutputFileName: (NSString *) name;
- (NSString *) printProgram;
- setPrintProgram: (NSString *) program;
- (NSString *) docName;
- setDocName: (NSString *) name;
- (NSString *) creator;
- setCreator: (NSString *) creator;
- (Orientation) orientation;
- setOrientation: (Orientation) orientation;
- (PageSize) pageSize;
- setPageSize: (PageSize) size;
- setPageOrder: (PageOrder) order;
- (PageOrder) pageOrder;
- setColorMode: (ColorMode) mode;
- (ColorMode) colorMode;
- (int) fromPage;
- (int) toPage;
- setFrom: (int) fromPage to: (int) toPage;
- (int) minPage;
- (int) maxPage;
- setMin: (int) minPage max: (int) maxPage;
- (int) numCopies;
- setNumCopies: (int) number;
- (BOOL) newPage;
- (BOOL) abort;
- (BOOL) aborted;
- (BOOL) setup: (QWidget *) parent;
@end

#endif
