/***************************************************************************
                          QPrinter.m  -  description
                             -------------------
    begin                : Fri Mar 24 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtc/qtc.h>
#include <qtobjc/QPrinter.h>

@implementation QPrinter

- init
{
	[super init];
	[self setQt: qt_new_QPrinter()];	
	return self;
}


- (void) dealloc
{
	qt_del_QPrinter([self qt]);	
	[super dealloc];	
	return;
}



- (NSString *) printerName
{
	return (NSString *) [NSString stringWithCString: qt_QPrinter_printerName([self qt])];
}


- setPrinterName: (NSString *) name
{
	qt_QPrinter_setPrinterName([self qt], (char *) [name cString]);
	return self;
}


- (BOOL) outputToFile
{
	return (BOOL) qt_QPrinter_outputToFile([self qt]);
}


- setOutputToFile: (BOOL) yn
{
	qt_QPrinter_setOutputToFile([self qt], yn);
	return self;
}


- (NSString *) outputFileName
{
	return (NSString *) [NSString stringWithCString: qt_QPrinter_outputFileName([self qt])];
}


- setOutputFileName: (NSString *) name
{
	qt_QPrinter_setOutputFileName([self qt], (char *) [name cString]);
	return self;
}


- (NSString *) printProgram
{
	return (NSString *) [NSString stringWithCString: qt_QPrinter_printProgram([self qt])];
}


- setPrintProgram: (NSString *) program
{
	qt_QPrinter_setPrintProgram([self qt], (char *) [program cString]);
	return self;
}


- (NSString *) docName
{
	return (NSString *) [NSString stringWithCString: qt_QPrinter_docName([self qt])];
}


- setDocName: (NSString *) name
{
	qt_QPrinter_setDocName([self qt], (char *) [name cString]);
	return self;
}


- (NSString *) creator
{
	return (NSString *) [NSString stringWithCString: qt_QPrinter_creator([self qt])];
}


- setCreator: (NSString *) creator
{
	qt_QPrinter_setCreator([self qt], (char *) [creator cString]);
	return self;
}


- (Orientation) orientation
{
	return (Orientation) qt_QPrinter_orientation([self qt]);
}


- setOrientation: (Orientation) orientation
{
	qt_QPrinter_setOrientation([self qt], orientation);
	return self;
}


- (PageSize) pageSize
{
	return (PageSize) qt_QPrinter_pageSize([self qt]);
}


- setPageSize: (PageSize) size
{
	qt_QPrinter_setPageSize([self qt], size);
	return self;
}


- setPageOrder: (PageOrder) order
{
//	qt_QPrinter_setPageOrder([self qt], order);
	return self;
}


- (PageOrder) pageOrder
{
//	return (PageOrder) qt_QPrinter_pageOrder([self qt]);
	return 0;
}


- setColorMode: (ColorMode) mode
{
//	qt_QPrinter_setColorMode([self qt], mode);
	return self;
}


- (ColorMode) colorMode
{
//	return (ColorMode) qt_QPrinter_colorMode([self qt]);
	return 0;
}


- (int) fromPage
{
	return (int) qt_QPrinter_fromPage([self qt]);
}


- (int) toPage
{
	return (int) qt_QPrinter_toPage([self qt]);
}


- setFrom: (int) fromPage to: (int) toPage
{
	qt_QPrinter_setFromTo([self qt], fromPage, toPage);
	return self;
}


- (int) minPage
{
	return (int) qt_QPrinter_minPage([self qt]);
}


- (int) maxPage
{
	return (int) qt_QPrinter_maxPage([self qt]);
}


- setMin: (int) minPage max: (int) maxPage
{
	qt_QPrinter_setMinMax([self qt], minPage, maxPage);
	return self;
}


- (int) numCopies
{
	return (int) qt_QPrinter_numCopies([self qt]);
}


- setNumCopies: (int) copies
{
	qt_QPrinter_setNumCopies([self qt], copies);
	return self;
}


- (BOOL) newPage
{
	return (BOOL) qt_QPrinter_newPage([self qt]);
}


- (BOOL) abort
{
	return (BOOL) qt_QPrinter_abort([self qt]);
}


- (BOOL) aborted
{
	return (BOOL) qt_QPrinter_aborted([self qt]);
}


- (BOOL) setup: (QWidget *) parent
{
	return (BOOL) qt_QPrinter_setup([self qt], [parent qt]);
}

@end

