/***************************************************************************
                          QProgressBar.m  -  description
                             -------------------
    begin                : Fri Apr 14 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QProgressBar.h>
#include <qtobjc/QPainter.h>
#include <qtc/qtc.h>

@implementation QProgressBar

- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f
{
	[self setQt: qt_new_QProgressBar([parent qt], (char *) [name cString], f)];
	[super init];	
	return self;
}


- initWithSteps: (int) totalSteps parent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f
{
	[self setQt: qt_new_QProgressBar1(totalSteps, [parent qt], (char *) [name cString], f)];	
	return self;
}


- (int) totalSteps
{
	return (int) qt_QProgressBar_totalSteps([self qt]);
}


- (int) progress
{
	return (int) qt_QProgressBar_progress([self qt]);
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: qt_QProgressBar_sizeHint([self qt]) withClass: [QSize class]];
}


- show
{
	qt_QProgressBar_show([self qt]);
	return self;
}


- reset
{
	qt_QProgressBar_reset([self qt]);
	return self;
}


- setTotalSteps: (int) totalSteps
{
	qt_QProgressBar_setTotalSteps([self qt], totalSteps);
	return self;
}


- setProgress: (int) progress
{
	qt_QProgressBar_setProgress([self qt], progress);
	return self;
}

@end

