/***************************************************************************
                          QPushButton.h  -  description
                             -------------------
    begin                : Mon Mar 20 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QPUSHBUTTON_H
#define QPUSHBUTTON_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QButton.h>
#include <qtobjc/QSize.h>
#include <qtobjc/QPoint.h>
#include <qtobjc/QRect.h>

/**
  *@author Richard Dale
  */

@interface QPushButton : QButton
- initWithParent: (QWidget *) parent name: (NSString *) name;
- initWithText: (NSString *) text parent: (QWidget *) parent;
- initWithText: (NSString *) text parent: (QWidget *) parent name: (NSString *) name;

- setToggleButton: (BOOL) yn;
- setAutoDefault: (BOOL) autoDef;
- setDefault: (BOOL) def;
- setIsMenuButton: (BOOL) yn;
- (BOOL) isMenuButton;
- (QSize *) sizeHint;
- move: (int) x : (int) y;
- move: (QPoint *) p;
- resize: (int) w : (int) h;
- resize: (QSize *) size;
- setGeometry: (int) x : (int) y : (int) w : (int) h;
- setGeometry: (QRect *) rect;
- setOn: (BOOL) yn;
- toggle;

@end

#endif
