/***************************************************************************
                          QPushButton.m  -  description
                             -------------------
    begin                : Mon Mar 20 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QPushButton.h>
#include <qtc/qtc.h>

@implementation QPushButton

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[super init];
	[self setQt: qt_new_QPushButton([parent qt], (char *) [name cString])];
	return self;
}


- initWithText: (NSString *) text parent: (QWidget *) parent
{
	[super init];
	[self setQt: qt_new_QPushButton1((char *) [text cString], [parent qt], (char *) NULL)];
	return self;
}


- initWithText: (NSString *) text parent: (QWidget *) parent name: (NSString *) name
{
	[super init];
	[self setQt: qt_new_QPushButton1((char *) [text cString], [parent qt], (char *) [name cString])];
	return self;
}


- setToggleButton: (BOOL) yn
{
	qt_QPushButton_setToggleButton([self qt], yn);
	return self;
}


- setAutoDefault: (BOOL) autoDef
{
	qt_QPushButton_setAutoDefault([self qt], autoDef);
	return self;
}


- setDefault: (BOOL) def
{
	qt_QPushButton_setDefault([self qt], def);
	return self;
}


- setIsMenuButton: (BOOL) yn
{
//	qt_QPushButton_setIsMenuButton([self qt], yn);
	return self;
}


- (BOOL) isMenuButton
{
//	return (BOOL) qt_QPushButton_isMenuButton([self qt]);
	return NO;
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: (void *) qt_QPushButton_sizeHint([self qt])];
}


- move: (int) x : (int) y
{
	qt_QPushButton_move([self qt], x, y);
	return self;
}


- move: (QPoint *) p
{
	qt_QPushButton_move1([self qt], [p qt]);
	return self;
}


- resize: (int) w : (int) h
{
	qt_QPushButton_resize([self qt], w, h);
	return self;
}


- resize: (QSize *) size
{
	qt_QPushButton_resize1([self qt], [size qt]);
	return self;
}


- setGeometry: (int) x : (int) y : (int) w : (int) h
{
	qt_QPushButton_setGeometry([self qt], x, y, w, h);
	return self;
}


- setGeometry: (QRect *) rect
{
	qt_QPushButton_setGeometry1([self qt], [rect qt]);
	return self;
}


- setOn: (BOOL) yn
{
	qt_QPushButton_setOn([self qt], yn);
	return self;
}


- toggle
{
	qt_QPushButton_toggle([self qt]);
	return self;
}

@end

