/***************************************************************************
                          QRangeControl.h  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QRANGECONTROL_H
#define QRANGECONTROL_H

#include <Foundation/NSObject.h>

/**
  *@author Richard Dale
  */

@protocol QRangeControlInterface
- (int) value;
- setValue: (int) value;
- addPage;
- subtractPage;
- addLine;
- subtractLine;
- (int) minValue;
- (int) maxValue;
- setRangeMinValue: (int) minValue maxValue: (int) maxValue;
- (int) lineStep;
- (int) pageStep;
- setLineStep: (int) line pageStep: (int) page;
@end

@interface QRangeControl : NSObject <QRangeControlInterface>
{
@private
	void *	_qt;
}
- init;
- initWithMinValue: (int) minValue maxValue: (int) maxValue lineStep: (int) lineStep pageStep: (int) pageStep value: (int) value;
@end

#endif
