/***************************************************************************
                          QRangeControl.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QRangeControl.h>
#include <qtc/qtc.h>

@implementation QRangeControl

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}

- init
{
	[self setQt: qt_new_QRangeControl()];
	[super init];	
	return self;
}


- initWithMinValue: (int) minValue maxValue: (int) maxValue lineStep: (int) lineStep pageStep: (int) pageStep value: (int) value
{
	[self setQt: qt_new_QRangeControl1(minValue, maxValue, lineStep, pageStep, value)];	
	[super init];	
	return self;
}


- (int) value
{
	return (int) qt_QRangeControl_value([self qt]);
}


- setValue: (int) value
{
	qt_QRangeControl_setValue([self qt], value);
	return self;
}


- addPage
{
	qt_QRangeControl_addPage([self qt]);
	return self;
}


- subtractPage
{
	qt_QRangeControl_subtractPage([self qt]);
	return self;
}


- addLine
{
	qt_QRangeControl_addLine([self qt]);
	return self;
}


- subtractLine
{
	qt_QRangeControl_subtractLine([self qt]);
	return self;
}


- (int) minValue
{
	return (int) qt_QRangeControl_minValue([self qt]);
}


- (int) maxValue
{
	return (int) qt_QRangeControl_maxValue([self qt]);
}


- setRangeMinValue: (int) minValue maxValue: (int) maxValue
{
	qt_QRangeControl_setRange([self qt], minValue, maxValue);
	return self;
}


- (int) lineStep
{
	return (int) qt_QRangeControl_lineStep([self qt]);
}


- (int) pageStep
{
	return (int) qt_QRangeControl_pageStep([self qt]);
}


- setLineStep: (int) line pageStep: (int) page
{
	qt_QRangeControl_setSteps([self qt], line, page);
	return self;
}

@end

