/***************************************************************************
                          QRect.h  -  description
                             -------------------
    begin                : Wed Mar 8 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QRECT_H
#define QRECT_H

#include <Foundation/NSObject.h>

#include <qtobjc/QtSupport.h>
#include <qtobjc/QPoint.h>
#include <qtobjc/QSize.h>

/**
  *@author Richard Dale
  */

@interface QRect : NSObject <QtSupport>

- init;
- initTopLeft: (QPoint *) topleft bottomRight: (QPoint *) bottomright;
- initTopLeft: (QPoint *) topleft size: (QSize *) size;
- initLeft: (int) left top: (int) top width: (int) width height: (int) height;
- (BOOL) isNull;
- (BOOL) isEmpty;
- (BOOL) isValid;
- normalize;
- (int) left;
- (int) top;
- (int) right;
- (int) bottom;
- (int) x;
- (int) y;
- setLeft: (int) pos;
- setTop: (int) pos;
- setRight: (int) pos;
- setBottom: (int) pos;
- setX: (int) x;
- setY: (int) y;
- (QPoint *) topLeft;
- (QPoint *) bottomRight;
- (QPoint *) topRight;
- (QPoint *) bottomLeft;
- (QPoint *) center;
- rect: (int *) x : (int *) y : (int *) w : (int *)h;
- coords: (int *) x1 : (int *) y1 : (int *) x2 : (int *) y2;
- moveTopLeft: (QPoint *) p;
- moveBottomRight: (QPoint *) p;
- moveTopRight: (QPoint *) p;
- moveBottomLeft: (QPoint *) p;
- moveCenter: (QPoint *) p;
- moveBy: (int) dx : (int) dy;
- setRect: (int) x : (int) y : (int) w : (int) h;
- setCoords: (int) x1 : (int) y1 : (int) x2 : (int) y2;
- (QSize) size;
- (int) width;
- (int) height;
- setWidth: (int) w;
- setHeight: (int) h;
- setSize: (QSize *) s;
- (BOOL) containsPoint: (QPoint *) p proper: (BOOL) proper;
- (BOOL) containsRect: (QRect *) r proper: (BOOL) proper;
- (QRect *) unite: (QRect *) r;
- (QRect *) intersect: (QRect *) r;
- (BOOL) intersects: (QRect *) r;

@end

#endif
