/***************************************************************************
                          QScrollBar.h  -  description
                             -------------------
    begin                : Thu Mar 30 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QSCROLLBAR_H
#define QSCROLLBAR_H

#include <Foundation/NSObject.h>
#include <qtobjc/QWidget.h>
#include <qtobjc/QPalette.h>
#include <qtobjc/QRangeControl.h>


#define Orientation		int
#define Horizontal		0
#define Vertical			1

/**
  *@author Richard Dale
  */

@interface QScrollBar : QWidget
- initWithParent: (QWidget *) parent name: (NSString *) name;
- initWithOrientation: (Orientation) orientation parent: (QWidget *)parent name: (NSString * )name;
- initMinValue: (int) minValue maxValue: (int) maxValue lineStep: (int) LineStep pageStep: (int) PageStep value: (int) value orientation: (Orientation) orientation parent: (QWidget *) parent name: (NSString *) name;
- setOrientation: (Orientation) orientation;
- (Orientation) orientation;
- setTracking: (BOOL) enable;
- (BOOL) tracking;
- (BOOL) draggingSlider;
- setPalette: (QPalette *) palette;
- (QSize *) sizeHint;
@end

@interface QScrollBar (QRangeControlImplementation) <QRangeControlInterface>
@end

#endif
