/***************************************************************************
                          QScrollBar.m  -  description
                             -------------------
    begin                : Thu Mar 30 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QScrollBar.h>
#include <qtc/qtc.h>

@implementation QScrollBar

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QScrollBar([parent qt], (char *) [name cString])];	
	return self;
}


- initWithOrientation: (Orientation) orientation parent: (QWidget *)parent name: (NSString * )name
{
	[self setQt: qt_new_QScrollBar1(orientation, [parent qt], (char *) [name cString])];
	return self;
}


- initMinValue: (int) minValue maxValue: (int) maxValue lineStep: (int) LineStep pageStep: (int) PageStep value: (int) value orientation: (Orientation) orientation parent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QScrollBar2(minValue, maxValue, LineStep, PageStep, value, orientation, [parent qt], (char *) [name cString])];	
	return self;
}


- setOrientation: (Orientation) orientation
{
	qt_QScrollBar_setOrientation([self qt], orientation);
	return self;
}


- (Orientation) orientation
{
	return (Orientation) qt_QScrollBar_orientation([self qt]);
}


- setTracking: (BOOL) enable
{
	qt_QScrollBar_setTracking([self qt], enable);
	return self;
}


- (BOOL) tracking
{
	return (BOOL) qt_QScrollBar_tracking([self qt]);
}


- (BOOL) draggingSlider
{
	return (BOOL) qt_QScrollBar_draggingSlider([self qt]);
}


- setPalette: (QPalette *) palette
{
	qt_QScrollBar_setPalette([self qt], [palette qt]);
	return self;
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: qt_QScrollBar_sizeHint([self qt]) withClass: [QSize class]];
}

@end

@implementation QScrollBar (QRangeControlImplementation)

- (int) value
{
	return (int) qt_QRangeControl_value(qt_QScrollBar_QRangeControl([self qt]));
}


- setValue: (int) value
{
	qt_QRangeControl_setValue(qt_QScrollBar_QRangeControl([self qt]), value);
	return self;
}


- addPage
{
	qt_QRangeControl_addPage(qt_QScrollBar_QRangeControl([self qt]));
	return self;
}


- subtractPage
{
	qt_QRangeControl_subtractPage(qt_QScrollBar_QRangeControl([self qt]));
	return self;
}


- addLine
{
	qt_QRangeControl_addLine(qt_QScrollBar_QRangeControl([self qt]));
	return self;
}


- subtractLine
{
	qt_QRangeControl_subtractLine(qt_QScrollBar_QRangeControl([self qt]));
	return self;
}


- (int) minValue
{
	return (int) qt_QRangeControl_minValue(qt_QScrollBar_QRangeControl([self qt]));
}


- (int) maxValue
{
	return (int) qt_QRangeControl_maxValue(qt_QScrollBar_QRangeControl([self qt]));
}


- setRangeMinValue: (int) minValue maxValue: (int) maxValue
{
	qt_QRangeControl_setRange(qt_QScrollBar_QRangeControl([self qt]), minValue, maxValue);
	return self;
}


- (int) lineStep
{
	return (int) qt_QRangeControl_lineStep(qt_QScrollBar_QRangeControl([self qt]));
}


- (int) pageStep
{
	return (int) qt_QRangeControl_pageStep(qt_QScrollBar_QRangeControl([self qt]));
}


- setLineStep: (int) line pageStep: (int) page
{
	qt_QRangeControl_setSteps(qt_QScrollBar_QRangeControl([self qt]), line, page);
	return self;
}

@end
