/***************************************************************************
                          QScrollView.h  -  description
                             -------------------
    begin                : Thu Mar 30 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QSCROLLVIEW_H
#define QSCROLLVIEW_H

#include <Foundation/NSObject.h>

#include <qtobjc/QFrame.h>
#include <qtobjc/QScrollBar.h>

#define ResizePolicy		int
#undef Default
#undef Manual
#define Default			0
#define Manual			1
#define AutoOne			2

#define ScrollBarMode		int
#define Auto 			0
#define AlwaysOff			1
#define AlwaysOn 			2

/**
  *@author Richard Dale
  */

@interface QScrollView : QFrame

- initWithParent: (QWidget *) parent;
- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f;
- (void) dealloc;

- setResizePolicy: (ResizePolicy) policy;
- (ResizePolicy) resizePolicy;
- addChild: (QWidget *) child;
- removeChild: (QWidget *) child;
- addChild: (QWidget *) child : (int) x : (int) y;
- moveChild: (QWidget *) child : (int) x : (int) y;
- (int) childX: (QWidget *) child;
- (int) childY: (QWidget *) child;
- (BOOL) childIsVisible: (QWidget *) child;
- showChild: (QWidget*) child yes: (BOOL) yes;
- (ScrollBarMode) vScrollBarMode;
- setVScrollBarMode: (ScrollBarMode) mode;
- (ScrollBarMode) hScrollBarMode;
- setHScrollBarMode: (ScrollBarMode) mode;
- (QWidget *) cornerWidget;
- setCornerWidget: (QWidget*) widget;
- (QScrollBar *) horizontalScrollBar;
- (QScrollBar *) verticalScrollBar;
- (QWidget *) viewport;
- (int) contentsWidth;
- (int) contentsHeight;
- (int) contentsX;
- (int) contentsY;
- resize: (int) w : (int) h;
- resize: (QSize *) size;
- show;

@end

#endif
