/***************************************************************************
                          QScrollView.m  -  description
                             -------------------
    begin                : Thu Mar 30 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QScrollView.h>
#include <qtc/qtc.h>

@implementation QScrollView

- initWithParent: (QWidget *) parent
{
	[self setQt: qt_new_QScrollView([parent qt], (char *) NULL, 0)];	
	return self;
}

- initWithParent: (QWidget *) parent name: (NSString *) name flags: (WFlags) f
{
	[self setQt: qt_new_QScrollView([parent qt], (char *) [name cString], f)];	
	return self;
}


- (void) dealloc
{
	qt_del_QScrollView([self qt]);	
	[super dealloc];	
	return;
}



- setResizePolicy: (ResizePolicy) policy
{
	qt_QScrollView_setResizePolicy([self qt], policy);
	return self;
}


- (ResizePolicy) resizePolicy
{
	return (ResizePolicy) qt_QScrollView_resizePolicy([self qt]);
}


- addChild: (QWidget *) child
{
	qt_QScrollView_addChild([self qt], [child qt]);
	return self;
}


- removeChild: (QWidget *) child
{
	qt_QScrollView_removeChild([self qt], [child qt]);
	return self;
}


- addChild: (QWidget *) child : (int) x : (int) y
{
	qt_QScrollView_addChild1([self qt], [child qt], x, y);
	return self;
}


- moveChild: (QWidget *) child : (int) x : (int) y
{
	qt_QScrollView_moveChild([self qt], [child qt], x, y);
	return self;
}


- (int) childX: (QWidget *) child
{
	return (int) qt_QScrollView_childX([self qt], [child qt]);
}


- (int) childY: (QWidget *) child
{
	return (int) qt_QScrollView_childY([self qt], [child qt]);
}


- (BOOL) childIsVisible: (QWidget *) child
{
	return (BOOL) qt_QScrollView_childIsVisible([self qt], [child qt]);
}


- showChild: (QWidget*) child yes: (BOOL) yn
{
	qt_QScrollView_showChild([self qt], [child qt], yn);
	return self;
}


- (ScrollBarMode) vScrollBarMode
{
	return (ScrollBarMode) qt_QScrollView_vScrollBarMode([self qt]);
}


- setVScrollBarMode: (ScrollBarMode) mode
{
	qt_QScrollView_setVScrollBarMode([self qt], mode);
	return self;
}


- (ScrollBarMode) hScrollBarMode
{
	return (ScrollBarMode) qt_QScrollView_hScrollBarMode([self qt]);
}


- setHScrollBarMode: (ScrollBarMode) mode
{
	qt_QScrollView_setHScrollBarMode([self qt], mode);
	return self;
}


- (QWidget *) cornerWidget
{
	return (QWidget *) [QObject objectForQtKey: qt_QScrollView_cornerWidget([self qt])];
}


- setCornerWidget: (QWidget*) widget
{
	qt_QScrollView_setCornerWidget([self qt], [widget qt]);
	return self;
}


- (QScrollBar *) horizontalScrollBar
{
	return (QScrollBar *) [QObject objectForQtKey: qt_QScrollView_horizontalScrollBar([self qt])];
}


- (QScrollBar *) verticalScrollBar
{
	return (QScrollBar *) [QObject objectForQtKey: qt_QScrollView_verticalScrollBar([self qt])];
}


- (QWidget *) viewport
{
	return (QWidget *) [QObject objectForQtKey: qt_QScrollView_viewport([self qt])];
}


- (int) contentsWidth
{
	return (int) qt_QScrollView_contentsWidth([self qt]);
}


- (int) contentsHeight
{
	return (int) qt_QScrollView_contentsHeight([self qt]);
}


- (int) contentsX
{
	return (int) qt_QScrollView_contentsX([self qt]);
}


- (int) contentsY
{
	return (int) qt_QScrollView_contentsY([self qt]);
}


- resize: (int) w : (int) h
{
	qt_QScrollView_resize([self qt], w, h);
	return self;
}


- resize: (QSize *) size
{
	qt_QScrollView_resize1([self qt], [size qt]);
	return self;
}


- show
{
	qt_QScrollView_show([self qt]);
	return self;
}

@end

