/***************************************************************************
                          QSlider.h  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QSLIDER_H
#define QSLIDER_H

#include <Foundation/NSObject.h>
#include <Foundation/NSString.h>

#include <qtobjc/QWidget.h>
#include <qtobjc/QRangeControl.h>
#include <qtobjc/QSize.h>
#include <qtobjc/QRect.h>

#define Orientation	int
#define Horizontal	0
#define Vertical		1

#undef Above
#undef Below

#define TickSetting	int
#define NoMarks		0
#define Above		1
#define Left			Above
#define Below		2
#define Right		Below
#define Both			3

/**
  *@author Richard Dale
  */

@interface QSlider : QWidget
- initWithParent: (QWidget *) parent name: (NSString *) name;
- initWithOrientation: (Orientation) orientation parent: (QWidget *) parent name: (NSString *) name;
- initWithMinValue: (int) minValue maxValue: (int) maxValue step: (int) pageStep initial: (int) value orientation: (Orientation) orientation parent: (QWidget *) parent;
- initWithMinValue: (int) minValue maxValue: (int) maxValue step: (int) pageStep initial: (int) value orientation: (Orientation) orientation parent: (QWidget *) parent name: (NSString *)name;
- setOrientation: (Orientation) orientation;
- (Orientation) orientation;
- setTracking: (BOOL) enable;
- (BOOL) tracking;
- setPalette: (QPalette *) palette;
- (QRect *) sliderRect;
- (QSize *) sizeHint;
- setTickmarks: (TickSetting) tickSetting;
- setTickInterval: (int) interval;
- setValue: (int) value;
- addStep;
- subtractStep;
@end

@interface QSlider (QRangeControlImplementation) <QRangeControlInterface>
@end

#endif
