/***************************************************************************
                          QSlider.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QSlider.h>

#undef Above
#undef Below
#include <qtc/qtc.h>


@implementation QSlider

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QSlider([parent qt], (char *) [name cString])];	
	return self;
}


- initWithOrientation: (Orientation) orientation parent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QSlider1(orientation, [parent qt], (char *) [name cString])];	
	return self;
}


- initWithMinValue: (int) minValue maxValue: (int) maxValue step: (int) pageStep initial: (int) value orientation: (Orientation) orientation parent: (QWidget *) parent
{
	return [self initWithMinValue: minValue maxValue: maxValue step: pageStep initial: value orientation: orientation parent: parent name: @""];
}

- initWithMinValue: (int) minValue maxValue: (int) maxValue step: (int) pageStep initial: (int) value orientation: (Orientation) orientation parent: (QWidget *) parent name: (NSString *)name
{
	[self setQt: qt_new_QSlider2(minValue, maxValue, pageStep, value, orientation, [parent qt], (char *) [name cString])];	
	return self;
}


- setOrientation: (Orientation) orientation
{
	qt_QSlider_setOrientation([self qt], orientation);
	return self;
}


- (Orientation) orientation
{
	return (Orientation) qt_QSlider_orientation([self qt]);
}


- setTracking: (BOOL) enable
{
	qt_QSlider_setTracking([self qt], enable);
	return self;
}


- (BOOL) tracking
{
	return (BOOL) qt_QSlider_tracking([self qt]);
}


- setPalette: (QPalette *) palette
{
	qt_QSlider_setPalette([self qt], [palette qt]);
	return self;
}


- (QRect *) sliderRect
{
	return (QRect *) [QObject objectForQtKey: qt_QSlider_sliderRect([self qt]) withClass: [QRect class]];
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: qt_QSlider_sizeHint([self qt]) withClass: [QSize class]];
}


- setTickmarks: (TickSetting) tickSetting
{
	qt_QSlider_setTickmarks([self qt], tickSetting);
	return self;
}


- setTickInterval: (int) interval
{
	qt_QSlider_setTickInterval([self qt], interval);
	return self;
}


- setValue: (int) value
{
	qt_QSlider_setValue([self qt], value);
	return self;
}


- addStep
{
	qt_QSlider_addStep([self qt]);
	return self;
}


- subtractStep
{
	qt_QSlider_subtractStep([self qt]);
	return self;
}

@end

@implementation QSlider (QRangeControlImplementation)

- (int) value
{
	return (int) qt_QRangeControl_value(qt_QSlider_QRangeControl([self qt]));
}


- setValue: (int) value
{
	qt_QRangeControl_setValue(qt_QSlider_QRangeControl([self qt]), value);
	return self;
}


- addPage
{
	qt_QRangeControl_addPage(qt_QSlider_QRangeControl([self qt]));
	return self;
}


- subtractPage
{
	qt_QRangeControl_subtractPage(qt_QSlider_QRangeControl([self qt]));
	return self;
}


- addLine
{
	qt_QRangeControl_addLine(qt_QSlider_QRangeControl([self qt]));
	return self;
}


- subtractLine
{
	qt_QRangeControl_subtractLine(qt_QSlider_QRangeControl([self qt]));
	return self;
}


- (int) minValue
{
	return (int) qt_QRangeControl_minValue(qt_QSlider_QRangeControl([self qt]));
}


- (int) maxValue
{
	return (int) qt_QRangeControl_maxValue(qt_QSlider_QRangeControl([self qt]));
}


- setRangeMinValue: (int) minValue maxValue: (int) maxValue
{
	qt_QRangeControl_setRange(qt_QSlider_QRangeControl([self qt]), minValue, maxValue);
	return self;
}


- (int) lineStep
{
	return (int) qt_QRangeControl_lineStep(qt_QSlider_QRangeControl([self qt]));
}


- (int) pageStep
{
	return (int) qt_QRangeControl_pageStep(qt_QSlider_QRangeControl([self qt]));
}


- setLineStep: (int) line pageStep: (int) page
{
	qt_QRangeControl_setSteps(qt_QSlider_QRangeControl([self qt]), line, page);
	return self;
}

@end
