/***************************************************************************
                          QSpinBox.h  -  description
                             -------------------
    begin                : Sun Apr 16 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QSPINBOX_H
#define QSPINBOX_H

#include <Foundation/NSObject.h>
#include <qtobjc/QFrame.h>
#include <qtobjc/QRangeControl.h>

@class QValidator;

/**
  *@author Richard Dale
  */

@interface QSpinBox : QFrame
- initWithParent: (QWidget *) parent name: (NSString *) name;
- initWithMinValue: (int) minValue maxValue: (int) maxValue step: (int) step parent: (QWidget *) parent name: (NSString *) name;
- (void) dealloc;
- (NSString *) text;
- (NSString *) prefix;
- (NSString *) suffix;
- (NSString *) cleanText;
- setSpecialValueText: (NSString *) text;
- (NSString *) specialValueText;
- setWrapping: (BOOL) on;
- (BOOL) wrapping;
- setValidator: (QValidator *) v;
- (QSize *) sizeHint;
- setValue: (int) value;
- setPrefix: (NSString *) text;
- setSuffix: (NSString *) text;
- stepUp;
- stepDown;
@end

@interface QSpinBox (QRangeControlImplementation) <QRangeControlInterface>
@end

#endif
