/***************************************************************************
                          QToolBar.m  -  description
                             -------------------
    begin                : Fri Mar 24 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QToolBar.h>
#include <qtc/qtc.h>

@implementation QToolBar

- initWithLabel: (NSString *) label mainWindow: (QMainWindow *) window toolbarDock: (ToolBarDock) dock newline: (BOOL) newLine name: (NSString *) name
{
	[self setQt: qt_new_QToolBar((char *) [label cString], [window qt], dock, newLine, (char *) [name cString])];
	[super init];	
	return self;
}


- initWithLabel: (NSString *) label mainWindow: (QMainWindow *) window parent: (QWidget *) parent newline: (BOOL) newLine name: (NSString *) name flags: (WFlags) f
{
	[self setQt: qt_new_QToolBar1((char *) [label cString], [window qt], [parent qt], newLine, (char *) [name cString], f)];	
	[super init];	
	return self;
}


- initWithParent: (QMainWindow *) parent name: (NSString *) name
{
	[self setQt: qt_new_QToolBar2([parent qt], (char *) [name cString])];	
	[super init];	
	return self;
}


- (void) dealloc
{
	qt_del_QToolBar([self qt]);	
	[super dealloc];	
	return;
}


- addSeparator
{
	qt_QToolBar_addSeparator([self qt]);
	return self;
}


- setOrientation: (Orientation) orientation
{
	qt_QToolBar_setOrientation([self qt], orientation);
	return self;
}


- show
{
	qt_QToolBar_show([self qt]);
	return self;
}


- (QMainWindow *) mainWindow
{
	return (QMainWindow *) [QObject objectForQtKey: qt_QToolBar_mainWindow([self qt])];
}


- setStretchableWidget: (QWidget *) widget
{
	qt_QToolBar_setStretchableWidget([self qt], [widget qt]);
	return self;
}

@end

