/***************************************************************************
                          QToolButton.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 *************************************#include <Foundation/NSObject.h>
**************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QToolButton.h>
#undef Normal
#include <qtc/qtc.h>

@implementation QToolButton

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QToolButton([parent qt], (char *) [name cString])];	
	return self;
}


- initWithPixmap: (QPixmap *) pm label: (NSString *) textLabel groupText: (NSString *) grouptext receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) slot parent: (QToolBar *) parent
{
	return [self initWithPixmap: pm label: textLabel groupText: grouptext receiver: receiver slot: slot parent: parent name: @""];
}

- initWithPixmap: (QPixmap *) pm label: (NSString *) textLabel groupText: (NSString *) grouptext receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) slot parent: (QToolBar *) parent name: (NSString *) name
{
	qt_Slot *	slotId;
	
	if ([slot hasSuffix: @")"]) {
		[	self setQt: qt_new_QToolButton1(	[pm qt],
											(char *) [textLabel cString],
											(char *) [grouptext cString],
											[receiver qt],
											(char *)[[NSString stringWithFormat: @"1%@", slot] cString],
											[parent qt],
											(char *) [name cString] ) ];	
	} else {
		slotId = (qt_Slot *) [QObject slotIdForReceiver: receiver slot: slot];
		
		[	self setQt: qt_new_QToolButton1(	[pm qt],
											(char *) [textLabel cString],
											(char *) [grouptext cString],
											(qt_QObject *) slotId,
											([slot hasSuffix: @":"]) ? "1UserDataSlot(int)" : "1UserDataSlot()",
											[parent qt],
											(char *) [name cString] ) ];	
	}
	
	return self;
}


- initWithIconSet: (QIconSet *) s label: (NSString *) textLabel groupText: (NSString *) grouptext  receiver: (<QObjectInterface,QtSupport>) receiver slot: (NSString *) slot parent: (QToolBar *) parent name: (NSString *) name
{
	[self setQt: qt_new_QToolButton2([s qt], (char *) [textLabel cString], (char *) [grouptext cString], [receiver qt], (char *) [slot cString], [parent qt], (char *) [name cString])];	
	return self;
}


- (void) dealloc
{
	qt_del_QToolButton([self qt]);	
	[super dealloc];	
	return;
}


- (QSize *) sizeHint
{
	return (QSize *) [QObject objectForQtKey: qt_QToolButton_sizeHint([self qt]) withClass: [QSize class]];
}


- setIconSet: (QIconSet *) iconSet
{
	qt_QToolButton_setIconSet([self qt], [iconSet qt]);
	return self;
}


- (QIconSet *) iconSet
{
	return (QIconSet *) [QObject objectForQtKey: qt_QToolButton_iconSet([self qt]) withClass: [QIconSet class]];
}


- setUsesBigPixmap: (BOOL) enable
{
	qt_QToolButton_setUsesBigPixmap([self qt], enable);
	return self;
}


- setUsesTextLabel: (BOOL) enable
{
	qt_QToolButton_setUsesTextLabel([self qt], enable);
	return self;
}


- setTextLabel: (NSString *) label tipToo: (BOOL) yn
{
	qt_QToolButton_setTextLabel([self qt], (char *) [label cString], yn);
	return self;
}


- setToggleButton: (BOOL) enable
{
	qt_QToolButton_setToggleButton([self qt], enable);
	return self;
}


- setOn: (BOOL) enable
{
	qt_QToolButton_setOn([self qt], enable);
	return self;
}


- toggle
{
	qt_QToolButton_toggle([self qt]);
	return self;
}


@end

