/***************************************************************************
                          QToolTip.h  -  description
                             -------------------
    begin                : Fri Mar 31 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QTOOLTIP_H
#define QTOOLTIP_H

#include <Foundation/NSObject.h>

#include <qtobjc/QObject.h>
#include <qtobjc/QWidget.h>

/**
  *@author Richard Dale
  */

@interface QToolTipGroup : QObject
- initWithParent: (<QtSupport,QObjectInterface>) parent name: (NSString *) name;
- (void) dealloc;
@end

@interface QToolTip : NSObject
{
@private
	void *	_qt;
}
+  add: (QWidget *) widget text: (NSString *) text;
+  add: (QWidget *) widget text: (NSString *) text toolTipGroup: (QToolTipGroup *) group groupText: (NSString *) groupText;
+  remove: (QWidget *) widget;
+  add: (QWidget *) widget rect: (QRect *) rect text: (NSString *) text;
+  add: (QWidget *) widget rect: (QRect *) rect text: (NSString *) text toolTipGroup: (QToolTipGroup *) group groupText: (NSString *) groupText;
+  remove: (QWidget *) widget rect: (QRect *) rect;
+ (QFont *) font;
+ setFont: (QFont *) font;
+ (QPalette *) palette;
+ setPalette: (QPalette *) palette;
- maybeTip: (QPoint *) point;
- tip: (QRect *) rect text: (NSString *) text;
- tip: (QRect *) rect text: (NSString *) text groupText: (NSString *) groupText;
- clear;
@end

#endif
