/***************************************************************************
                          QToolTip.m  -  description
                             -------------------
    begin                : Fri Mar 31 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QToolTip.h>
#include <qtc/qtc.h>

@implementation QToolTipGroup

- initWithParent: (<QtSupport,QObjectInterface>) parent name: (NSString *) name
{
	[self setQt: qt_new_QToolTipGroup([parent qt], (char *) [name cString])];	
	[super init];
	return self;
}


- (void) dealloc
{
	qt_del_QToolTipGroup([self qt]);	
	[super dealloc];	
	return;
}
@end

@implementation QToolTip

- (void *) qt
{
	return _qt;
}

- setQt: (void *) qt
{
	_qt = qt;
	return self;
}


+ add: (QWidget *) widget text: (NSString *) text
{
	qt_QToolTip_add([widget qt], (char *) [text cString]);
	return self;
}


+ add: (QWidget *) widget text: (NSString *) text toolTipGroup: (QToolTipGroup *) group groupText: (NSString *) groupText
{
	qt_QToolTip_add1([widget qt], (char *) [text cString], [group qt], (char *) [groupText cString]);
	return self;
}


+ remove: (QWidget *) widget
{
	qt_QToolTip_remove([widget qt]);
	return self;
}


+ add: (QWidget *) widget rect: (QRect *) rect text: (NSString *) text
{
	qt_QToolTip_add2([widget qt], [rect qt], (char *) [text cString]);
	return self;
}


+ add: (QWidget *) widget rect: (QRect *) rect text: (NSString *) text toolTipGroup: (QToolTipGroup *) group groupText: (NSString *) groupText
{
	qt_QToolTip_add3([widget qt], [rect qt], (char *) [text cString], [group qt], (char *) [groupText cString]);
	return self;
}


+ remove: (QWidget *) widget rect: (QRect *) rect
{
	qt_QToolTip_remove1([widget qt], [rect qt]);
	return self;
}


+ (QFont *) font
{
	return (QFont *) [QObject objectForQtKey: qt_QToolTip_font([self qt]) withClass: [QFont class]];
}


+ setFont: (QFont *) font
{
	qt_QToolTip_setFont([font qt]);
	return self;
}


+ (QPalette *) palette
{
	return (QPalette *) [QObject objectForQtKey: qt_QToolTip_palette([self qt]) withClass: [QPalette class]];
}


+ setPalette: (QPalette *) palette
{
	qt_QToolTip_setPalette([palette qt]);
	return self;
}


- maybeTip: (QPoint *) point
{
//	qt_QToolTip_maybeTip([point qt]);
	return self;
}


- tip: (QRect *) rect text: (NSString *) text
{
//	qt_QToolTip_tip([rect qt], (char *) [text cString]);
	return self;
}


- tip: (QRect *) rect text: (NSString *) text groupText: (NSString *) groupText
{
//	qt_QToolTip_tip([rect qt], (char *) [text cString], (char *) [groupText cString]);
	return self;
}


- clear
{
//	qt_QToolTip_clear([self qt]);
	return self;
}

@end

