/***************************************************************************
                          QValidator.m  -  description
                             -------------------
    begin                : Fri Apr 14 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QValidator.h>
#include <qtc/qtc.h>

@implementation QValidator

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QValidator([parent qt], (char *) [name cString])];
	[super init];	
	return self;
}


- (void) dealloc
{
	qt_del_QValidator([self qt]);	
	[super dealloc];	
	return;
}


- (State) validate: (NSString *) input position: (int) position
{
	return (State) qt_QValidator_validate([self qt], qt_new_QString3((char *) [input cString]), position);
}


- fixup: (NSString *) input
{
	qt_QValidator_fixup([self qt], qt_new_QString3((char *) [input cString]));
	return self;
}

@end

@implementation QIntValidator

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QIntValidator([parent qt], (char *) [name cString])];
	[super init];	
	return self;
}


- initWithRangeMinValue: (int) bottom maxValue: (int) top parent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QIntValidator1(bottom, top, [parent qt], (char *) [name cString])];	
	return self;
}


- (void) dealloc
{
	qt_del_QIntValidator([self qt]);	
	[super dealloc];	
	return;
}


- (State) validate: (NSString *) input position: (int) position
{
	return (State) qt_QIntValidator_validate([self qt], qt_new_QString3((char *) [input cString]), position);
}


- setRangeMinValue: (int) bottom maxValue: (int) top
{
	qt_QIntValidator_setRange([self qt], bottom, top);
	return self;
}

@end

@implementation QDoubleValidator

- initWithParent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QDoubleValidator([parent qt], (char *) [name cString])];
	[super init];	
	return self;
}


- initWithRangeMinValue: (double) bottom maxValue: (int) top decimals: (int) decimals parent: (QWidget *) parent name: (NSString *) name
{
	[self setQt: qt_new_QDoubleValidator1(bottom, top, decimals, [parent qt], (char *) [name cString])];	
	return self;
}


- (void) dealloc
{
	qt_del_QDoubleValidator([self qt]);	
	[super dealloc];	
	return;
}


- (State) validate: (NSString *) input position: (int) position
{
	return (State) qt_QDoubleValidator_validate([self qt], qt_new_QString3((char *) [input cString]), position);
}


- setDoubleRangeMinValue: (double) bottom maxValue: (double) top decimals: (int) decimals
{
	qt_QDoubleValidator_setRange([self qt], bottom, top, decimals);
	return self;
}

@end
