/***************************************************************************
                          QWMatrix.h  -  description
                             -------------------
    begin                : Sun Mar 12 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QWMATRIX_H
#define QWMATRIX_H

#include <Foundation/NSObject.h>
#include <Foundation/NSArray.h>

#include <qtobjc/QPoint.h>
#include <qtobjc/QRect.h>
#include <qtobjc/QObject.h>

/**
  *@author Richard Dale
  */

@interface QWMatrix : NSObject <QtSupport>
- init;
- init: (float) m11 : (float) m12 : (float) m21 : (float) m22 dx: (float) dx dy: (float) dy;
- setMatrix: (float) m11 : (float) m12 : (float) m21 : (float) m22 dx: (float) dx dy: (float) dy;
- mapInt: (int) x : (int) y : (int *) tx : (int *) ty;
- mapFloat: (float) x : (float) y : (float *) tx : (float *) ty;
- (QPoint *) mapPoint: (QPoint *) map;
- (QRect *) mapRect: (QRect *) map;
- (NSArray *) mapArray: (NSArray *) array;
- reset;
- translate: (float) dx : (float) dy;
- scale: (float) sx : (float) sy;
- shear: (float) sh : (float) sv;
- rotate: (float) a;
- invert: (BOOL) yn;
@end

#endif
