/***************************************************************************
                          QWhatsThis.m  -  description
                             -------------------
    begin                : Sat Mar 25 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qtobjc/QtSupport.h>
#include <qtobjc/QWhatsThis.h>

#undef Normal
#include <qtc/qtc.h>

@implementation QWhatsThis

+ add: (QWidget *) widget text: (NSString *) text
{
	return [self add: widget text: text deepCopy: YES];
}

+ add: (QWidget *) widget text: (NSString *) text deepCopy: (BOOL) deepCopy
{
	qt_QWhatsThis_add([widget qt], (char *) [text cString], deepCopy);
	return self;
}


+ add: (QWidget *) widget icon: (QPixmap *) icon title: (NSString *) title text: (NSString *) text
{
	return [self add: widget icon: icon title: title text: text deepCopy: YES];
}

+ add: (QWidget *) widget icon: (QPixmap *) icon title: (NSString *) title text: (NSString *) text deepCopy: (BOOL) deepCopy
{
	qt_QWhatsThis_add1([widget qt], [icon qt], (char *) [title cString], (char *) [text cString], deepCopy);
	return self;
}


+ remove: (QWidget *) widget
{
	qt_QWhatsThis_remove([widget qt]);
	return self;
}


+ (NSString *) textFor: (QWidget *) widget
{
	return (NSString *) [NSString stringWithCString: qt_QWhatsThis_textFor([widget qt])];
}


+ (QToolButton *) whatsThisButton: (QWidget *) parent
{
	return (QToolButton *) [QObject objectForQtKey: qt_QWhatsThis_whatsThisButton([parent qt]) withClass: [QToolButton class]];
}
@end

