/***************************************************************************
                          QtSupport.h  -  description
                             -------------------
    begin                : Wed Mar 29 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QTSUPPORT_H
#define QTSUPPORT_H

#include <Foundation/NSObject.h>

/**
  *@author Richard Dale
  */

/**
* An interface for getting and setting an instance variable
* '_qt', which holds a pointer to a C++ instance being wrapped.
* The pointer can be passed to QtC library function calls. For
* example, 'qt_QObject_dumpObjectTree([self qt])'.
*
* @short An interface for getting and setting '_qt', holding a Qt C++ pointer.
*/
@protocol QtSupport
/** Return a pointer to a C++ instance for use with QtC library function calls */
- (void *) qt;
/**
  * Set the '_qt' instance variable to a pointer to a C++ instance. This should
  * be called in the initialization method for the class.
  */
- setQt: (void *) qt;
@end

#endif
