/***************************************************************************
                          qwindowdefs.h  -  description
                             -------------------
    begin                : Fri Mar 3 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef QWINDOWDEFS_H
#define QWINDOWDEFS_H

#define HANDLE	void *
#define WFlags	uint
#define WId		void *
#define GUIStyle	int

/**
  *@author Richard Dale
  */

@class QPixmap;
@class QFocusData;

#define WindowsStyle			1
#define MotifStyle			4

#define WState_Created        0x00000001   // widget state flags
#define WState_Disabled       0x00000002
#define WState_Visible        0x00000004
#define WState_DoHide         0x00000008
#define WState_ClickToFocus   0x00000010
#define WState_TrackMouse     0x00000020
#define WState_BlockUpdates   0x00000040
#define WState_PaintEvent     0x00000080

#define WType_TopLevel        0x00000100   // widget type flags
#define WType_Modal           0x00000200
#define WType_Popup           0x00000400
#define WType_Desktop         0x00000800

#define WStyle_Customize      0x00001000   // window style flags
#define WStyle_NormalBorder   0x00002000
#define WStyle_DialogBorder   0x00004000
#define WStyle_NoBorder       0x00000000
#define WStyle_Title          0x00008000
#define WStyle_SysMenu        0x00010000
#define WStyle_Minimize       0x00020000
#define WStyle_Maximize       0x00040000
#define WStyle_MinMax         WStyle_Minimize | WStyle_Maximize
#define WStyle_Tool           0x00080000
#define WStyle_Mask           0x000ff000

#define WCursorSet            0x00100000   // misc widget flags
#define WDestructiveClose     0x00200000
#define WPaintDesktop         0x00400000
#define WPaintUnclipped       0x00800000
#define WPaintClever          0x01000000
#define WConfigPending        0x02000000
#define WResizeNoErase        0x04000000
#define WRecreated            0x08000000
#define WExportFontMetrics    0x10000000
#define WExportFontInfo       0x20000000
#define WFocusSet             0x40000000   // not used any more
#define WState_TabToFocus     0x80000000

//	RasterOp
// raster op/transfer mode
#define RasterOp				int
#define CopyROP				0
#define OrROP				1
#define XorROP				2
#define EraseROP				3
#define NotCopyROP			4
#define NotOrROP				5
#define NotXorROP				6
#define NotEraseROP			7
#define NotROP   				8


// Text formatting flags for QPainter::drawText and QLabel

#define AlignLeft      		0x0001               // text alignment
#define AlignRight     		0x0002
#define AlignHCenter   		0x0004
#define AlignTop       		0x0008
#define AlignBottom    		0x0010
#define AlignVCenter   		0x0020
#define AlignCenter   		AlignVCenter | AlignHCenter

#define SingleLine     		0x0040              // misc. flags
#define DontClip       		0x0080
#define ExpandTabs     		0x0100
#define ShowPrefix     		0x0200
#define WordBreak     		0x0400
#define GrayText      		0x0800
#define DontPrint      		0x1000               // internal


// Image conversion flags

// The unusual ordering is caused by compatibility and default requirements.

#define ColorMode_Mask          0x00000003
#define AutoColor               0x00000000
#define ColorOnly               0x00000003
#define MonoOnly                0x00000002
//        Reserved                0x00000001;
#define AlphaDither_Mask        0x0000000c
#define ThresholdAlphaDither    0x00000000
#define OrderedAlphaDither      0x00000004
#define DiffuseAlphaDither      0x00000008
//        ReservedAlphaDither     0x0000000c;
#define Dither_Mask             0x00000030
#define DiffuseDither           0x00000000
#define OrderedDither           0x00000010
#define ThresholdDither         0x00000020
//        ReservedDither          0x00000030;
#define DitherMode_Mask         0x000000c0
#define AutoDither              0x00000000
#define PreferDither            0x00000040
#define AvoidDither             0x00000080

#define QCOORD				short

#endif