/***************************************************************************
                          main.m  -  description
                             -------------------
    begin                : Fri Mar 17 15:04:11 EST 2000
    copyright            : (C) 2000 by Richard Dale
    email                : Richard_Dale@tipitina.demon.co.uk
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <Foundation/NSString.h>
#include <Foundation/NSAutoreleasePool.h>

#include <qtobjc/QApplication.h>
#include <qtobjc/QSlider.h>
#include <qtobjc/QLCDNumber.h>

/*
 * 'Programming with Qt' Example 2-3 page 26
 */
int main(int argc, char *argv[])
{
	NSAutoreleasePool *	pool;
	QApplication *		myapp;
	QWidget *			mywidget;
	QSlider *			myslider;
	QLCDNumber *			mylcdnum;
	
	pool = [[NSAutoreleasePool alloc] init];
	
	myapp = [[QApplication alloc] initWithArgc: argc argv: argv];
	
	mywidget = [[QWidget alloc] init];
	[mywidget setGeometry: 400 : 300 : 170 : 110];
	
	myslider = [[QSlider alloc] initWithMinValue: 0 maxValue: 9 step: 1 initial: 1 orientation: Horizontal parent: mywidget];
	[myslider setGeometry: 10 : 10 : 150 : 30];
	
	mylcdnum = [[QLCDNumber alloc] initWithDigits: 1 parent: mywidget];
	[mylcdnum setGeometry: 60 : 50 : 50 : 50];
	[mylcdnum displayInt: 1];
	
	[	QObject	connect: myslider signal: @"sliderMoved(int)"
				receiver: mylcdnum slot: @"display(int)" ];
	
	[myapp setMainWidget: mywidget];
	[mywidget show];
	
	return [myapp exec];
}
