/**********************************/
/* This file is part of QtC 0.0.2 */
/* (c) 1997 Roberto Alsina        */
/* Licensed under the GPL v2      */
/* Read file COPYING for details  */
/**********************************/
#ifndef QT_QSTRING
#define QT_QSTRING
#include <qstring.h>
extern "C" {
#include "qt_proto_destructor.h"
qt_QString *qt_new_QString();
qt_QString *qt_new_QString1(int size);
qt_QString *qt_new_QString2(qt_QString * s);
qt_QString *qt_new_QString3(char* str);
qt_QString *qt_new_QString4(char* str,unsigned int maxlen);
int qt_QString_isNull( qt_QString *instPointer);
int qt_QString_isEmpty( qt_QString *instPointer);
unsigned int qt_QString_length( qt_QString *instPointer);
int qt_QString_resize( qt_QString *instPointer,unsigned int newlen);
int qt_QString_truncate( qt_QString *instPointer,unsigned int pos);
int qt_QString_fill( qt_QString *instPointer,char c,int len);
qt_QString * qt_QString_copy( qt_QString *instPointer);


/**************************************/
/*This function didn't wrap*/
/*qt_QString * qt_QString_sprintf( qt_QString *instPointer,char* format,XXX arg1);*/
/**/

int qt_QString_find( qt_QString *instPointer,char c,int index,int cs);
int qt_QString_find1( qt_QString *instPointer,char* str,int index,int cs);
int qt_QString_find2( qt_QString *instPointer,qt_QRegExp * arg1,int index);
int qt_QString_findRev( qt_QString *instPointer,char c,int index,int cs);
int qt_QString_findRev1( qt_QString *instPointer,char* str,int index,int cs);
int qt_QString_findRev2( qt_QString *instPointer,qt_QRegExp * arg1,int index);
int qt_QString_contains( qt_QString *instPointer,char c,int cs);
int qt_QString_contains1( qt_QString *instPointer,char* str,int cs);
int qt_QString_contains2( qt_QString *instPointer,qt_QRegExp * arg1);
qt_QString * qt_QString_left( qt_QString *instPointer,unsigned int len);
qt_QString * qt_QString_right( qt_QString *instPointer,unsigned int len);
qt_QString * qt_QString_mid( qt_QString *instPointer,unsigned int index,unsigned int len);
qt_QString * qt_QString_leftJustify( qt_QString *instPointer,unsigned int width,char fill,int trunc);
qt_QString * qt_QString_rightJustify( qt_QString *instPointer,unsigned int width,char fill,int trunc);
qt_QString * qt_QString_lower( qt_QString *instPointer);
qt_QString * qt_QString_upper( qt_QString *instPointer);
qt_QString * qt_QString_stripWhiteSpace( qt_QString *instPointer);
qt_QString * qt_QString_simplifyWhiteSpace( qt_QString *instPointer);
qt_QString * qt_QString_insert( qt_QString *instPointer,unsigned int index,char* arg1);
qt_QString * qt_QString_insert1( qt_QString *instPointer,unsigned int index,char arg1);
qt_QString * qt_QString_append( qt_QString *instPointer,char* arg1);
qt_QString * qt_QString_prepend( qt_QString *instPointer,char* arg1);
qt_QString * qt_QString_remove( qt_QString *instPointer,unsigned int index,unsigned int len);
qt_QString * qt_QString_replace( qt_QString *instPointer,unsigned int index,unsigned int len,char* arg1);
qt_QString * qt_QString_replace1( qt_QString *instPointer,qt_QRegExp * arg1,char* arg2);
short int qt_QString_toShort( qt_QString *instPointer,int* ok);
unsigned short int qt_QString_toUShort( qt_QString *instPointer,int* ok);
int qt_QString_toInt( qt_QString *instPointer,int* ok);
unsigned int qt_QString_toUInt( qt_QString *instPointer,int* ok);
long qt_QString_toLong( qt_QString *instPointer,int* ok);
unsigned long qt_QString_toULong( qt_QString *instPointer,int* ok);
float qt_QString_toFloat( qt_QString *instPointer,int* ok);
double qt_QString_toDouble( qt_QString *instPointer,int* ok);
qt_QString * qt_QString_setStr( qt_QString *instPointer,char* s);
qt_QString * qt_QString_setNum( qt_QString *instPointer,short int arg1);
qt_QString * qt_QString_setNum1( qt_QString *instPointer,unsigned short int arg1);
qt_QString * qt_QString_setNum2( qt_QString *instPointer,int arg1);
qt_QString * qt_QString_setNum3( qt_QString *instPointer,unsigned int arg1);
qt_QString * qt_QString_setNum4( qt_QString *instPointer,long arg1);
qt_QString * qt_QString_setNum5( qt_QString *instPointer,unsigned long arg1);
qt_QString * qt_QString_setNum6( qt_QString *instPointer,float arg1,char f,int prec);
qt_QString * qt_QString_setNum7( qt_QString *instPointer,double arg1,char f,int prec);
int qt_QString_setExpand( qt_QString *instPointer,unsigned int index,char c);
char *qt_QString_data(qt_QString *s);

}
#endif