/**********************************/
/* This file is part of QtC 0.0.2 */
/* (c) 1997 Roberto Alsina        */
/* Licensed under the GPL v2      */
/* Read file COPYING for details  */
/**********************************/
#ifndef QT_QWIDGET
#define QT_QWIDGET
#include <qwidget.h>
extern "C" {
#include "qt_proto_destructor.h"

qt_QWidget *qt_new_QWidget(qt_QWidget * parent,char* name,uint f);

void qt_QWidget_registerEventDelegate(qt_QWidget_EventDelegate delegate);
extern qt_QWidget_EventDelegate Qt_QWidget_EventDelegate;

qt_QPaintDevice * qt_QWidget_QPaintDevice(qt_QWidget *instPointer);
uint qt_QWidget_winId( qt_QWidget *instPointer);
int qt_QWidget_style( qt_QWidget *instPointer);
void qt_QWidget_setStyle( qt_QWidget *instPointer,int arg1);
int qt_QWidget_isTopLevel( qt_QWidget *instPointer);
int qt_QWidget_isModal( qt_QWidget *instPointer);
int qt_QWidget_isPopup( qt_QWidget *instPointer);
int qt_QWidget_isDesktop( qt_QWidget *instPointer);
int qt_QWidget_isEnabled( qt_QWidget *instPointer);
void qt_QWidget_setEnabled( qt_QWidget *instPointer,int arg1);
qt_QRect * qt_QWidget_frameGeometry( qt_QWidget *instPointer);
qt_QRect * qt_QWidget_geometry( qt_QWidget *instPointer);
int qt_QWidget_x( qt_QWidget *instPointer);
int qt_QWidget_y( qt_QWidget *instPointer);
qt_QPoint * qt_QWidget_pos( qt_QWidget *instPointer);
qt_QSize * qt_QWidget_size( qt_QWidget *instPointer);
int qt_QWidget_width( qt_QWidget *instPointer);
int qt_QWidget_height( qt_QWidget *instPointer);
qt_QRect * qt_QWidget_rect( qt_QWidget *instPointer);
qt_QRect * qt_QWidget_childrenRect( qt_QWidget *instPointer);
qt_QSize * qt_QWidget_minimumSize( qt_QWidget *instPointer);
qt_QSize * qt_QWidget_maximumSize( qt_QWidget *instPointer);
void qt_QWidget_setMinimumSize( qt_QWidget *instPointer,qt_QSize * arg1);
void qt_QWidget_setMinimumSize1( qt_QWidget *instPointer,int w,int h);
void qt_QWidget_setMaximumSize( qt_QWidget *instPointer,qt_QSize * arg1);
void qt_QWidget_setMaximumSize1( qt_QWidget *instPointer,int w,int h);
void qt_QWidget_setMinimumWidth( qt_QWidget *instPointer,int w);
void qt_QWidget_setMinimumHeight( qt_QWidget *instPointer,int h);
void qt_QWidget_setMaximumWidth( qt_QWidget *instPointer,int w);
void qt_QWidget_setMaximumHeight( qt_QWidget *instPointer,int h);
qt_QSize * qt_QWidget_sizeIncrement( qt_QWidget *instPointer);
void qt_QWidget_setSizeIncrement( qt_QWidget *instPointer,qt_QSize * arg1);
void qt_QWidget_setSizeIncrement1( qt_QWidget *instPointer,int w,int h);
void qt_QWidget_setFixedSize( qt_QWidget *instPointer,qt_QSize * arg1);
void qt_QWidget_setFixedSize1( qt_QWidget *instPointer,int w,int h);
void qt_QWidget_setFixedWidth( qt_QWidget *instPointer,int w);
void qt_QWidget_setFixedHeight( qt_QWidget *instPointer,int h);
qt_QPoint * qt_QWidget_mapToGlobal( qt_QWidget *instPointer,qt_QPoint * arg1);
qt_QPoint * qt_QWidget_mapFromGlobal( qt_QWidget *instPointer,qt_QPoint * arg1);
qt_QPoint * qt_QWidget_mapToParent( qt_QWidget *instPointer,qt_QPoint * arg1);
qt_QPoint * qt_QWidget_mapFromParent( qt_QWidget *instPointer,qt_QPoint * arg1);
qt_QWidget * qt_QWidget_topLevelWidget( qt_QWidget *instPointer);


enum { FixedColor, FixedPixmap, NoBackground,PaletteForeground, PaletteBackground, PaletteLight,PaletteMidlight, PaletteDark, PaletteMid,PaletteText, PaletteBase };

int qt_QWidget_backgroundMode( qt_QWidget *instPointer);
void qt_QWidget_setBackgroundMode( qt_QWidget *instPointer,int arg1);
qt_QColor * qt_QWidget_backgroundColor( qt_QWidget *instPointer);
qt_QColor * qt_QWidget_foregroundColor( qt_QWidget *instPointer);
void qt_QWidget_setBackgroundColor( qt_QWidget *instPointer,qt_QColor * arg1);
qt_QPixmap * qt_QWidget_backgroundPixmap( qt_QWidget *instPointer);
void qt_QWidget_setBackgroundPixmap( qt_QWidget *instPointer,qt_QPixmap * arg1);
qt_QColorGroup * qt_QWidget_colorGroup( qt_QWidget *instPointer);
qt_QPalette * qt_QWidget_palette( qt_QWidget *instPointer);
void qt_QWidget_setPalette( qt_QWidget *instPointer,qt_QPalette * arg1);
qt_QFont * qt_QWidget_font( qt_QWidget *instPointer);
void qt_QWidget_setFont( qt_QWidget *instPointer,qt_QFont * arg1);
qt_QFontMetrics * qt_QWidget_fontMetrics( qt_QWidget *instPointer);
qt_QFontInfo * qt_QWidget_fontInfo( qt_QWidget *instPointer);
qt_QCursor * qt_QWidget_cursor( qt_QWidget *instPointer);
void qt_QWidget_setCursor( qt_QWidget *instPointer,qt_QCursor * arg1);
char* qt_QWidget_caption( qt_QWidget *instPointer);
void qt_QWidget_setCaption( qt_QWidget *instPointer,char* arg1);
qt_QPixmap * qt_QWidget_icon( qt_QWidget *instPointer);
void qt_QWidget_setIcon( qt_QWidget *instPointer,qt_QPixmap * arg1);
char* qt_QWidget_iconText( qt_QWidget *instPointer);
void qt_QWidget_setIconText( qt_QWidget *instPointer,char* arg1);
int qt_QWidget_hasMouseTracking( qt_QWidget *instPointer);
void qt_QWidget_setMouseTracking( qt_QWidget *instPointer,int enable);


enum { NoFocus = 0, TabFocus = 0x1, ClickFocus = 0x2, StrongFocus = 0x3 };

int qt_QWidget_isActiveWindow( qt_QWidget *instPointer);
void qt_QWidget_setActiveWindow( qt_QWidget *instPointer);
int qt_QWidget_isFocusEnabled( qt_QWidget *instPointer);
int qt_QWidget_focusPolicy( qt_QWidget *instPointer);
void qt_QWidget_setFocusPolicy( qt_QWidget *instPointer,int arg1);
int qt_QWidget_hasFocus( qt_QWidget *instPointer);
void qt_QWidget_setFocus( qt_QWidget *instPointer);
void qt_QWidget_clearFocus( qt_QWidget *instPointer);
void qt_QWidget_setTabOrder( qt_QWidget * arg1,qt_QWidget * arg2);
void qt_QWidget_setFocusProxy( qt_QWidget *instPointer,qt_QWidget * arg1);
qt_QWidget * qt_QWidget_focusProxy( qt_QWidget *instPointer);
void qt_QWidget_grabMouse( qt_QWidget *instPointer);
void qt_QWidget_grabMouse1( qt_QWidget *instPointer,qt_QCursor * arg1);
void qt_QWidget_releaseMouse( qt_QWidget *instPointer);
void qt_QWidget_grabKeyboard( qt_QWidget *instPointer);
void qt_QWidget_releaseKeyboard( qt_QWidget *instPointer);
qt_QWidget * qt_QWidget_mouseGrabber();
qt_QWidget * qt_QWidget_keyboardGrabber();
int qt_QWidget_isUpdatesEnabled( qt_QWidget *instPointer);
void qt_QWidget_setUpdatesEnabled( qt_QWidget *instPointer,int enable);
void qt_QWidget_update( qt_QWidget *instPointer);
void qt_QWidget_update1( qt_QWidget *instPointer,int x,int y,int w,int h);
void qt_QWidget_update2( qt_QWidget *instPointer,qt_QRect * arg1);
void qt_QWidget_repaint( qt_QWidget *instPointer,int erase);
void qt_QWidget_repaint1( qt_QWidget *instPointer,int x,int y,int w,int h,int erase);
void qt_QWidget_repaint2( qt_QWidget *instPointer,qt_QRect * arg1,int erase);
void qt_QWidget_show( qt_QWidget *instPointer);
void qt_QWidget_hide( qt_QWidget *instPointer);
void qt_QWidget_iconify( qt_QWidget *instPointer);
int qt_QWidget_close( qt_QWidget *instPointer,int forceKill);
int qt_QWidget_isVisible( qt_QWidget *instPointer);
int qt_QWidget_isVisibleToTLW( qt_QWidget *instPointer);
void qt_QWidget_raise( qt_QWidget *instPointer);
void qt_QWidget_lower( qt_QWidget *instPointer);
void qt_QWidget_move( qt_QWidget *instPointer,int x,int y);
void qt_QWidget_move1( qt_QWidget *instPointer,qt_QPoint * arg1);
void qt_QWidget_resize( qt_QWidget *instPointer,int w,int h);
void qt_QWidget_resize1( qt_QWidget *instPointer,qt_QSize * arg1);
void qt_QWidget_setGeometry( qt_QWidget *instPointer,int x,int y,int w,int h);
void qt_QWidget_setGeometry1( qt_QWidget *instPointer,qt_QRect * arg1);
qt_QSize * qt_QWidget_sizeHint( qt_QWidget *instPointer);
void qt_QWidget_adjustSize( qt_QWidget *instPointer);
void qt_QWidget_recreate( qt_QWidget *instPointer,qt_QWidget * parent,uint arg1,qt_QPoint * arg2,int showIt);
void qt_QWidget_erase( qt_QWidget *instPointer);
void qt_QWidget_erase1( qt_QWidget *instPointer,int x,int y,int w,int h);
void qt_QWidget_erase2( qt_QWidget *instPointer,qt_QRect * arg1);
void qt_QWidget_scroll( qt_QWidget *instPointer,int dx,int dy);
void qt_QWidget_drawText( qt_QWidget *instPointer,int x,int y,char* arg1);
void qt_QWidget_drawText1( qt_QWidget *instPointer,qt_QPoint * arg1,char* arg2);
qt_QWidget * qt_QWidget_focusWidget( qt_QWidget *instPointer);
qt_QWidget * qt_QWidget_parentWidget( qt_QWidget *instPointer);
int qt_QWidget_testWFlags( qt_QWidget *instPointer,uint n);
qt_QWidget * qt_QWidget_find( uint arg1);


/**************************************/
/*This function didn't wrap*/
/*XXX qt_QWidget_wmapper();*/
/**/


}
#endif