/**********************************/
/* This file is part of QtC 0.0.2 */
/* (c) 1997 Roberto Alsina        */
/* Licensed under the GPL v2      */
/* Read file COPYING for details  */
/**********************************/
#ifndef QT_QMESSAGEBOX_PROTO
#define QT_QMESSAGEBOX_PROTO
#include "qtc_types.h"

#define Icon				int
#define NoIcon			0
#define Information		1
#define Warning			2
#define Critical			3

#define Ok				1
#define Cancel			2
#define Yes				3
#define No				4
#define Abort			5
#define Retry			6
#define ButtonMask		0x07
#undef Default
#define Default			0x100
#define Escape			0x200
#define FlagMask			0x300


qt_QMessageBox *qt_new_QMessageBox(qt_QWidget * parent,char* name);
qt_QMessageBox *qt_new_QMessageBox1(char* caption,char* text,int icon,int button0,int button1,int button2,qt_QWidget * parent,char* name,int modal,uint f);


int qt_QMessageBox_information( qt_QWidget * parent,char* caption,char* text,int button0,int button1,int button2);
int qt_QMessageBox_information1( qt_QWidget * parent,char* caption,char* text,char* button0Text,char* button1Text,char* button2Text,int defaultButtonNumber,int escapeButtonNumber);
int qt_QMessageBox_warning( qt_QWidget * parent,char* caption,char* text,int button0,int button1,int button2);
int qt_QMessageBox_warning1( qt_QWidget * parent,char* caption,char* text,char* button0Text,char* button1Text,char* button2Text,int defaultButtonNumber,int escapeButtonNumber);
int qt_QMessageBox_critical( qt_QWidget * parent,char* caption,char* text,int button0,int button1,int button2);
int qt_QMessageBox_critical1( qt_QWidget * parent,char* caption,char* text,char* button0Text,char* button1Text,char* button2Text,int defaultButtonNumber,int escapeButtonNumber);
void qt_QMessageBox_about( qt_QWidget * parent,char* caption,char* text);
void qt_QMessageBox_aboutQt( qt_QWidget * parent,char* caption);
char* qt_QMessageBox_text( qt_QMessageBox *instPointer);
void qt_QMessageBox_setText( qt_QMessageBox *instPointer,char* arg1);
int qt_QMessageBox_icon( qt_QMessageBox *instPointer);
void qt_QMessageBox_setIcon( qt_QMessageBox *instPointer,int arg1);
qt_QPixmap * qt_QMessageBox_iconPixmap( qt_QMessageBox *instPointer);
void qt_QMessageBox_setIconPixmap( qt_QMessageBox *instPointer,qt_QPixmap * arg1);
char* qt_QMessageBox_buttonText( qt_QMessageBox *instPointer,int button);
void qt_QMessageBox_setButtonText( qt_QMessageBox *instPointer,int button,char* arg1);
void qt_QMessageBox_adjustSize( qt_QMessageBox *instPointer);
void qt_QMessageBox_setStyle( qt_QMessageBox *instPointer,int arg1);
qt_QPixmap * qt_QMessageBox_standardIcon( int icon,int style);

#endif