class QSpinBox : public QFrame, public QRangeControl
public:
    QSpinBox( QWidget* parent = 0, const char* name = 0 );
    QSpinBox( int minValue, int maxValue, int step = 1, QWidget* parent = 0, const char* name = 0 );

    const char* 	text() const;
    virtual const char*	prefix() const;
    virtual const char*	suffix() const;
    virtual QString 	cleanText() const;

    void		setSpecialValueText( const char* text );
    const char* 	specialValueText() const;

    void  setWrapping( bool on );
    bool  wrapping() const;

    void		setValidator( QValidator* v );

    QSize  sizeHint() const;

public slots:
    virtual void	setValue( int value );
    virtual void	setPrefix( const char* text );
    virtual void	setSuffix( const char* text );
    virtual void	stepUp();
    virtual void	stepDown();

